/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_CLOWNFISH_BLOB
#define H_CLOWNFISH_BLOB 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_BLOB
extern uint32_t cfish_Blob_IVARS_OFFSET;
typedef struct cfish_BlobIVARS cfish_BlobIVARS;
static CFISH_INLINE cfish_BlobIVARS*
cfish_Blob_IVARS(cfish_Blob *self) {
   char *ptr = (char*)self + cfish_Blob_IVARS_OFFSET;
   return (cfish_BlobIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define BlobIVARS cfish_BlobIVARS
  #define Blob_IVARS cfish_Blob_IVARS
#endif

struct cfish_Blob {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    const char* buf;
    size_t size;
    bool owns_buf;
};

#endif /* C_CFISH_BLOB */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_Blob*
cfish_Blob_new(const void* bytes, size_t size);

CFISH_VISIBLE cfish_Blob*
cfish_Blob_init(cfish_Blob* self, const void* bytes, size_t size);

CFISH_VISIBLE cfish_Blob*
cfish_Blob_new_steal(void* bytes, size_t size);

CFISH_VISIBLE cfish_Blob*
cfish_Blob_init_steal(cfish_Blob* self, void* bytes, size_t size);

CFISH_VISIBLE cfish_Blob*
cfish_Blob_new_wrap(const void* bytes, size_t size);

CFISH_VISIBLE cfish_Blob*
cfish_Blob_init_wrap(cfish_Blob* self, const void* bytes, size_t size);

void*
CFISH_Blob_To_Host_IMP(cfish_Blob* self, void* vcache);

size_t
CFISH_Blob_Get_Size_IMP(cfish_Blob* self);

const char*
CFISH_Blob_Get_Buf_IMP(cfish_Blob* self);

bool
CFISH_Blob_Equals_IMP(cfish_Blob* self, cfish_Obj* other);

bool
CFISH_Blob_Equals_Bytes_IMP(cfish_Blob* self, const void* bytes, size_t size);

int32_t
CFISH_Blob_Compare_To_IMP(cfish_Blob* self, cfish_Obj* other);

cfish_Blob*
CFISH_Blob_Clone_IMP(cfish_Blob* self);

void
CFISH_Blob_Destroy_IMP(cfish_Blob* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*CFISH_Blob_To_Host_t)(cfish_Blob* self, void* vcache);

typedef cfish_Blob*
(*CFISH_Blob_Clone_t)(cfish_Blob* self);

typedef bool
(*CFISH_Blob_Equals_t)(cfish_Blob* self, cfish_Obj* other);

typedef int32_t
(*CFISH_Blob_Compare_To_t)(cfish_Blob* self, cfish_Obj* other);

typedef void
(*CFISH_Blob_Destroy_t)(cfish_Blob* self);

typedef cfish_String*
(*CFISH_Blob_To_String_t)(cfish_Blob* self);

typedef size_t
(*CFISH_Blob_Get_Size_t)(cfish_Blob* self);

typedef const char*
(*CFISH_Blob_Get_Buf_t)(cfish_Blob* self);

typedef bool
(*CFISH_Blob_Equals_Bytes_t)(cfish_Blob* self, const void* bytes, size_t size);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
cfish_Blob_get_class(cfish_Blob *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
cfish_Blob_get_class_name(cfish_Blob *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
cfish_Blob_is_a(cfish_Blob *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE uint32_t CFISH_Blob_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_Blob_To_Host(cfish_Blob* self, void* vcache) {
#ifdef CFP_CFISH
    return CFISH_Blob_To_Host_IMP(self, vcache);
#else
    const CFISH_Blob_To_Host_t method = (CFISH_Blob_To_Host_t)cfish_obj_method(self, CFISH_Blob_To_Host_OFFSET);
    return method(self, vcache);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Clone_OFFSET;
static CFISH_INLINE cfish_Blob*
CFISH_Blob_Clone(cfish_Blob* self) {
#ifdef CFP_CFISH
    return CFISH_Blob_Clone_IMP(self);
#else
    const CFISH_Blob_Clone_t method = (CFISH_Blob_Clone_t)cfish_obj_method(self, CFISH_Blob_Clone_OFFSET);
    return method(self);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_Blob_Equals(cfish_Blob* self, cfish_Obj* other) {
#ifdef CFP_CFISH
    return CFISH_Blob_Equals_IMP(self, other);
#else
    const CFISH_Blob_Equals_t method = (CFISH_Blob_Equals_t)cfish_obj_method(self, CFISH_Blob_Equals_OFFSET);
    return method(self, other);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_Blob_Compare_To(cfish_Blob* self, cfish_Obj* other) {
#ifdef CFP_CFISH
    return CFISH_Blob_Compare_To_IMP(self, other);
#else
    const CFISH_Blob_Compare_To_t method = (CFISH_Blob_Compare_To_t)cfish_obj_method(self, CFISH_Blob_Compare_To_OFFSET);
    return method(self, other);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_Blob_Destroy(cfish_Blob* self) {
#ifdef CFP_CFISH
    CFISH_Blob_Destroy_IMP(self);
#else
    const CFISH_Blob_Destroy_t method = (CFISH_Blob_Destroy_t)cfish_obj_method(self, CFISH_Blob_Destroy_OFFSET);
    method(self);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Blob_To_String(cfish_Blob* self) {
#ifdef CFP_CFISH
    return CFISH_Obj_To_String_IMP((cfish_Obj*)self);
#else
    const CFISH_Blob_To_String_t method = (CFISH_Blob_To_String_t)cfish_obj_method(self, CFISH_Blob_To_String_OFFSET);
    return method(self);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Get_Size_OFFSET;
static CFISH_INLINE size_t
CFISH_Blob_Get_Size(cfish_Blob* self) {
#ifdef CFP_CFISH
    return CFISH_Blob_Get_Size_IMP(self);
#else
    const CFISH_Blob_Get_Size_t method = (CFISH_Blob_Get_Size_t)cfish_obj_method(self, CFISH_Blob_Get_Size_OFFSET);
    return method(self);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Get_Buf_OFFSET;
static CFISH_INLINE const char*
CFISH_Blob_Get_Buf(cfish_Blob* self) {
#ifdef CFP_CFISH
    return CFISH_Blob_Get_Buf_IMP(self);
#else
    const CFISH_Blob_Get_Buf_t method = (CFISH_Blob_Get_Buf_t)cfish_obj_method(self, CFISH_Blob_Get_Buf_OFFSET);
    return method(self);
#endif
}

extern CFISH_VISIBLE uint32_t CFISH_Blob_Equals_Bytes_OFFSET;
static CFISH_INLINE bool
CFISH_Blob_Equals_Bytes(cfish_Blob* self, const void* bytes, size_t size) {
#ifdef CFP_CFISH
    return CFISH_Blob_Equals_Bytes_IMP(self, bytes, size);
#else
    const CFISH_Blob_Equals_Bytes_t method = (CFISH_Blob_Equals_Bytes_t)cfish_obj_method(self, CFISH_Blob_Equals_Bytes_OFFSET);
    return method(self, bytes, size);
#endif
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define Blob cfish_Blob
  #define BLOB CFISH_BLOB
  #define Blob_new cfish_Blob_new
  #define Blob_init cfish_Blob_init
  #define Blob_new_steal cfish_Blob_new_steal
  #define Blob_init_steal cfish_Blob_init_steal
  #define Blob_new_wrap cfish_Blob_new_wrap
  #define Blob_init_wrap cfish_Blob_init_wrap
  #define Blob_get_class cfish_Blob_get_class
  #define Blob_get_class_name cfish_Blob_get_class_name
  #define Blob_is_a cfish_Blob_is_a
  #define Blob_To_Host_IMP CFISH_Blob_To_Host_IMP
  #define Blob_Get_Size_IMP CFISH_Blob_Get_Size_IMP
  #define Blob_Get_Buf_IMP CFISH_Blob_Get_Buf_IMP
  #define Blob_Equals_IMP CFISH_Blob_Equals_IMP
  #define Blob_Equals_Bytes_IMP CFISH_Blob_Equals_Bytes_IMP
  #define Blob_Compare_To_IMP CFISH_Blob_Compare_To_IMP
  #define Blob_Clone_IMP CFISH_Blob_Clone_IMP
  #define Blob_Destroy_IMP CFISH_Blob_Destroy_IMP
  #define Blob_To_Host CFISH_Blob_To_Host
  #define Blob_To_Host_t CFISH_Blob_To_Host_t
  #define Blob_Clone CFISH_Blob_Clone
  #define Blob_Clone_t CFISH_Blob_Clone_t
  #define Blob_Equals CFISH_Blob_Equals
  #define Blob_Equals_t CFISH_Blob_Equals_t
  #define Blob_Compare_To CFISH_Blob_Compare_To
  #define Blob_Compare_To_t CFISH_Blob_Compare_To_t
  #define Blob_Destroy CFISH_Blob_Destroy
  #define Blob_Destroy_t CFISH_Blob_Destroy_t
  #define Blob_To_String CFISH_Blob_To_String
  #define Blob_To_String_t CFISH_Blob_To_String_t
  #define Blob_Get_Size CFISH_Blob_Get_Size
  #define Blob_Get_Size_t CFISH_Blob_Get_Size_t
  #define Blob_Get_Buf CFISH_Blob_Get_Buf
  #define Blob_Get_Buf_t CFISH_Blob_Get_Buf_t
  #define Blob_Equals_Bytes CFISH_Blob_Equals_Bytes
  #define Blob_Equals_Bytes_t CFISH_Blob_Equals_Bytes_t
#endif /* CFISH_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_BLOB */




