/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_ANALYSIS_STANDARDTOKENIZER
#define H_LUCY_ANALYSIS_STANDARDTOKENIZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_STANDARDTOKENIZER
extern uint32_t lucy_StandardTokenizer_IVARS_OFFSET;
typedef struct lucy_StandardTokenizerIVARS lucy_StandardTokenizerIVARS;
static CFISH_INLINE lucy_StandardTokenizerIVARS*
lucy_StandardTokenizer_IVARS(lucy_StandardTokenizer *self) {
   char *ptr = (char*)self + lucy_StandardTokenizer_IVARS_OFFSET;
   return (lucy_StandardTokenizerIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define StandardTokenizerIVARS lucy_StandardTokenizerIVARS
  #define StandardTokenizer_IVARS lucy_StandardTokenizer_IVARS
#endif


#endif /* C_LUCY_STANDARDTOKENIZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_StandardTokenizer*
lucy_StandardTokenizer_new(void);

LUCY_VISIBLE lucy_StandardTokenizer*
lucy_StandardTokenizer_init(lucy_StandardTokenizer* self);

lucy_Inversion*
LUCY_StandardTokenizer_Transform_IMP(lucy_StandardTokenizer* self, lucy_Inversion* inversion);

lucy_Inversion*
LUCY_StandardTokenizer_Transform_Text_IMP(lucy_StandardTokenizer* self, cfish_String* text);

void
LUCY_StandardTokenizer_Tokenize_Utf8_IMP(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);

bool
LUCY_StandardTokenizer_Equals_IMP(lucy_StandardTokenizer* self, cfish_Obj* other);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_StandardTokenizer_To_Host_t)(lucy_StandardTokenizer* self, void* vcache);

typedef cfish_Obj*
(*LUCY_StandardTokenizer_Clone_t)(lucy_StandardTokenizer* self);

typedef bool
(*LUCY_StandardTokenizer_Equals_t)(lucy_StandardTokenizer* self, cfish_Obj* other);

typedef int32_t
(*LUCY_StandardTokenizer_Compare_To_t)(lucy_StandardTokenizer* self, cfish_Obj* other);

typedef void
(*LUCY_StandardTokenizer_Destroy_t)(lucy_StandardTokenizer* self);

typedef cfish_String*
(*LUCY_StandardTokenizer_To_String_t)(lucy_StandardTokenizer* self);

typedef lucy_Inversion*
(*LUCY_StandardTokenizer_Transform_t)(lucy_StandardTokenizer* self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*LUCY_StandardTokenizer_Transform_Text_t)(lucy_StandardTokenizer* self, cfish_String* text);

typedef cfish_Vector*
(*LUCY_StandardTokenizer_Split_t)(lucy_StandardTokenizer* self, cfish_String* text);

typedef cfish_Obj*
(*LUCY_StandardTokenizer_Dump_t)(lucy_StandardTokenizer* self);

typedef cfish_Obj*
(*LUCY_StandardTokenizer_Load_t)(lucy_StandardTokenizer* self, cfish_Obj* dump);

typedef void
(*LUCY_StandardTokenizer_Tokenize_Utf8_t)(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_StandardTokenizer_get_class(lucy_StandardTokenizer *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_StandardTokenizer_get_class_name(lucy_StandardTokenizer *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_StandardTokenizer_is_a(lucy_StandardTokenizer *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_StandardTokenizer_To_Host(lucy_StandardTokenizer* self, void* vcache) {
    const LUCY_StandardTokenizer_To_Host_t method = (LUCY_StandardTokenizer_To_Host_t)cfish_obj_method(self, LUCY_StandardTokenizer_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_StandardTokenizer_Clone(lucy_StandardTokenizer* self) {
    const LUCY_StandardTokenizer_Clone_t method = (LUCY_StandardTokenizer_Clone_t)cfish_obj_method(self, LUCY_StandardTokenizer_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_StandardTokenizer_Equals(lucy_StandardTokenizer* self, cfish_Obj* other) {
    const LUCY_StandardTokenizer_Equals_t method = (LUCY_StandardTokenizer_Equals_t)cfish_obj_method(self, LUCY_StandardTokenizer_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_StandardTokenizer_Compare_To(lucy_StandardTokenizer* self, cfish_Obj* other) {
    const LUCY_StandardTokenizer_Compare_To_t method = (LUCY_StandardTokenizer_Compare_To_t)cfish_obj_method(self, LUCY_StandardTokenizer_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_StandardTokenizer_Destroy(lucy_StandardTokenizer* self) {
    const LUCY_StandardTokenizer_Destroy_t method = (LUCY_StandardTokenizer_Destroy_t)cfish_obj_method(self, LUCY_StandardTokenizer_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_StandardTokenizer_To_String(lucy_StandardTokenizer* self) {
    const LUCY_StandardTokenizer_To_String_t method = (LUCY_StandardTokenizer_To_String_t)cfish_obj_method(self, LUCY_StandardTokenizer_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Transform_OFFSET;
static CFISH_INLINE lucy_Inversion*
LUCY_StandardTokenizer_Transform(lucy_StandardTokenizer* self, lucy_Inversion* inversion) {
    const LUCY_StandardTokenizer_Transform_t method = (LUCY_StandardTokenizer_Transform_t)cfish_obj_method(self, LUCY_StandardTokenizer_Transform_OFFSET);
    return method(self, inversion);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Transform_Text_OFFSET;
static CFISH_INLINE lucy_Inversion*
LUCY_StandardTokenizer_Transform_Text(lucy_StandardTokenizer* self, cfish_String* text) {
    const LUCY_StandardTokenizer_Transform_Text_t method = (LUCY_StandardTokenizer_Transform_Text_t)cfish_obj_method(self, LUCY_StandardTokenizer_Transform_Text_OFFSET);
    return method(self, text);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Split_OFFSET;
static CFISH_INLINE cfish_Vector*
LUCY_StandardTokenizer_Split(lucy_StandardTokenizer* self, cfish_String* text) {
    const LUCY_StandardTokenizer_Split_t method = (LUCY_StandardTokenizer_Split_t)cfish_obj_method(self, LUCY_StandardTokenizer_Split_OFFSET);
    return method(self, text);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Dump_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_StandardTokenizer_Dump(lucy_StandardTokenizer* self) {
    const LUCY_StandardTokenizer_Dump_t method = (LUCY_StandardTokenizer_Dump_t)cfish_obj_method(self, LUCY_StandardTokenizer_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Load_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_StandardTokenizer_Load(lucy_StandardTokenizer* self, cfish_Obj* dump) {
    const LUCY_StandardTokenizer_Load_t method = (LUCY_StandardTokenizer_Load_t)cfish_obj_method(self, LUCY_StandardTokenizer_Load_OFFSET);
    return method(self, dump);
}

extern LUCY_VISIBLE uint32_t LUCY_StandardTokenizer_Tokenize_Utf8_OFFSET;
static CFISH_INLINE void
LUCY_StandardTokenizer_Tokenize_Utf8(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion) {
    const LUCY_StandardTokenizer_Tokenize_Utf8_t method = (LUCY_StandardTokenizer_Tokenize_Utf8_t)cfish_obj_method(self, LUCY_StandardTokenizer_Tokenize_Utf8_OFFSET);
    method(self, text, len, inversion);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_StandardTokenizer_Tokenize_Utf8_OVERRIDE NULL
#else
void
Lucy_StandardTokenizer_Tokenize_Utf8_OVERRIDE(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define StandardTokenizer lucy_StandardTokenizer
  #define STANDARDTOKENIZER LUCY_STANDARDTOKENIZER
  #define StandardTokenizer_new lucy_StandardTokenizer_new
  #define StandardTokenizer_init lucy_StandardTokenizer_init
  #define StandardTokenizer_get_class lucy_StandardTokenizer_get_class
  #define StandardTokenizer_get_class_name lucy_StandardTokenizer_get_class_name
  #define StandardTokenizer_is_a lucy_StandardTokenizer_is_a
  #define StandardTokenizer_Transform_IMP LUCY_StandardTokenizer_Transform_IMP
  #define StandardTokenizer_Transform_Text_IMP LUCY_StandardTokenizer_Transform_Text_IMP
  #define StandardTokenizer_Tokenize_Utf8_IMP LUCY_StandardTokenizer_Tokenize_Utf8_IMP
  #define StandardTokenizer_Equals_IMP LUCY_StandardTokenizer_Equals_IMP
  #define StandardTokenizer_To_Host LUCY_StandardTokenizer_To_Host
  #define StandardTokenizer_To_Host_t LUCY_StandardTokenizer_To_Host_t
  #define StandardTokenizer_Clone LUCY_StandardTokenizer_Clone
  #define StandardTokenizer_Clone_t LUCY_StandardTokenizer_Clone_t
  #define StandardTokenizer_Equals LUCY_StandardTokenizer_Equals
  #define StandardTokenizer_Equals_t LUCY_StandardTokenizer_Equals_t
  #define StandardTokenizer_Compare_To LUCY_StandardTokenizer_Compare_To
  #define StandardTokenizer_Compare_To_t LUCY_StandardTokenizer_Compare_To_t
  #define StandardTokenizer_Destroy LUCY_StandardTokenizer_Destroy
  #define StandardTokenizer_Destroy_t LUCY_StandardTokenizer_Destroy_t
  #define StandardTokenizer_To_String LUCY_StandardTokenizer_To_String
  #define StandardTokenizer_To_String_t LUCY_StandardTokenizer_To_String_t
  #define StandardTokenizer_Transform LUCY_StandardTokenizer_Transform
  #define StandardTokenizer_Transform_t LUCY_StandardTokenizer_Transform_t
  #define StandardTokenizer_Transform_Text LUCY_StandardTokenizer_Transform_Text
  #define StandardTokenizer_Transform_Text_t LUCY_StandardTokenizer_Transform_Text_t
  #define StandardTokenizer_Split LUCY_StandardTokenizer_Split
  #define StandardTokenizer_Split_t LUCY_StandardTokenizer_Split_t
  #define StandardTokenizer_Dump LUCY_StandardTokenizer_Dump
  #define StandardTokenizer_Dump_t LUCY_StandardTokenizer_Dump_t
  #define StandardTokenizer_Load LUCY_StandardTokenizer_Load
  #define StandardTokenizer_Load_t LUCY_StandardTokenizer_Load_t
  #define StandardTokenizer_Tokenize_Utf8 LUCY_StandardTokenizer_Tokenize_Utf8
  #define StandardTokenizer_Tokenize_Utf8_t LUCY_StandardTokenizer_Tokenize_Utf8_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_STANDARDTOKENIZER */




