/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_INDEX_DOCWRITER
#define H_LUCY_INDEX_DOCWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DOCWRITER
extern uint32_t lucy_DocWriter_IVARS_OFFSET;
typedef struct lucy_DocWriterIVARS lucy_DocWriterIVARS;
static CFISH_INLINE lucy_DocWriterIVARS*
lucy_DocWriter_IVARS(lucy_DocWriter *self) {
   char *ptr = (char*)self + lucy_DocWriter_IVARS_OFFSET;
   return (lucy_DocWriterIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define DocWriterIVARS lucy_DocWriterIVARS
  #define DocWriter_IVARS lucy_DocWriter_IVARS
#endif

struct lucy_DocWriterIVARS {
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_OutStream* ix_out;
    lucy_OutStream* dat_out;
};

#endif /* C_LUCY_DOCWRITER */

/* Declare this class's inert variables.
 */

extern LUCY_VISIBLE int32_t lucy_DocWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_DocWriter*
lucy_DocWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

LUCY_VISIBLE lucy_DocWriter*
lucy_DocWriter_init(lucy_DocWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
LUCY_DocWriter_Add_Inverted_Doc_IMP(lucy_DocWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
LUCY_DocWriter_Add_Segment_IMP(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
LUCY_DocWriter_Finish_IMP(lucy_DocWriter* self);

int32_t
LUCY_DocWriter_Format_IMP(lucy_DocWriter* self);

void
LUCY_DocWriter_Destroy_IMP(lucy_DocWriter* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_DocWriter_To_Host_t)(lucy_DocWriter* self, void* vcache);

typedef cfish_Obj*
(*LUCY_DocWriter_Clone_t)(lucy_DocWriter* self);

typedef bool
(*LUCY_DocWriter_Equals_t)(lucy_DocWriter* self, cfish_Obj* other);

typedef int32_t
(*LUCY_DocWriter_Compare_To_t)(lucy_DocWriter* self, cfish_Obj* other);

typedef void
(*LUCY_DocWriter_Destroy_t)(lucy_DocWriter* self);

typedef cfish_String*
(*LUCY_DocWriter_To_String_t)(lucy_DocWriter* self);

typedef void
(*LUCY_DocWriter_Add_Inverted_Doc_t)(lucy_DocWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*LUCY_DocWriter_Add_Segment_t)(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_DocWriter_Delete_Segment_t)(lucy_DocWriter* self, lucy_SegReader* reader);

typedef void
(*LUCY_DocWriter_Merge_Segment_t)(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_DocWriter_Finish_t)(lucy_DocWriter* self);

typedef cfish_Hash*
(*LUCY_DocWriter_Metadata_t)(lucy_DocWriter* self);

typedef int32_t
(*LUCY_DocWriter_Format_t)(lucy_DocWriter* self);

typedef lucy_Snapshot*
(*LUCY_DocWriter_Get_Snapshot_t)(lucy_DocWriter* self);

typedef lucy_Segment*
(*LUCY_DocWriter_Get_Segment_t)(lucy_DocWriter* self);

typedef lucy_PolyReader*
(*LUCY_DocWriter_Get_PolyReader_t)(lucy_DocWriter* self);

typedef lucy_Schema*
(*LUCY_DocWriter_Get_Schema_t)(lucy_DocWriter* self);

typedef lucy_Folder*
(*LUCY_DocWriter_Get_Folder_t)(lucy_DocWriter* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_DocWriter_get_class(lucy_DocWriter *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_DocWriter_get_class_name(lucy_DocWriter *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_DocWriter_is_a(lucy_DocWriter *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_DocWriter_To_Host(lucy_DocWriter* self, void* vcache) {
    const LUCY_DocWriter_To_Host_t method = (LUCY_DocWriter_To_Host_t)cfish_obj_method(self, LUCY_DocWriter_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_DocWriter_Clone(lucy_DocWriter* self) {
    const LUCY_DocWriter_Clone_t method = (LUCY_DocWriter_Clone_t)cfish_obj_method(self, LUCY_DocWriter_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_DocWriter_Equals(lucy_DocWriter* self, cfish_Obj* other) {
    const LUCY_DocWriter_Equals_t method = (LUCY_DocWriter_Equals_t)cfish_obj_method(self, LUCY_DocWriter_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_DocWriter_Compare_To(lucy_DocWriter* self, cfish_Obj* other) {
    const LUCY_DocWriter_Compare_To_t method = (LUCY_DocWriter_Compare_To_t)cfish_obj_method(self, LUCY_DocWriter_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Destroy(lucy_DocWriter* self) {
    const LUCY_DocWriter_Destroy_t method = (LUCY_DocWriter_Destroy_t)cfish_obj_method(self, LUCY_DocWriter_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_DocWriter_To_String(lucy_DocWriter* self) {
    const LUCY_DocWriter_To_String_t method = (LUCY_DocWriter_To_String_t)cfish_obj_method(self, LUCY_DocWriter_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Add_Inverted_Doc_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Add_Inverted_Doc(lucy_DocWriter* self, lucy_Inverter* inverter, int32_t doc_id) {
    const LUCY_DocWriter_Add_Inverted_Doc_t method = (LUCY_DocWriter_Add_Inverted_Doc_t)cfish_obj_method(self, LUCY_DocWriter_Add_Inverted_Doc_OFFSET);
    method(self, inverter, doc_id);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Add_Segment_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Add_Segment(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_DocWriter_Add_Segment_t method = (LUCY_DocWriter_Add_Segment_t)cfish_obj_method(self, LUCY_DocWriter_Add_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Delete_Segment_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Delete_Segment(lucy_DocWriter* self, lucy_SegReader* reader) {
    const LUCY_DocWriter_Delete_Segment_t method = (LUCY_DocWriter_Delete_Segment_t)cfish_obj_method(self, LUCY_DocWriter_Delete_Segment_OFFSET);
    method(self, reader);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Merge_Segment_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Merge_Segment(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_DocWriter_Merge_Segment_t method = (LUCY_DocWriter_Merge_Segment_t)cfish_obj_method(self, LUCY_DocWriter_Merge_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Finish_OFFSET;
static CFISH_INLINE void
LUCY_DocWriter_Finish(lucy_DocWriter* self) {
    const LUCY_DocWriter_Finish_t method = (LUCY_DocWriter_Finish_t)cfish_obj_method(self, LUCY_DocWriter_Finish_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Metadata_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_DocWriter_Metadata(lucy_DocWriter* self) {
    const LUCY_DocWriter_Metadata_t method = (LUCY_DocWriter_Metadata_t)cfish_obj_method(self, LUCY_DocWriter_Metadata_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Format_OFFSET;
static CFISH_INLINE int32_t
LUCY_DocWriter_Format(lucy_DocWriter* self) {
    const LUCY_DocWriter_Format_t method = (LUCY_DocWriter_Format_t)cfish_obj_method(self, LUCY_DocWriter_Format_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_DocWriter_Get_Snapshot(lucy_DocWriter* self) {
    const LUCY_DocWriter_Get_Snapshot_t method = (LUCY_DocWriter_Get_Snapshot_t)cfish_obj_method(self, LUCY_DocWriter_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_DocWriter_Get_Segment(lucy_DocWriter* self) {
    const LUCY_DocWriter_Get_Segment_t method = (LUCY_DocWriter_Get_Segment_t)cfish_obj_method(self, LUCY_DocWriter_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Get_PolyReader_OFFSET;
static CFISH_INLINE lucy_PolyReader*
LUCY_DocWriter_Get_PolyReader(lucy_DocWriter* self) {
    const LUCY_DocWriter_Get_PolyReader_t method = (LUCY_DocWriter_Get_PolyReader_t)cfish_obj_method(self, LUCY_DocWriter_Get_PolyReader_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_DocWriter_Get_Schema(lucy_DocWriter* self) {
    const LUCY_DocWriter_Get_Schema_t method = (LUCY_DocWriter_Get_Schema_t)cfish_obj_method(self, LUCY_DocWriter_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_DocWriter_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_DocWriter_Get_Folder(lucy_DocWriter* self) {
    const LUCY_DocWriter_Get_Folder_t method = (LUCY_DocWriter_Get_Folder_t)cfish_obj_method(self, LUCY_DocWriter_Get_Folder_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DocWriter lucy_DocWriter
  #define DOCWRITER LUCY_DOCWRITER
  #define DocWriter_new lucy_DocWriter_new
  #define DocWriter_init lucy_DocWriter_init
  #define DocWriter_current_file_format lucy_DocWriter_current_file_format
  #define DocWriter_get_class lucy_DocWriter_get_class
  #define DocWriter_get_class_name lucy_DocWriter_get_class_name
  #define DocWriter_is_a lucy_DocWriter_is_a
  #define DocWriter_Add_Inverted_Doc_IMP LUCY_DocWriter_Add_Inverted_Doc_IMP
  #define DocWriter_Add_Segment_IMP LUCY_DocWriter_Add_Segment_IMP
  #define DocWriter_Finish_IMP LUCY_DocWriter_Finish_IMP
  #define DocWriter_Format_IMP LUCY_DocWriter_Format_IMP
  #define DocWriter_Destroy_IMP LUCY_DocWriter_Destroy_IMP
  #define DocWriter_To_Host LUCY_DocWriter_To_Host
  #define DocWriter_To_Host_t LUCY_DocWriter_To_Host_t
  #define DocWriter_Clone LUCY_DocWriter_Clone
  #define DocWriter_Clone_t LUCY_DocWriter_Clone_t
  #define DocWriter_Equals LUCY_DocWriter_Equals
  #define DocWriter_Equals_t LUCY_DocWriter_Equals_t
  #define DocWriter_Compare_To LUCY_DocWriter_Compare_To
  #define DocWriter_Compare_To_t LUCY_DocWriter_Compare_To_t
  #define DocWriter_Destroy LUCY_DocWriter_Destroy
  #define DocWriter_Destroy_t LUCY_DocWriter_Destroy_t
  #define DocWriter_To_String LUCY_DocWriter_To_String
  #define DocWriter_To_String_t LUCY_DocWriter_To_String_t
  #define DocWriter_Add_Inverted_Doc LUCY_DocWriter_Add_Inverted_Doc
  #define DocWriter_Add_Inverted_Doc_t LUCY_DocWriter_Add_Inverted_Doc_t
  #define DocWriter_Add_Segment LUCY_DocWriter_Add_Segment
  #define DocWriter_Add_Segment_t LUCY_DocWriter_Add_Segment_t
  #define DocWriter_Delete_Segment LUCY_DocWriter_Delete_Segment
  #define DocWriter_Delete_Segment_t LUCY_DocWriter_Delete_Segment_t
  #define DocWriter_Merge_Segment LUCY_DocWriter_Merge_Segment
  #define DocWriter_Merge_Segment_t LUCY_DocWriter_Merge_Segment_t
  #define DocWriter_Finish LUCY_DocWriter_Finish
  #define DocWriter_Finish_t LUCY_DocWriter_Finish_t
  #define DocWriter_Metadata LUCY_DocWriter_Metadata
  #define DocWriter_Metadata_t LUCY_DocWriter_Metadata_t
  #define DocWriter_Format LUCY_DocWriter_Format
  #define DocWriter_Format_t LUCY_DocWriter_Format_t
  #define DocWriter_Get_Snapshot LUCY_DocWriter_Get_Snapshot
  #define DocWriter_Get_Snapshot_t LUCY_DocWriter_Get_Snapshot_t
  #define DocWriter_Get_Segment LUCY_DocWriter_Get_Segment
  #define DocWriter_Get_Segment_t LUCY_DocWriter_Get_Segment_t
  #define DocWriter_Get_PolyReader LUCY_DocWriter_Get_PolyReader
  #define DocWriter_Get_PolyReader_t LUCY_DocWriter_Get_PolyReader_t
  #define DocWriter_Get_Schema LUCY_DocWriter_Get_Schema
  #define DocWriter_Get_Schema_t LUCY_DocWriter_Get_Schema_t
  #define DocWriter_Get_Folder LUCY_DocWriter_Get_Folder
  #define DocWriter_Get_Folder_t LUCY_DocWriter_Get_Folder_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DOCWRITER */




