/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_INDEX_POSTINGLISTWRITER
#define H_LUCY_INDEX_POSTINGLISTWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGLISTWRITER
extern uint32_t lucy_PListWriter_IVARS_OFFSET;
typedef struct lucy_PostingListWriterIVARS lucy_PostingListWriterIVARS;
static CFISH_INLINE lucy_PostingListWriterIVARS*
lucy_PListWriter_IVARS(lucy_PostingListWriter *self) {
   char *ptr = (char*)self + lucy_PListWriter_IVARS_OFFSET;
   return (lucy_PostingListWriterIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define PostingListWriterIVARS lucy_PostingListWriterIVARS
  #define PListWriter_IVARS lucy_PListWriter_IVARS
#endif

struct lucy_PostingListWriterIVARS {
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_LexiconWriter* lex_writer;
    cfish_Vector* pools;
    lucy_MemoryPool* mem_pool;
    lucy_OutStream* lex_temp_out;
    lucy_OutStream* post_temp_out;
    lucy_OutStream* skip_out;
    uint32_t mem_thresh;
};

#endif /* C_LUCY_POSTINGLISTWRITER */

/* Declare this class's inert variables.
 */

extern LUCY_VISIBLE int32_t lucy_PListWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_PostingListWriter*
lucy_PListWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_LexiconWriter* lex_writer);

LUCY_VISIBLE lucy_PostingListWriter*
lucy_PListWriter_init(lucy_PostingListWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_LexiconWriter* lex_writer);

LUCY_VISIBLE void
lucy_PListWriter_set_default_mem_thresh(uint32_t mem_thresh);

void
LUCY_PListWriter_Add_Inverted_Doc_IMP(lucy_PostingListWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
LUCY_PListWriter_Add_Segment_IMP(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
LUCY_PListWriter_Finish_IMP(lucy_PostingListWriter* self);

int32_t
LUCY_PListWriter_Format_IMP(lucy_PostingListWriter* self);

void
LUCY_PListWriter_Destroy_IMP(lucy_PostingListWriter* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_PListWriter_To_Host_t)(lucy_PostingListWriter* self, void* vcache);

typedef cfish_Obj*
(*LUCY_PListWriter_Clone_t)(lucy_PostingListWriter* self);

typedef bool
(*LUCY_PListWriter_Equals_t)(lucy_PostingListWriter* self, cfish_Obj* other);

typedef int32_t
(*LUCY_PListWriter_Compare_To_t)(lucy_PostingListWriter* self, cfish_Obj* other);

typedef void
(*LUCY_PListWriter_Destroy_t)(lucy_PostingListWriter* self);

typedef cfish_String*
(*LUCY_PListWriter_To_String_t)(lucy_PostingListWriter* self);

typedef void
(*LUCY_PListWriter_Add_Inverted_Doc_t)(lucy_PostingListWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*LUCY_PListWriter_Add_Segment_t)(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_PListWriter_Delete_Segment_t)(lucy_PostingListWriter* self, lucy_SegReader* reader);

typedef void
(*LUCY_PListWriter_Merge_Segment_t)(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_PListWriter_Finish_t)(lucy_PostingListWriter* self);

typedef cfish_Hash*
(*LUCY_PListWriter_Metadata_t)(lucy_PostingListWriter* self);

typedef int32_t
(*LUCY_PListWriter_Format_t)(lucy_PostingListWriter* self);

typedef lucy_Snapshot*
(*LUCY_PListWriter_Get_Snapshot_t)(lucy_PostingListWriter* self);

typedef lucy_Segment*
(*LUCY_PListWriter_Get_Segment_t)(lucy_PostingListWriter* self);

typedef lucy_PolyReader*
(*LUCY_PListWriter_Get_PolyReader_t)(lucy_PostingListWriter* self);

typedef lucy_Schema*
(*LUCY_PListWriter_Get_Schema_t)(lucy_PostingListWriter* self);

typedef lucy_Folder*
(*LUCY_PListWriter_Get_Folder_t)(lucy_PostingListWriter* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_PListWriter_get_class(lucy_PostingListWriter *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_PListWriter_get_class_name(lucy_PostingListWriter *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_PListWriter_is_a(lucy_PostingListWriter *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_PListWriter_To_Host(lucy_PostingListWriter* self, void* vcache) {
    const LUCY_PListWriter_To_Host_t method = (LUCY_PListWriter_To_Host_t)cfish_obj_method(self, LUCY_PListWriter_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PListWriter_Clone(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Clone_t method = (LUCY_PListWriter_Clone_t)cfish_obj_method(self, LUCY_PListWriter_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_PListWriter_Equals(lucy_PostingListWriter* self, cfish_Obj* other) {
    const LUCY_PListWriter_Equals_t method = (LUCY_PListWriter_Equals_t)cfish_obj_method(self, LUCY_PListWriter_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_PListWriter_Compare_To(lucy_PostingListWriter* self, cfish_Obj* other) {
    const LUCY_PListWriter_Compare_To_t method = (LUCY_PListWriter_Compare_To_t)cfish_obj_method(self, LUCY_PListWriter_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Destroy(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Destroy_t method = (LUCY_PListWriter_Destroy_t)cfish_obj_method(self, LUCY_PListWriter_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PListWriter_To_String(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_To_String_t method = (LUCY_PListWriter_To_String_t)cfish_obj_method(self, LUCY_PListWriter_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Add_Inverted_Doc_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Add_Inverted_Doc(lucy_PostingListWriter* self, lucy_Inverter* inverter, int32_t doc_id) {
    const LUCY_PListWriter_Add_Inverted_Doc_t method = (LUCY_PListWriter_Add_Inverted_Doc_t)cfish_obj_method(self, LUCY_PListWriter_Add_Inverted_Doc_OFFSET);
    method(self, inverter, doc_id);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Add_Segment_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Add_Segment(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_PListWriter_Add_Segment_t method = (LUCY_PListWriter_Add_Segment_t)cfish_obj_method(self, LUCY_PListWriter_Add_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Delete_Segment_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Delete_Segment(lucy_PostingListWriter* self, lucy_SegReader* reader) {
    const LUCY_PListWriter_Delete_Segment_t method = (LUCY_PListWriter_Delete_Segment_t)cfish_obj_method(self, LUCY_PListWriter_Delete_Segment_OFFSET);
    method(self, reader);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Merge_Segment_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Merge_Segment(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_PListWriter_Merge_Segment_t method = (LUCY_PListWriter_Merge_Segment_t)cfish_obj_method(self, LUCY_PListWriter_Merge_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Finish_OFFSET;
static CFISH_INLINE void
LUCY_PListWriter_Finish(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Finish_t method = (LUCY_PListWriter_Finish_t)cfish_obj_method(self, LUCY_PListWriter_Finish_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Metadata_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_PListWriter_Metadata(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Metadata_t method = (LUCY_PListWriter_Metadata_t)cfish_obj_method(self, LUCY_PListWriter_Metadata_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Format_OFFSET;
static CFISH_INLINE int32_t
LUCY_PListWriter_Format(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Format_t method = (LUCY_PListWriter_Format_t)cfish_obj_method(self, LUCY_PListWriter_Format_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_PListWriter_Get_Snapshot(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Get_Snapshot_t method = (LUCY_PListWriter_Get_Snapshot_t)cfish_obj_method(self, LUCY_PListWriter_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_PListWriter_Get_Segment(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Get_Segment_t method = (LUCY_PListWriter_Get_Segment_t)cfish_obj_method(self, LUCY_PListWriter_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Get_PolyReader_OFFSET;
static CFISH_INLINE lucy_PolyReader*
LUCY_PListWriter_Get_PolyReader(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Get_PolyReader_t method = (LUCY_PListWriter_Get_PolyReader_t)cfish_obj_method(self, LUCY_PListWriter_Get_PolyReader_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_PListWriter_Get_Schema(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Get_Schema_t method = (LUCY_PListWriter_Get_Schema_t)cfish_obj_method(self, LUCY_PListWriter_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PListWriter_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_PListWriter_Get_Folder(lucy_PostingListWriter* self) {
    const LUCY_PListWriter_Get_Folder_t method = (LUCY_PListWriter_Get_Folder_t)cfish_obj_method(self, LUCY_PListWriter_Get_Folder_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingListWriter lucy_PostingListWriter
  #define POSTINGLISTWRITER LUCY_POSTINGLISTWRITER
  #define PListWriter_new lucy_PListWriter_new
  #define PListWriter_init lucy_PListWriter_init
  #define PListWriter_set_default_mem_thresh lucy_PListWriter_set_default_mem_thresh
  #define PListWriter_current_file_format lucy_PListWriter_current_file_format
  #define PListWriter_get_class lucy_PListWriter_get_class
  #define PListWriter_get_class_name lucy_PListWriter_get_class_name
  #define PListWriter_is_a lucy_PListWriter_is_a
  #define PListWriter_Add_Inverted_Doc_IMP LUCY_PListWriter_Add_Inverted_Doc_IMP
  #define PListWriter_Add_Segment_IMP LUCY_PListWriter_Add_Segment_IMP
  #define PListWriter_Finish_IMP LUCY_PListWriter_Finish_IMP
  #define PListWriter_Format_IMP LUCY_PListWriter_Format_IMP
  #define PListWriter_Destroy_IMP LUCY_PListWriter_Destroy_IMP
  #define PListWriter_To_Host LUCY_PListWriter_To_Host
  #define PListWriter_To_Host_t LUCY_PListWriter_To_Host_t
  #define PListWriter_Clone LUCY_PListWriter_Clone
  #define PListWriter_Clone_t LUCY_PListWriter_Clone_t
  #define PListWriter_Equals LUCY_PListWriter_Equals
  #define PListWriter_Equals_t LUCY_PListWriter_Equals_t
  #define PListWriter_Compare_To LUCY_PListWriter_Compare_To
  #define PListWriter_Compare_To_t LUCY_PListWriter_Compare_To_t
  #define PListWriter_Destroy LUCY_PListWriter_Destroy
  #define PListWriter_Destroy_t LUCY_PListWriter_Destroy_t
  #define PListWriter_To_String LUCY_PListWriter_To_String
  #define PListWriter_To_String_t LUCY_PListWriter_To_String_t
  #define PListWriter_Add_Inverted_Doc LUCY_PListWriter_Add_Inverted_Doc
  #define PListWriter_Add_Inverted_Doc_t LUCY_PListWriter_Add_Inverted_Doc_t
  #define PListWriter_Add_Segment LUCY_PListWriter_Add_Segment
  #define PListWriter_Add_Segment_t LUCY_PListWriter_Add_Segment_t
  #define PListWriter_Delete_Segment LUCY_PListWriter_Delete_Segment
  #define PListWriter_Delete_Segment_t LUCY_PListWriter_Delete_Segment_t
  #define PListWriter_Merge_Segment LUCY_PListWriter_Merge_Segment
  #define PListWriter_Merge_Segment_t LUCY_PListWriter_Merge_Segment_t
  #define PListWriter_Finish LUCY_PListWriter_Finish
  #define PListWriter_Finish_t LUCY_PListWriter_Finish_t
  #define PListWriter_Metadata LUCY_PListWriter_Metadata
  #define PListWriter_Metadata_t LUCY_PListWriter_Metadata_t
  #define PListWriter_Format LUCY_PListWriter_Format
  #define PListWriter_Format_t LUCY_PListWriter_Format_t
  #define PListWriter_Get_Snapshot LUCY_PListWriter_Get_Snapshot
  #define PListWriter_Get_Snapshot_t LUCY_PListWriter_Get_Snapshot_t
  #define PListWriter_Get_Segment LUCY_PListWriter_Get_Segment
  #define PListWriter_Get_Segment_t LUCY_PListWriter_Get_Segment_t
  #define PListWriter_Get_PolyReader LUCY_PListWriter_Get_PolyReader
  #define PListWriter_Get_PolyReader_t LUCY_PListWriter_Get_PolyReader_t
  #define PListWriter_Get_Schema LUCY_PListWriter_Get_Schema
  #define PListWriter_Get_Schema_t LUCY_PListWriter_Get_Schema_t
  #define PListWriter_Get_Folder LUCY_PListWriter_Get_Folder
  #define PListWriter_Get_Folder_t LUCY_PListWriter_Get_Folder_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTINGLISTWRITER */




