/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_INDEX_RAWPOSTINGLIST
#define H_LUCY_INDEX_RAWPOSTINGLIST 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/PostingList.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAWPOSTINGLIST
extern uint32_t lucy_RawPList_IVARS_OFFSET;
typedef struct lucy_RawPostingListIVARS lucy_RawPostingListIVARS;
static CFISH_INLINE lucy_RawPostingListIVARS*
lucy_RawPList_IVARS(lucy_RawPostingList *self) {
   char *ptr = (char*)self + lucy_RawPList_IVARS_OFFSET;
   return (lucy_RawPostingListIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define RawPostingListIVARS lucy_RawPostingListIVARS
  #define RawPList_IVARS lucy_RawPList_IVARS
#endif

struct lucy_RawPostingListIVARS {
    lucy_Posting* posting;
    lucy_InStream* instream;
    int64_t start;
    int64_t end;
    int64_t len;
};

#endif /* C_LUCY_RAWPOSTINGLIST */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_RawPostingList*
lucy_RawPList_new(lucy_Schema* schema, cfish_String* field, lucy_InStream* instream, int64_t start, int64_t end);

LUCY_VISIBLE lucy_RawPostingList*
lucy_RawPList_init(lucy_RawPostingList* self, lucy_Schema* schema, cfish_String* field, lucy_InStream* instream, int64_t lex_start, int64_t lex_end);

void
LUCY_RawPList_Destroy_IMP(lucy_RawPostingList* self);

lucy_RawPosting*
LUCY_RawPList_Read_Raw_IMP(lucy_RawPostingList* self, int32_t last_doc_id, cfish_String* term_text, lucy_MemoryPool* mem_pool);

lucy_Posting*
LUCY_RawPList_Get_Posting_IMP(lucy_RawPostingList* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_RawPList_To_Host_t)(lucy_RawPostingList* self, void* vcache);

typedef cfish_Obj*
(*LUCY_RawPList_Clone_t)(lucy_RawPostingList* self);

typedef bool
(*LUCY_RawPList_Equals_t)(lucy_RawPostingList* self, cfish_Obj* other);

typedef int32_t
(*LUCY_RawPList_Compare_To_t)(lucy_RawPostingList* self, cfish_Obj* other);

typedef void
(*LUCY_RawPList_Destroy_t)(lucy_RawPostingList* self);

typedef cfish_String*
(*LUCY_RawPList_To_String_t)(lucy_RawPostingList* self);

typedef int32_t
(*LUCY_RawPList_Next_t)(lucy_RawPostingList* self);

typedef int32_t
(*LUCY_RawPList_Advance_t)(lucy_RawPostingList* self, int32_t target);

typedef int32_t
(*LUCY_RawPList_Get_Doc_ID_t)(lucy_RawPostingList* self);

typedef float
(*LUCY_RawPList_Score_t)(lucy_RawPostingList* self);

typedef void
(*LUCY_RawPList_Collect_t)(lucy_RawPostingList* self, lucy_Collector* collector, lucy_Matcher* deletions);

typedef lucy_Posting*
(*LUCY_RawPList_Get_Posting_t)(lucy_RawPostingList* self);

typedef uint32_t
(*LUCY_RawPList_Get_Doc_Freq_t)(lucy_RawPostingList* self);

typedef void
(*LUCY_RawPList_Seek_t)(lucy_RawPostingList* self, cfish_Obj* target);

typedef void
(*LUCY_RawPList_Seek_Lex_t)(lucy_RawPostingList* self, lucy_Lexicon* lexicon);

typedef lucy_Matcher*
(*LUCY_RawPList_Make_Matcher_t)(lucy_RawPostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, bool need_score);

typedef lucy_RawPosting*
(*LUCY_RawPList_Read_Raw_t)(lucy_RawPostingList* self, int32_t last_doc_id, cfish_String* term_text, lucy_MemoryPool* mem_pool);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_RawPList_get_class(lucy_RawPostingList *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_RawPList_get_class_name(lucy_RawPostingList *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_RawPList_is_a(lucy_RawPostingList *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_RawPList_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_RawPList_To_Host(lucy_RawPostingList* self, void* vcache) {
    const LUCY_RawPList_To_Host_t method = (LUCY_RawPList_To_Host_t)cfish_obj_method(self, LUCY_RawPList_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RawPList_Clone(lucy_RawPostingList* self) {
    const LUCY_RawPList_Clone_t method = (LUCY_RawPList_Clone_t)cfish_obj_method(self, LUCY_RawPList_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_RawPList_Equals(lucy_RawPostingList* self, cfish_Obj* other) {
    const LUCY_RawPList_Equals_t method = (LUCY_RawPList_Equals_t)cfish_obj_method(self, LUCY_RawPList_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_RawPList_Compare_To(lucy_RawPostingList* self, cfish_Obj* other) {
    const LUCY_RawPList_Compare_To_t method = (LUCY_RawPList_Compare_To_t)cfish_obj_method(self, LUCY_RawPList_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_RawPList_Destroy(lucy_RawPostingList* self) {
    const LUCY_RawPList_Destroy_t method = (LUCY_RawPList_Destroy_t)cfish_obj_method(self, LUCY_RawPList_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RawPList_To_String(lucy_RawPostingList* self) {
    const LUCY_RawPList_To_String_t method = (LUCY_RawPList_To_String_t)cfish_obj_method(self, LUCY_RawPList_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_RawPList_Next(lucy_RawPostingList* self) {
    const LUCY_RawPList_Next_t method = (LUCY_RawPList_Next_t)cfish_obj_method(self, LUCY_RawPList_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_RawPList_Advance(lucy_RawPostingList* self, int32_t target) {
    const LUCY_RawPList_Advance_t method = (LUCY_RawPList_Advance_t)cfish_obj_method(self, LUCY_RawPList_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_RawPList_Get_Doc_ID(lucy_RawPostingList* self) {
    const LUCY_RawPList_Get_Doc_ID_t method = (LUCY_RawPList_Get_Doc_ID_t)cfish_obj_method(self, LUCY_RawPList_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Score_OFFSET;
static CFISH_INLINE float
LUCY_RawPList_Score(lucy_RawPostingList* self) {
    const LUCY_RawPList_Score_t method = (LUCY_RawPList_Score_t)cfish_obj_method(self, LUCY_RawPList_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Collect_OFFSET;
static CFISH_INLINE void
LUCY_RawPList_Collect(lucy_RawPostingList* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_RawPList_Collect_t method = (LUCY_RawPList_Collect_t)cfish_obj_method(self, LUCY_RawPList_Collect_OFFSET);
    method(self, collector, deletions);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Get_Posting_OFFSET;
static CFISH_INLINE lucy_Posting*
LUCY_RawPList_Get_Posting(lucy_RawPostingList* self) {
    const LUCY_RawPList_Get_Posting_t method = (LUCY_RawPList_Get_Posting_t)cfish_obj_method(self, LUCY_RawPList_Get_Posting_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Get_Doc_Freq_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RawPList_Get_Doc_Freq(lucy_RawPostingList* self) {
    const LUCY_RawPList_Get_Doc_Freq_t method = (LUCY_RawPList_Get_Doc_Freq_t)cfish_obj_method(self, LUCY_RawPList_Get_Doc_Freq_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Seek_OFFSET;
static CFISH_INLINE void
LUCY_RawPList_Seek(lucy_RawPostingList* self, cfish_Obj* target) {
    const LUCY_RawPList_Seek_t method = (LUCY_RawPList_Seek_t)cfish_obj_method(self, LUCY_RawPList_Seek_OFFSET);
    method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Seek_Lex_OFFSET;
static CFISH_INLINE void
LUCY_RawPList_Seek_Lex(lucy_RawPostingList* self, lucy_Lexicon* lexicon) {
    const LUCY_RawPList_Seek_Lex_t method = (LUCY_RawPList_Seek_Lex_t)cfish_obj_method(self, LUCY_RawPList_Seek_Lex_OFFSET);
    method(self, lexicon);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Make_Matcher_OFFSET;
static CFISH_INLINE lucy_Matcher*
LUCY_RawPList_Make_Matcher(lucy_RawPostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, bool need_score) {
    const LUCY_RawPList_Make_Matcher_t method = (LUCY_RawPList_Make_Matcher_t)cfish_obj_method(self, LUCY_RawPList_Make_Matcher_OFFSET);
    return method(self, similarity, compiler, need_score);
}

extern LUCY_VISIBLE uint32_t LUCY_RawPList_Read_Raw_OFFSET;
static CFISH_INLINE lucy_RawPosting*
LUCY_RawPList_Read_Raw(lucy_RawPostingList* self, int32_t last_doc_id, cfish_String* term_text, lucy_MemoryPool* mem_pool) {
    const LUCY_RawPList_Read_Raw_t method = (LUCY_RawPList_Read_Raw_t)cfish_obj_method(self, LUCY_RawPList_Read_Raw_OFFSET);
    return method(self, last_doc_id, term_text, mem_pool);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RawPostingList lucy_RawPostingList
  #define RAWPOSTINGLIST LUCY_RAWPOSTINGLIST
  #define RawPList_new lucy_RawPList_new
  #define RawPList_init lucy_RawPList_init
  #define RawPList_get_class lucy_RawPList_get_class
  #define RawPList_get_class_name lucy_RawPList_get_class_name
  #define RawPList_is_a lucy_RawPList_is_a
  #define RawPList_Destroy_IMP LUCY_RawPList_Destroy_IMP
  #define RawPList_Read_Raw_IMP LUCY_RawPList_Read_Raw_IMP
  #define RawPList_Get_Posting_IMP LUCY_RawPList_Get_Posting_IMP
  #define RawPList_To_Host LUCY_RawPList_To_Host
  #define RawPList_To_Host_t LUCY_RawPList_To_Host_t
  #define RawPList_Clone LUCY_RawPList_Clone
  #define RawPList_Clone_t LUCY_RawPList_Clone_t
  #define RawPList_Equals LUCY_RawPList_Equals
  #define RawPList_Equals_t LUCY_RawPList_Equals_t
  #define RawPList_Compare_To LUCY_RawPList_Compare_To
  #define RawPList_Compare_To_t LUCY_RawPList_Compare_To_t
  #define RawPList_Destroy LUCY_RawPList_Destroy
  #define RawPList_Destroy_t LUCY_RawPList_Destroy_t
  #define RawPList_To_String LUCY_RawPList_To_String
  #define RawPList_To_String_t LUCY_RawPList_To_String_t
  #define RawPList_Next LUCY_RawPList_Next
  #define RawPList_Next_t LUCY_RawPList_Next_t
  #define RawPList_Advance LUCY_RawPList_Advance
  #define RawPList_Advance_t LUCY_RawPList_Advance_t
  #define RawPList_Get_Doc_ID LUCY_RawPList_Get_Doc_ID
  #define RawPList_Get_Doc_ID_t LUCY_RawPList_Get_Doc_ID_t
  #define RawPList_Score LUCY_RawPList_Score
  #define RawPList_Score_t LUCY_RawPList_Score_t
  #define RawPList_Collect LUCY_RawPList_Collect
  #define RawPList_Collect_t LUCY_RawPList_Collect_t
  #define RawPList_Get_Posting LUCY_RawPList_Get_Posting
  #define RawPList_Get_Posting_t LUCY_RawPList_Get_Posting_t
  #define RawPList_Get_Doc_Freq LUCY_RawPList_Get_Doc_Freq
  #define RawPList_Get_Doc_Freq_t LUCY_RawPList_Get_Doc_Freq_t
  #define RawPList_Seek LUCY_RawPList_Seek
  #define RawPList_Seek_t LUCY_RawPList_Seek_t
  #define RawPList_Seek_Lex LUCY_RawPList_Seek_Lex
  #define RawPList_Seek_Lex_t LUCY_RawPList_Seek_Lex_t
  #define RawPList_Make_Matcher LUCY_RawPList_Make_Matcher
  #define RawPList_Make_Matcher_t LUCY_RawPList_Make_Matcher_t
  #define RawPList_Read_Raw LUCY_RawPList_Read_Raw
  #define RawPList_Read_Raw_t LUCY_RawPList_Read_Raw_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_RAWPOSTINGLIST */




