/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_INDEX_SEGLEXICON
#define H_LUCY_INDEX_SEGLEXICON 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Lexicon.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGLEXICON
extern uint32_t lucy_SegLex_IVARS_OFFSET;
typedef struct lucy_SegLexiconIVARS lucy_SegLexiconIVARS;
static CFISH_INLINE lucy_SegLexiconIVARS*
lucy_SegLex_IVARS(lucy_SegLexicon *self) {
   char *ptr = (char*)self + lucy_SegLex_IVARS_OFFSET;
   return (lucy_SegLexiconIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SegLexiconIVARS lucy_SegLexiconIVARS
  #define SegLex_IVARS lucy_SegLex_IVARS
#endif

struct lucy_SegLexiconIVARS {
    cfish_String* field;
    lucy_Segment* segment;
    lucy_TermStepper* term_stepper;
    lucy_TermStepper* tinfo_stepper;
    lucy_InStream* instream;
    lucy_LexIndex* lex_index;
    int32_t field_num;
    int32_t size;
    int32_t term_num;
    int32_t skip_interval;
    int32_t index_interval;
};

#endif /* C_LUCY_SEGLEXICON */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_SegLexicon*
lucy_SegLex_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, cfish_String* field);

LUCY_VISIBLE lucy_SegLexicon*
lucy_SegLex_init(lucy_SegLexicon* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, cfish_String* field);

lucy_TermInfo*
LUCY_SegLex_Get_Term_Info_IMP(lucy_SegLexicon* self);

int32_t
LUCY_SegLex_Get_Field_Num_IMP(lucy_SegLexicon* self);

lucy_Segment*
LUCY_SegLex_Get_Segment_IMP(lucy_SegLexicon* self);

void
LUCY_SegLex_Destroy_IMP(lucy_SegLexicon* self);

void
LUCY_SegLex_Seek_IMP(lucy_SegLexicon* self, cfish_Obj* target);

void
LUCY_SegLex_Reset_IMP(lucy_SegLexicon* self);

cfish_Obj*
LUCY_SegLex_Get_Term_IMP(lucy_SegLexicon* self);

int32_t
LUCY_SegLex_Doc_Freq_IMP(lucy_SegLexicon* self);

bool
LUCY_SegLex_Next_IMP(lucy_SegLexicon* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_SegLex_To_Host_t)(lucy_SegLexicon* self, void* vcache);

typedef cfish_Obj*
(*LUCY_SegLex_Clone_t)(lucy_SegLexicon* self);

typedef bool
(*LUCY_SegLex_Equals_t)(lucy_SegLexicon* self, cfish_Obj* other);

typedef int32_t
(*LUCY_SegLex_Compare_To_t)(lucy_SegLexicon* self, cfish_Obj* other);

typedef void
(*LUCY_SegLex_Destroy_t)(lucy_SegLexicon* self);

typedef cfish_String*
(*LUCY_SegLex_To_String_t)(lucy_SegLexicon* self);

typedef void
(*LUCY_SegLex_Seek_t)(lucy_SegLexicon* self, cfish_Obj* target);

typedef bool
(*LUCY_SegLex_Next_t)(lucy_SegLexicon* self);

typedef void
(*LUCY_SegLex_Reset_t)(lucy_SegLexicon* self);

typedef int32_t
(*LUCY_SegLex_Doc_Freq_t)(lucy_SegLexicon* self);

typedef cfish_Obj*
(*LUCY_SegLex_Get_Term_t)(lucy_SegLexicon* self);

typedef cfish_String*
(*LUCY_SegLex_Get_Field_t)(lucy_SegLexicon* self);

typedef lucy_TermInfo*
(*LUCY_SegLex_Get_Term_Info_t)(lucy_SegLexicon* self);

typedef int32_t
(*LUCY_SegLex_Get_Field_Num_t)(lucy_SegLexicon* self);

typedef lucy_Segment*
(*LUCY_SegLex_Get_Segment_t)(lucy_SegLexicon* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_SegLex_get_class(lucy_SegLexicon *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_SegLex_get_class_name(lucy_SegLexicon *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_SegLex_is_a(lucy_SegLexicon *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_SegLex_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_SegLex_To_Host(lucy_SegLexicon* self, void* vcache) {
    const LUCY_SegLex_To_Host_t method = (LUCY_SegLex_To_Host_t)cfish_obj_method(self, LUCY_SegLex_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SegLex_Clone(lucy_SegLexicon* self) {
    const LUCY_SegLex_Clone_t method = (LUCY_SegLex_Clone_t)cfish_obj_method(self, LUCY_SegLex_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_SegLex_Equals(lucy_SegLexicon* self, cfish_Obj* other) {
    const LUCY_SegLex_Equals_t method = (LUCY_SegLex_Equals_t)cfish_obj_method(self, LUCY_SegLex_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_SegLex_Compare_To(lucy_SegLexicon* self, cfish_Obj* other) {
    const LUCY_SegLex_Compare_To_t method = (LUCY_SegLex_Compare_To_t)cfish_obj_method(self, LUCY_SegLex_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_SegLex_Destroy(lucy_SegLexicon* self) {
    const LUCY_SegLex_Destroy_t method = (LUCY_SegLex_Destroy_t)cfish_obj_method(self, LUCY_SegLex_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SegLex_To_String(lucy_SegLexicon* self) {
    const LUCY_SegLex_To_String_t method = (LUCY_SegLex_To_String_t)cfish_obj_method(self, LUCY_SegLex_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Seek_OFFSET;
static CFISH_INLINE void
LUCY_SegLex_Seek(lucy_SegLexicon* self, cfish_Obj* target) {
    const LUCY_SegLex_Seek_t method = (LUCY_SegLex_Seek_t)cfish_obj_method(self, LUCY_SegLex_Seek_OFFSET);
    method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Next_OFFSET;
static CFISH_INLINE bool
LUCY_SegLex_Next(lucy_SegLexicon* self) {
    const LUCY_SegLex_Next_t method = (LUCY_SegLex_Next_t)cfish_obj_method(self, LUCY_SegLex_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Reset_OFFSET;
static CFISH_INLINE void
LUCY_SegLex_Reset(lucy_SegLexicon* self) {
    const LUCY_SegLex_Reset_t method = (LUCY_SegLex_Reset_t)cfish_obj_method(self, LUCY_SegLex_Reset_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Doc_Freq_OFFSET;
static CFISH_INLINE int32_t
LUCY_SegLex_Doc_Freq(lucy_SegLexicon* self) {
    const LUCY_SegLex_Doc_Freq_t method = (LUCY_SegLex_Doc_Freq_t)cfish_obj_method(self, LUCY_SegLex_Doc_Freq_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Get_Term_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SegLex_Get_Term(lucy_SegLexicon* self) {
    const LUCY_SegLex_Get_Term_t method = (LUCY_SegLex_Get_Term_t)cfish_obj_method(self, LUCY_SegLex_Get_Term_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Get_Field_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SegLex_Get_Field(lucy_SegLexicon* self) {
    const LUCY_SegLex_Get_Field_t method = (LUCY_SegLex_Get_Field_t)cfish_obj_method(self, LUCY_SegLex_Get_Field_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Get_Term_Info_OFFSET;
static CFISH_INLINE lucy_TermInfo*
LUCY_SegLex_Get_Term_Info(lucy_SegLexicon* self) {
    const LUCY_SegLex_Get_Term_Info_t method = (LUCY_SegLex_Get_Term_Info_t)cfish_obj_method(self, LUCY_SegLex_Get_Term_Info_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Get_Field_Num_OFFSET;
static CFISH_INLINE int32_t
LUCY_SegLex_Get_Field_Num(lucy_SegLexicon* self) {
    const LUCY_SegLex_Get_Field_Num_t method = (LUCY_SegLex_Get_Field_Num_t)cfish_obj_method(self, LUCY_SegLex_Get_Field_Num_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SegLex_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_SegLex_Get_Segment(lucy_SegLexicon* self) {
    const LUCY_SegLex_Get_Segment_t method = (LUCY_SegLex_Get_Segment_t)cfish_obj_method(self, LUCY_SegLex_Get_Segment_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_SegLex_Get_Term_Info_OVERRIDE NULL
#define Lucy_SegLex_Get_Field_Num_OVERRIDE NULL
#define Lucy_SegLex_Get_Segment_OVERRIDE NULL
#else
lucy_TermInfo*
Lucy_SegLex_Get_Term_Info_OVERRIDE(lucy_SegLexicon* self);
int32_t
Lucy_SegLex_Get_Field_Num_OVERRIDE(lucy_SegLexicon* self);
lucy_Segment*
Lucy_SegLex_Get_Segment_OVERRIDE(lucy_SegLexicon* self);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegLexicon lucy_SegLexicon
  #define SEGLEXICON LUCY_SEGLEXICON
  #define SegLex_new lucy_SegLex_new
  #define SegLex_init lucy_SegLex_init
  #define SegLex_get_class lucy_SegLex_get_class
  #define SegLex_get_class_name lucy_SegLex_get_class_name
  #define SegLex_is_a lucy_SegLex_is_a
  #define SegLex_Get_Term_Info_IMP LUCY_SegLex_Get_Term_Info_IMP
  #define SegLex_Get_Field_Num_IMP LUCY_SegLex_Get_Field_Num_IMP
  #define SegLex_Get_Segment_IMP LUCY_SegLex_Get_Segment_IMP
  #define SegLex_Destroy_IMP LUCY_SegLex_Destroy_IMP
  #define SegLex_Seek_IMP LUCY_SegLex_Seek_IMP
  #define SegLex_Reset_IMP LUCY_SegLex_Reset_IMP
  #define SegLex_Get_Term_IMP LUCY_SegLex_Get_Term_IMP
  #define SegLex_Doc_Freq_IMP LUCY_SegLex_Doc_Freq_IMP
  #define SegLex_Next_IMP LUCY_SegLex_Next_IMP
  #define SegLex_To_Host LUCY_SegLex_To_Host
  #define SegLex_To_Host_t LUCY_SegLex_To_Host_t
  #define SegLex_Clone LUCY_SegLex_Clone
  #define SegLex_Clone_t LUCY_SegLex_Clone_t
  #define SegLex_Equals LUCY_SegLex_Equals
  #define SegLex_Equals_t LUCY_SegLex_Equals_t
  #define SegLex_Compare_To LUCY_SegLex_Compare_To
  #define SegLex_Compare_To_t LUCY_SegLex_Compare_To_t
  #define SegLex_Destroy LUCY_SegLex_Destroy
  #define SegLex_Destroy_t LUCY_SegLex_Destroy_t
  #define SegLex_To_String LUCY_SegLex_To_String
  #define SegLex_To_String_t LUCY_SegLex_To_String_t
  #define SegLex_Seek LUCY_SegLex_Seek
  #define SegLex_Seek_t LUCY_SegLex_Seek_t
  #define SegLex_Next LUCY_SegLex_Next
  #define SegLex_Next_t LUCY_SegLex_Next_t
  #define SegLex_Reset LUCY_SegLex_Reset
  #define SegLex_Reset_t LUCY_SegLex_Reset_t
  #define SegLex_Doc_Freq LUCY_SegLex_Doc_Freq
  #define SegLex_Doc_Freq_t LUCY_SegLex_Doc_Freq_t
  #define SegLex_Get_Term LUCY_SegLex_Get_Term
  #define SegLex_Get_Term_t LUCY_SegLex_Get_Term_t
  #define SegLex_Get_Field LUCY_SegLex_Get_Field
  #define SegLex_Get_Field_t LUCY_SegLex_Get_Field_t
  #define SegLex_Get_Term_Info LUCY_SegLex_Get_Term_Info
  #define SegLex_Get_Term_Info_t LUCY_SegLex_Get_Term_Info_t
  #define SegLex_Get_Field_Num LUCY_SegLex_Get_Field_Num
  #define SegLex_Get_Field_Num_t LUCY_SegLex_Get_Field_Num_t
  #define SegLex_Get_Segment LUCY_SegLex_Get_Segment
  #define SegLex_Get_Segment_t LUCY_SegLex_Get_Segment_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGLEXICON */




