/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_PLAN_FULLTEXTTYPE
#define H_LUCY_PLAN_FULLTEXTTYPE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Plan/TextType.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FULLTEXTTYPE
extern uint32_t lucy_FullTextType_IVARS_OFFSET;
typedef struct lucy_FullTextTypeIVARS lucy_FullTextTypeIVARS;
static CFISH_INLINE lucy_FullTextTypeIVARS*
lucy_FullTextType_IVARS(lucy_FullTextType *self) {
   char *ptr = (char*)self + lucy_FullTextType_IVARS_OFFSET;
   return (lucy_FullTextTypeIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define FullTextTypeIVARS lucy_FullTextTypeIVARS
  #define FullTextType_IVARS lucy_FullTextType_IVARS
#endif

struct lucy_FullTextTypeIVARS {
    float boost;
    bool indexed;
    bool stored;
    bool sortable;
    bool highlightable;
    lucy_Analyzer* analyzer;
};

#endif /* C_LUCY_FULLTEXTTYPE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_FullTextType*
lucy_FullTextType_new(lucy_Analyzer* analyzer);

LUCY_VISIBLE lucy_FullTextType*
lucy_FullTextType_init(lucy_FullTextType* self, lucy_Analyzer* analyzer);

LUCY_VISIBLE lucy_FullTextType*
lucy_FullTextType_init2(lucy_FullTextType* self, lucy_Analyzer* analyzer, float boost, bool indexed, bool stored, bool sortable, bool highlightable);

void
LUCY_FullTextType_Set_Highlightable_IMP(lucy_FullTextType* self, bool highlightable);

bool
LUCY_FullTextType_Highlightable_IMP(lucy_FullTextType* self);

lucy_Analyzer*
LUCY_FullTextType_Get_Analyzer_IMP(lucy_FullTextType* self);

lucy_Similarity*
LUCY_FullTextType_Make_Similarity_IMP(lucy_FullTextType* self);

cfish_Hash*
LUCY_FullTextType_Dump_For_Schema_IMP(lucy_FullTextType* self);

cfish_Hash*
LUCY_FullTextType_Dump_IMP(lucy_FullTextType* self);

lucy_FullTextType*
LUCY_FullTextType_Load_IMP(lucy_FullTextType* self, cfish_Obj* dump);

bool
LUCY_FullTextType_Equals_IMP(lucy_FullTextType* self, cfish_Obj* other);

void
LUCY_FullTextType_Destroy_IMP(lucy_FullTextType* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_FullTextType_To_Host_t)(lucy_FullTextType* self, void* vcache);

typedef cfish_Obj*
(*LUCY_FullTextType_Clone_t)(lucy_FullTextType* self);

typedef bool
(*LUCY_FullTextType_Equals_t)(lucy_FullTextType* self, cfish_Obj* other);

typedef int32_t
(*LUCY_FullTextType_Compare_To_t)(lucy_FullTextType* self, cfish_Obj* other);

typedef void
(*LUCY_FullTextType_Destroy_t)(lucy_FullTextType* self);

typedef cfish_String*
(*LUCY_FullTextType_To_String_t)(lucy_FullTextType* self);

typedef void
(*LUCY_FullTextType_Set_Boost_t)(lucy_FullTextType* self, float boost);

typedef float
(*LUCY_FullTextType_Get_Boost_t)(lucy_FullTextType* self);

typedef void
(*LUCY_FullTextType_Set_Indexed_t)(lucy_FullTextType* self, bool indexed);

typedef bool
(*LUCY_FullTextType_Indexed_t)(lucy_FullTextType* self);

typedef void
(*LUCY_FullTextType_Set_Stored_t)(lucy_FullTextType* self, bool stored);

typedef bool
(*LUCY_FullTextType_Stored_t)(lucy_FullTextType* self);

typedef void
(*LUCY_FullTextType_Set_Sortable_t)(lucy_FullTextType* self, bool sortable);

typedef bool
(*LUCY_FullTextType_Sortable_t)(lucy_FullTextType* self);

typedef bool
(*LUCY_FullTextType_Binary_t)(lucy_FullTextType* self);

typedef int32_t
(*LUCY_FullTextType_Compare_Values_t)(lucy_FullTextType* self, cfish_Obj* a, cfish_Obj* b);

typedef lucy_TermStepper*
(*LUCY_FullTextType_Make_Term_Stepper_t)(lucy_FullTextType* self);

typedef int8_t
(*LUCY_FullTextType_Primitive_ID_t)(lucy_FullTextType* self);

typedef cfish_Hash*
(*LUCY_FullTextType_Dump_For_Schema_t)(lucy_FullTextType* self);

typedef cfish_Hash*
(*LUCY_FullTextType_Dump_t)(lucy_FullTextType* self);

typedef lucy_FullTextType*
(*LUCY_FullTextType_Load_t)(lucy_FullTextType* self, cfish_Obj* dump);

typedef void
(*LUCY_FullTextType_Set_Highlightable_t)(lucy_FullTextType* self, bool highlightable);

typedef bool
(*LUCY_FullTextType_Highlightable_t)(lucy_FullTextType* self);

typedef lucy_Analyzer*
(*LUCY_FullTextType_Get_Analyzer_t)(lucy_FullTextType* self);

typedef lucy_Similarity*
(*LUCY_FullTextType_Make_Similarity_t)(lucy_FullTextType* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_FullTextType_get_class(lucy_FullTextType *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_FullTextType_get_class_name(lucy_FullTextType *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_FullTextType_is_a(lucy_FullTextType *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_FullTextType_To_Host(lucy_FullTextType* self, void* vcache) {
    const LUCY_FullTextType_To_Host_t method = (LUCY_FullTextType_To_Host_t)cfish_obj_method(self, LUCY_FullTextType_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_FullTextType_Clone(lucy_FullTextType* self) {
    const LUCY_FullTextType_Clone_t method = (LUCY_FullTextType_Clone_t)cfish_obj_method(self, LUCY_FullTextType_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Equals(lucy_FullTextType* self, cfish_Obj* other) {
    const LUCY_FullTextType_Equals_t method = (LUCY_FullTextType_Equals_t)cfish_obj_method(self, LUCY_FullTextType_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_FullTextType_Compare_To(lucy_FullTextType* self, cfish_Obj* other) {
    const LUCY_FullTextType_Compare_To_t method = (LUCY_FullTextType_Compare_To_t)cfish_obj_method(self, LUCY_FullTextType_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Destroy(lucy_FullTextType* self) {
    const LUCY_FullTextType_Destroy_t method = (LUCY_FullTextType_Destroy_t)cfish_obj_method(self, LUCY_FullTextType_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_FullTextType_To_String(lucy_FullTextType* self) {
    const LUCY_FullTextType_To_String_t method = (LUCY_FullTextType_To_String_t)cfish_obj_method(self, LUCY_FullTextType_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Set_Boost_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Set_Boost(lucy_FullTextType* self, float boost) {
    const LUCY_FullTextType_Set_Boost_t method = (LUCY_FullTextType_Set_Boost_t)cfish_obj_method(self, LUCY_FullTextType_Set_Boost_OFFSET);
    method(self, boost);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Get_Boost_OFFSET;
static CFISH_INLINE float
LUCY_FullTextType_Get_Boost(lucy_FullTextType* self) {
    const LUCY_FullTextType_Get_Boost_t method = (LUCY_FullTextType_Get_Boost_t)cfish_obj_method(self, LUCY_FullTextType_Get_Boost_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Set_Indexed_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Set_Indexed(lucy_FullTextType* self, bool indexed) {
    const LUCY_FullTextType_Set_Indexed_t method = (LUCY_FullTextType_Set_Indexed_t)cfish_obj_method(self, LUCY_FullTextType_Set_Indexed_OFFSET);
    method(self, indexed);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Indexed_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Indexed(lucy_FullTextType* self) {
    const LUCY_FullTextType_Indexed_t method = (LUCY_FullTextType_Indexed_t)cfish_obj_method(self, LUCY_FullTextType_Indexed_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Set_Stored_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Set_Stored(lucy_FullTextType* self, bool stored) {
    const LUCY_FullTextType_Set_Stored_t method = (LUCY_FullTextType_Set_Stored_t)cfish_obj_method(self, LUCY_FullTextType_Set_Stored_OFFSET);
    method(self, stored);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Stored_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Stored(lucy_FullTextType* self) {
    const LUCY_FullTextType_Stored_t method = (LUCY_FullTextType_Stored_t)cfish_obj_method(self, LUCY_FullTextType_Stored_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Set_Sortable_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Set_Sortable(lucy_FullTextType* self, bool sortable) {
    const LUCY_FullTextType_Set_Sortable_t method = (LUCY_FullTextType_Set_Sortable_t)cfish_obj_method(self, LUCY_FullTextType_Set_Sortable_OFFSET);
    method(self, sortable);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Sortable_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Sortable(lucy_FullTextType* self) {
    const LUCY_FullTextType_Sortable_t method = (LUCY_FullTextType_Sortable_t)cfish_obj_method(self, LUCY_FullTextType_Sortable_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Binary_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Binary(lucy_FullTextType* self) {
    const LUCY_FullTextType_Binary_t method = (LUCY_FullTextType_Binary_t)cfish_obj_method(self, LUCY_FullTextType_Binary_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Compare_Values_OFFSET;
static CFISH_INLINE int32_t
LUCY_FullTextType_Compare_Values(lucy_FullTextType* self, cfish_Obj* a, cfish_Obj* b) {
    const LUCY_FullTextType_Compare_Values_t method = (LUCY_FullTextType_Compare_Values_t)cfish_obj_method(self, LUCY_FullTextType_Compare_Values_OFFSET);
    return method(self, a, b);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Make_Term_Stepper_OFFSET;
static CFISH_INLINE lucy_TermStepper*
LUCY_FullTextType_Make_Term_Stepper(lucy_FullTextType* self) {
    const LUCY_FullTextType_Make_Term_Stepper_t method = (LUCY_FullTextType_Make_Term_Stepper_t)cfish_obj_method(self, LUCY_FullTextType_Make_Term_Stepper_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Primitive_ID_OFFSET;
static CFISH_INLINE int8_t
LUCY_FullTextType_Primitive_ID(lucy_FullTextType* self) {
    const LUCY_FullTextType_Primitive_ID_t method = (LUCY_FullTextType_Primitive_ID_t)cfish_obj_method(self, LUCY_FullTextType_Primitive_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Dump_For_Schema_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_FullTextType_Dump_For_Schema(lucy_FullTextType* self) {
    const LUCY_FullTextType_Dump_For_Schema_t method = (LUCY_FullTextType_Dump_For_Schema_t)cfish_obj_method(self, LUCY_FullTextType_Dump_For_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Dump_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_FullTextType_Dump(lucy_FullTextType* self) {
    const LUCY_FullTextType_Dump_t method = (LUCY_FullTextType_Dump_t)cfish_obj_method(self, LUCY_FullTextType_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Load_OFFSET;
static CFISH_INLINE lucy_FullTextType*
LUCY_FullTextType_Load(lucy_FullTextType* self, cfish_Obj* dump) {
    const LUCY_FullTextType_Load_t method = (LUCY_FullTextType_Load_t)cfish_obj_method(self, LUCY_FullTextType_Load_OFFSET);
    return method(self, dump);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Set_Highlightable_OFFSET;
static CFISH_INLINE void
LUCY_FullTextType_Set_Highlightable(lucy_FullTextType* self, bool highlightable) {
    const LUCY_FullTextType_Set_Highlightable_t method = (LUCY_FullTextType_Set_Highlightable_t)cfish_obj_method(self, LUCY_FullTextType_Set_Highlightable_OFFSET);
    method(self, highlightable);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Highlightable_OFFSET;
static CFISH_INLINE bool
LUCY_FullTextType_Highlightable(lucy_FullTextType* self) {
    const LUCY_FullTextType_Highlightable_t method = (LUCY_FullTextType_Highlightable_t)cfish_obj_method(self, LUCY_FullTextType_Highlightable_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Get_Analyzer_OFFSET;
static CFISH_INLINE lucy_Analyzer*
LUCY_FullTextType_Get_Analyzer(lucy_FullTextType* self) {
    const LUCY_FullTextType_Get_Analyzer_t method = (LUCY_FullTextType_Get_Analyzer_t)cfish_obj_method(self, LUCY_FullTextType_Get_Analyzer_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FullTextType_Make_Similarity_OFFSET;
static CFISH_INLINE lucy_Similarity*
LUCY_FullTextType_Make_Similarity(lucy_FullTextType* self) {
    const LUCY_FullTextType_Make_Similarity_t method = (LUCY_FullTextType_Make_Similarity_t)cfish_obj_method(self, LUCY_FullTextType_Make_Similarity_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_FullTextType_Set_Highlightable_OVERRIDE NULL
#define Lucy_FullTextType_Highlightable_OVERRIDE NULL
#define Lucy_FullTextType_Get_Analyzer_OVERRIDE NULL
#define Lucy_FullTextType_Make_Similarity_OVERRIDE NULL
#else
void
Lucy_FullTextType_Set_Highlightable_OVERRIDE(lucy_FullTextType* self, bool highlightable);
bool
Lucy_FullTextType_Highlightable_OVERRIDE(lucy_FullTextType* self);
lucy_Analyzer*
Lucy_FullTextType_Get_Analyzer_OVERRIDE(lucy_FullTextType* self);
lucy_Similarity*
Lucy_FullTextType_Make_Similarity_OVERRIDE(lucy_FullTextType* self);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FullTextType lucy_FullTextType
  #define FULLTEXTTYPE LUCY_FULLTEXTTYPE
  #define FullTextType_new lucy_FullTextType_new
  #define FullTextType_init lucy_FullTextType_init
  #define FullTextType_init2 lucy_FullTextType_init2
  #define FullTextType_get_class lucy_FullTextType_get_class
  #define FullTextType_get_class_name lucy_FullTextType_get_class_name
  #define FullTextType_is_a lucy_FullTextType_is_a
  #define FullTextType_Set_Highlightable_IMP LUCY_FullTextType_Set_Highlightable_IMP
  #define FullTextType_Highlightable_IMP LUCY_FullTextType_Highlightable_IMP
  #define FullTextType_Get_Analyzer_IMP LUCY_FullTextType_Get_Analyzer_IMP
  #define FullTextType_Make_Similarity_IMP LUCY_FullTextType_Make_Similarity_IMP
  #define FullTextType_Dump_For_Schema_IMP LUCY_FullTextType_Dump_For_Schema_IMP
  #define FullTextType_Dump_IMP LUCY_FullTextType_Dump_IMP
  #define FullTextType_Load_IMP LUCY_FullTextType_Load_IMP
  #define FullTextType_Equals_IMP LUCY_FullTextType_Equals_IMP
  #define FullTextType_Destroy_IMP LUCY_FullTextType_Destroy_IMP
  #define FullTextType_To_Host LUCY_FullTextType_To_Host
  #define FullTextType_To_Host_t LUCY_FullTextType_To_Host_t
  #define FullTextType_Clone LUCY_FullTextType_Clone
  #define FullTextType_Clone_t LUCY_FullTextType_Clone_t
  #define FullTextType_Equals LUCY_FullTextType_Equals
  #define FullTextType_Equals_t LUCY_FullTextType_Equals_t
  #define FullTextType_Compare_To LUCY_FullTextType_Compare_To
  #define FullTextType_Compare_To_t LUCY_FullTextType_Compare_To_t
  #define FullTextType_Destroy LUCY_FullTextType_Destroy
  #define FullTextType_Destroy_t LUCY_FullTextType_Destroy_t
  #define FullTextType_To_String LUCY_FullTextType_To_String
  #define FullTextType_To_String_t LUCY_FullTextType_To_String_t
  #define FullTextType_Set_Boost LUCY_FullTextType_Set_Boost
  #define FullTextType_Set_Boost_t LUCY_FullTextType_Set_Boost_t
  #define FullTextType_Get_Boost LUCY_FullTextType_Get_Boost
  #define FullTextType_Get_Boost_t LUCY_FullTextType_Get_Boost_t
  #define FullTextType_Set_Indexed LUCY_FullTextType_Set_Indexed
  #define FullTextType_Set_Indexed_t LUCY_FullTextType_Set_Indexed_t
  #define FullTextType_Indexed LUCY_FullTextType_Indexed
  #define FullTextType_Indexed_t LUCY_FullTextType_Indexed_t
  #define FullTextType_Set_Stored LUCY_FullTextType_Set_Stored
  #define FullTextType_Set_Stored_t LUCY_FullTextType_Set_Stored_t
  #define FullTextType_Stored LUCY_FullTextType_Stored
  #define FullTextType_Stored_t LUCY_FullTextType_Stored_t
  #define FullTextType_Set_Sortable LUCY_FullTextType_Set_Sortable
  #define FullTextType_Set_Sortable_t LUCY_FullTextType_Set_Sortable_t
  #define FullTextType_Sortable LUCY_FullTextType_Sortable
  #define FullTextType_Sortable_t LUCY_FullTextType_Sortable_t
  #define FullTextType_Binary LUCY_FullTextType_Binary
  #define FullTextType_Binary_t LUCY_FullTextType_Binary_t
  #define FullTextType_Compare_Values LUCY_FullTextType_Compare_Values
  #define FullTextType_Compare_Values_t LUCY_FullTextType_Compare_Values_t
  #define FullTextType_Make_Term_Stepper LUCY_FullTextType_Make_Term_Stepper
  #define FullTextType_Make_Term_Stepper_t LUCY_FullTextType_Make_Term_Stepper_t
  #define FullTextType_Primitive_ID LUCY_FullTextType_Primitive_ID
  #define FullTextType_Primitive_ID_t LUCY_FullTextType_Primitive_ID_t
  #define FullTextType_Dump_For_Schema LUCY_FullTextType_Dump_For_Schema
  #define FullTextType_Dump_For_Schema_t LUCY_FullTextType_Dump_For_Schema_t
  #define FullTextType_Dump LUCY_FullTextType_Dump
  #define FullTextType_Dump_t LUCY_FullTextType_Dump_t
  #define FullTextType_Load LUCY_FullTextType_Load
  #define FullTextType_Load_t LUCY_FullTextType_Load_t
  #define FullTextType_Set_Highlightable LUCY_FullTextType_Set_Highlightable
  #define FullTextType_Set_Highlightable_t LUCY_FullTextType_Set_Highlightable_t
  #define FullTextType_Highlightable LUCY_FullTextType_Highlightable
  #define FullTextType_Highlightable_t LUCY_FullTextType_Highlightable_t
  #define FullTextType_Get_Analyzer LUCY_FullTextType_Get_Analyzer
  #define FullTextType_Get_Analyzer_t LUCY_FullTextType_Get_Analyzer_t
  #define FullTextType_Make_Similarity LUCY_FullTextType_Make_Similarity
  #define FullTextType_Make_Similarity_t LUCY_FullTextType_Make_Similarity_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_PLAN_FULLTEXTTYPE */




