/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_SEARCH_BITVECMATCHER
#define H_LUCY_SEARCH_BITVECMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BITVECMATCHER
extern uint32_t lucy_BitVecMatcher_IVARS_OFFSET;
typedef struct lucy_BitVecMatcherIVARS lucy_BitVecMatcherIVARS;
static CFISH_INLINE lucy_BitVecMatcherIVARS*
lucy_BitVecMatcher_IVARS(lucy_BitVecMatcher *self) {
   char *ptr = (char*)self + lucy_BitVecMatcher_IVARS_OFFSET;
   return (lucy_BitVecMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define BitVecMatcherIVARS lucy_BitVecMatcherIVARS
  #define BitVecMatcher_IVARS lucy_BitVecMatcher_IVARS
#endif

struct lucy_BitVecMatcherIVARS {
    lucy_BitVector* bit_vec;
    int32_t doc_id;
};

#endif /* C_LUCY_BITVECMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_BitVecMatcher*
lucy_BitVecMatcher_new(lucy_BitVector* bit_vector);

LUCY_VISIBLE lucy_BitVecMatcher*
lucy_BitVecMatcher_init(lucy_BitVecMatcher* self, lucy_BitVector* bit_vector);

int32_t
LUCY_BitVecMatcher_Next_IMP(lucy_BitVecMatcher* self);

int32_t
LUCY_BitVecMatcher_Advance_IMP(lucy_BitVecMatcher* self, int32_t target);

int32_t
LUCY_BitVecMatcher_Get_Doc_ID_IMP(lucy_BitVecMatcher* self);

void
LUCY_BitVecMatcher_Destroy_IMP(lucy_BitVecMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_BitVecMatcher_To_Host_t)(lucy_BitVecMatcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_BitVecMatcher_Clone_t)(lucy_BitVecMatcher* self);

typedef bool
(*LUCY_BitVecMatcher_Equals_t)(lucy_BitVecMatcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_BitVecMatcher_Compare_To_t)(lucy_BitVecMatcher* self, cfish_Obj* other);

typedef void
(*LUCY_BitVecMatcher_Destroy_t)(lucy_BitVecMatcher* self);

typedef cfish_String*
(*LUCY_BitVecMatcher_To_String_t)(lucy_BitVecMatcher* self);

typedef int32_t
(*LUCY_BitVecMatcher_Next_t)(lucy_BitVecMatcher* self);

typedef int32_t
(*LUCY_BitVecMatcher_Advance_t)(lucy_BitVecMatcher* self, int32_t target);

typedef int32_t
(*LUCY_BitVecMatcher_Get_Doc_ID_t)(lucy_BitVecMatcher* self);

typedef float
(*LUCY_BitVecMatcher_Score_t)(lucy_BitVecMatcher* self);

typedef void
(*LUCY_BitVecMatcher_Collect_t)(lucy_BitVecMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_BitVecMatcher_get_class(lucy_BitVecMatcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_BitVecMatcher_get_class_name(lucy_BitVecMatcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_BitVecMatcher_is_a(lucy_BitVecMatcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_BitVecMatcher_To_Host(lucy_BitVecMatcher* self, void* vcache) {
    const LUCY_BitVecMatcher_To_Host_t method = (LUCY_BitVecMatcher_To_Host_t)cfish_obj_method(self, LUCY_BitVecMatcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BitVecMatcher_Clone(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_Clone_t method = (LUCY_BitVecMatcher_Clone_t)cfish_obj_method(self, LUCY_BitVecMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_BitVecMatcher_Equals(lucy_BitVecMatcher* self, cfish_Obj* other) {
    const LUCY_BitVecMatcher_Equals_t method = (LUCY_BitVecMatcher_Equals_t)cfish_obj_method(self, LUCY_BitVecMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_BitVecMatcher_Compare_To(lucy_BitVecMatcher* self, cfish_Obj* other) {
    const LUCY_BitVecMatcher_Compare_To_t method = (LUCY_BitVecMatcher_Compare_To_t)cfish_obj_method(self, LUCY_BitVecMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_BitVecMatcher_Destroy(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_Destroy_t method = (LUCY_BitVecMatcher_Destroy_t)cfish_obj_method(self, LUCY_BitVecMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_BitVecMatcher_To_String(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_To_String_t method = (LUCY_BitVecMatcher_To_String_t)cfish_obj_method(self, LUCY_BitVecMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_BitVecMatcher_Next(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_Next_t method = (LUCY_BitVecMatcher_Next_t)cfish_obj_method(self, LUCY_BitVecMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_BitVecMatcher_Advance(lucy_BitVecMatcher* self, int32_t target) {
    const LUCY_BitVecMatcher_Advance_t method = (LUCY_BitVecMatcher_Advance_t)cfish_obj_method(self, LUCY_BitVecMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_BitVecMatcher_Get_Doc_ID(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_Get_Doc_ID_t method = (LUCY_BitVecMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_BitVecMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_BitVecMatcher_Score(lucy_BitVecMatcher* self) {
    const LUCY_BitVecMatcher_Score_t method = (LUCY_BitVecMatcher_Score_t)cfish_obj_method(self, LUCY_BitVecMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_BitVecMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_BitVecMatcher_Collect(lucy_BitVecMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_BitVecMatcher_Collect_t method = (LUCY_BitVecMatcher_Collect_t)cfish_obj_method(self, LUCY_BitVecMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define BitVecMatcher lucy_BitVecMatcher
  #define BITVECMATCHER LUCY_BITVECMATCHER
  #define BitVecMatcher_new lucy_BitVecMatcher_new
  #define BitVecMatcher_init lucy_BitVecMatcher_init
  #define BitVecMatcher_get_class lucy_BitVecMatcher_get_class
  #define BitVecMatcher_get_class_name lucy_BitVecMatcher_get_class_name
  #define BitVecMatcher_is_a lucy_BitVecMatcher_is_a
  #define BitVecMatcher_Next_IMP LUCY_BitVecMatcher_Next_IMP
  #define BitVecMatcher_Advance_IMP LUCY_BitVecMatcher_Advance_IMP
  #define BitVecMatcher_Get_Doc_ID_IMP LUCY_BitVecMatcher_Get_Doc_ID_IMP
  #define BitVecMatcher_Destroy_IMP LUCY_BitVecMatcher_Destroy_IMP
  #define BitVecMatcher_To_Host LUCY_BitVecMatcher_To_Host
  #define BitVecMatcher_To_Host_t LUCY_BitVecMatcher_To_Host_t
  #define BitVecMatcher_Clone LUCY_BitVecMatcher_Clone
  #define BitVecMatcher_Clone_t LUCY_BitVecMatcher_Clone_t
  #define BitVecMatcher_Equals LUCY_BitVecMatcher_Equals
  #define BitVecMatcher_Equals_t LUCY_BitVecMatcher_Equals_t
  #define BitVecMatcher_Compare_To LUCY_BitVecMatcher_Compare_To
  #define BitVecMatcher_Compare_To_t LUCY_BitVecMatcher_Compare_To_t
  #define BitVecMatcher_Destroy LUCY_BitVecMatcher_Destroy
  #define BitVecMatcher_Destroy_t LUCY_BitVecMatcher_Destroy_t
  #define BitVecMatcher_To_String LUCY_BitVecMatcher_To_String
  #define BitVecMatcher_To_String_t LUCY_BitVecMatcher_To_String_t
  #define BitVecMatcher_Next LUCY_BitVecMatcher_Next
  #define BitVecMatcher_Next_t LUCY_BitVecMatcher_Next_t
  #define BitVecMatcher_Advance LUCY_BitVecMatcher_Advance
  #define BitVecMatcher_Advance_t LUCY_BitVecMatcher_Advance_t
  #define BitVecMatcher_Get_Doc_ID LUCY_BitVecMatcher_Get_Doc_ID
  #define BitVecMatcher_Get_Doc_ID_t LUCY_BitVecMatcher_Get_Doc_ID_t
  #define BitVecMatcher_Score LUCY_BitVecMatcher_Score
  #define BitVecMatcher_Score_t LUCY_BitVecMatcher_Score_t
  #define BitVecMatcher_Collect LUCY_BitVecMatcher_Collect
  #define BitVecMatcher_Collect_t LUCY_BitVecMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_BITVECMATCHER */




