/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_SEARCH_POLYMATCHER
#define H_LUCY_SEARCH_POLYMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYMATCHER
extern uint32_t lucy_PolyMatcher_IVARS_OFFSET;
typedef struct lucy_PolyMatcherIVARS lucy_PolyMatcherIVARS;
static CFISH_INLINE lucy_PolyMatcherIVARS*
lucy_PolyMatcher_IVARS(lucy_PolyMatcher *self) {
   char *ptr = (char*)self + lucy_PolyMatcher_IVARS_OFFSET;
   return (lucy_PolyMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define PolyMatcherIVARS lucy_PolyMatcherIVARS
  #define PolyMatcher_IVARS lucy_PolyMatcher_IVARS
#endif

struct lucy_PolyMatcherIVARS {
    cfish_Vector* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
};

#endif /* C_LUCY_POLYMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_PolyMatcher*
lucy_PolyMatcher_new(cfish_Vector* children, lucy_Similarity* similarity);

LUCY_VISIBLE lucy_PolyMatcher*
lucy_PolyMatcher_init(lucy_PolyMatcher* self, cfish_Vector* children, lucy_Similarity* similarity);

void
LUCY_PolyMatcher_Destroy_IMP(lucy_PolyMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_PolyMatcher_To_Host_t)(lucy_PolyMatcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_PolyMatcher_Clone_t)(lucy_PolyMatcher* self);

typedef bool
(*LUCY_PolyMatcher_Equals_t)(lucy_PolyMatcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_PolyMatcher_Compare_To_t)(lucy_PolyMatcher* self, cfish_Obj* other);

typedef void
(*LUCY_PolyMatcher_Destroy_t)(lucy_PolyMatcher* self);

typedef cfish_String*
(*LUCY_PolyMatcher_To_String_t)(lucy_PolyMatcher* self);

typedef int32_t
(*LUCY_PolyMatcher_Next_t)(lucy_PolyMatcher* self);

typedef int32_t
(*LUCY_PolyMatcher_Advance_t)(lucy_PolyMatcher* self, int32_t target);

typedef int32_t
(*LUCY_PolyMatcher_Get_Doc_ID_t)(lucy_PolyMatcher* self);

typedef float
(*LUCY_PolyMatcher_Score_t)(lucy_PolyMatcher* self);

typedef void
(*LUCY_PolyMatcher_Collect_t)(lucy_PolyMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_PolyMatcher_get_class(lucy_PolyMatcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_PolyMatcher_get_class_name(lucy_PolyMatcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_PolyMatcher_is_a(lucy_PolyMatcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_PolyMatcher_To_Host(lucy_PolyMatcher* self, void* vcache) {
    const LUCY_PolyMatcher_To_Host_t method = (LUCY_PolyMatcher_To_Host_t)cfish_obj_method(self, LUCY_PolyMatcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PolyMatcher_Clone(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_Clone_t method = (LUCY_PolyMatcher_Clone_t)cfish_obj_method(self, LUCY_PolyMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_PolyMatcher_Equals(lucy_PolyMatcher* self, cfish_Obj* other) {
    const LUCY_PolyMatcher_Equals_t method = (LUCY_PolyMatcher_Equals_t)cfish_obj_method(self, LUCY_PolyMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyMatcher_Compare_To(lucy_PolyMatcher* self, cfish_Obj* other) {
    const LUCY_PolyMatcher_Compare_To_t method = (LUCY_PolyMatcher_Compare_To_t)cfish_obj_method(self, LUCY_PolyMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_PolyMatcher_Destroy(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_Destroy_t method = (LUCY_PolyMatcher_Destroy_t)cfish_obj_method(self, LUCY_PolyMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PolyMatcher_To_String(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_To_String_t method = (LUCY_PolyMatcher_To_String_t)cfish_obj_method(self, LUCY_PolyMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyMatcher_Next(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_Next_t method = (LUCY_PolyMatcher_Next_t)cfish_obj_method(self, LUCY_PolyMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyMatcher_Advance(lucy_PolyMatcher* self, int32_t target) {
    const LUCY_PolyMatcher_Advance_t method = (LUCY_PolyMatcher_Advance_t)cfish_obj_method(self, LUCY_PolyMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyMatcher_Get_Doc_ID(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_Get_Doc_ID_t method = (LUCY_PolyMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_PolyMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_PolyMatcher_Score(lucy_PolyMatcher* self) {
    const LUCY_PolyMatcher_Score_t method = (LUCY_PolyMatcher_Score_t)cfish_obj_method(self, LUCY_PolyMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolyMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_PolyMatcher_Collect(lucy_PolyMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_PolyMatcher_Collect_t method = (LUCY_PolyMatcher_Collect_t)cfish_obj_method(self, LUCY_PolyMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyMatcher lucy_PolyMatcher
  #define POLYMATCHER LUCY_POLYMATCHER
  #define PolyMatcher_new lucy_PolyMatcher_new
  #define PolyMatcher_init lucy_PolyMatcher_init
  #define PolyMatcher_get_class lucy_PolyMatcher_get_class
  #define PolyMatcher_get_class_name lucy_PolyMatcher_get_class_name
  #define PolyMatcher_is_a lucy_PolyMatcher_is_a
  #define PolyMatcher_Destroy_IMP LUCY_PolyMatcher_Destroy_IMP
  #define PolyMatcher_To_Host LUCY_PolyMatcher_To_Host
  #define PolyMatcher_To_Host_t LUCY_PolyMatcher_To_Host_t
  #define PolyMatcher_Clone LUCY_PolyMatcher_Clone
  #define PolyMatcher_Clone_t LUCY_PolyMatcher_Clone_t
  #define PolyMatcher_Equals LUCY_PolyMatcher_Equals
  #define PolyMatcher_Equals_t LUCY_PolyMatcher_Equals_t
  #define PolyMatcher_Compare_To LUCY_PolyMatcher_Compare_To
  #define PolyMatcher_Compare_To_t LUCY_PolyMatcher_Compare_To_t
  #define PolyMatcher_Destroy LUCY_PolyMatcher_Destroy
  #define PolyMatcher_Destroy_t LUCY_PolyMatcher_Destroy_t
  #define PolyMatcher_To_String LUCY_PolyMatcher_To_String
  #define PolyMatcher_To_String_t LUCY_PolyMatcher_To_String_t
  #define PolyMatcher_Next LUCY_PolyMatcher_Next
  #define PolyMatcher_Next_t LUCY_PolyMatcher_Next_t
  #define PolyMatcher_Advance LUCY_PolyMatcher_Advance
  #define PolyMatcher_Advance_t LUCY_PolyMatcher_Advance_t
  #define PolyMatcher_Get_Doc_ID LUCY_PolyMatcher_Get_Doc_ID
  #define PolyMatcher_Get_Doc_ID_t LUCY_PolyMatcher_Get_Doc_ID_t
  #define PolyMatcher_Score LUCY_PolyMatcher_Score
  #define PolyMatcher_Score_t LUCY_PolyMatcher_Score_t
  #define PolyMatcher_Collect LUCY_PolyMatcher_Collect
  #define PolyMatcher_Collect_t LUCY_PolyMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_POLYMATCHER */




