/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_SEARCH_POLYSEARCHER
#define H_LUCY_SEARCH_POLYSEARCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Searcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYSEARCHER
extern uint32_t lucy_PolySearcher_IVARS_OFFSET;
typedef struct lucy_PolySearcherIVARS lucy_PolySearcherIVARS;
static CFISH_INLINE lucy_PolySearcherIVARS*
lucy_PolySearcher_IVARS(lucy_PolySearcher *self) {
   char *ptr = (char*)self + lucy_PolySearcher_IVARS_OFFSET;
   return (lucy_PolySearcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define PolySearcherIVARS lucy_PolySearcherIVARS
  #define PolySearcher_IVARS lucy_PolySearcher_IVARS
#endif

struct lucy_PolySearcherIVARS {
    lucy_Schema* schema;
    lucy_QueryParser* qparser;
    cfish_Vector* searchers;
    lucy_I32Array* starts;
    int32_t doc_max;
};

#endif /* C_LUCY_POLYSEARCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_PolySearcher*
lucy_PolySearcher_new(lucy_Schema* schema, cfish_Vector* searchers);

LUCY_VISIBLE lucy_PolySearcher*
lucy_PolySearcher_init(lucy_PolySearcher* self, lucy_Schema* schema, cfish_Vector* searchers);

void
LUCY_PolySearcher_Destroy_IMP(lucy_PolySearcher* self);

int32_t
LUCY_PolySearcher_Doc_Max_IMP(lucy_PolySearcher* self);

uint32_t
LUCY_PolySearcher_Doc_Freq_IMP(lucy_PolySearcher* self, cfish_String* field, cfish_Obj* term);

void
LUCY_PolySearcher_Collect_IMP(lucy_PolySearcher* self, lucy_Query* query, lucy_Collector* collector);

lucy_TopDocs*
LUCY_PolySearcher_Top_Docs_IMP(lucy_PolySearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

lucy_HitDoc*
LUCY_PolySearcher_Fetch_Doc_IMP(lucy_PolySearcher* self, int32_t doc_id);

lucy_DocVector*
LUCY_PolySearcher_Fetch_Doc_Vec_IMP(lucy_PolySearcher* self, int32_t doc_id);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_PolySearcher_To_Host_t)(lucy_PolySearcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_PolySearcher_Clone_t)(lucy_PolySearcher* self);

typedef bool
(*LUCY_PolySearcher_Equals_t)(lucy_PolySearcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_PolySearcher_Compare_To_t)(lucy_PolySearcher* self, cfish_Obj* other);

typedef void
(*LUCY_PolySearcher_Destroy_t)(lucy_PolySearcher* self);

typedef cfish_String*
(*LUCY_PolySearcher_To_String_t)(lucy_PolySearcher* self);

typedef int32_t
(*LUCY_PolySearcher_Doc_Max_t)(lucy_PolySearcher* self);

typedef uint32_t
(*LUCY_PolySearcher_Doc_Freq_t)(lucy_PolySearcher* self, cfish_String* field, cfish_Obj* term);

typedef lucy_Query*
(*LUCY_PolySearcher_Glean_Query_t)(lucy_PolySearcher* self, cfish_Obj* query);

typedef lucy_Hits*
(*LUCY_PolySearcher_Hits_t)(lucy_PolySearcher* self, cfish_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef void
(*LUCY_PolySearcher_Collect_t)(lucy_PolySearcher* self, lucy_Query* query, lucy_Collector* collector);

typedef lucy_TopDocs*
(*LUCY_PolySearcher_Top_Docs_t)(lucy_PolySearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef lucy_HitDoc*
(*LUCY_PolySearcher_Fetch_Doc_t)(lucy_PolySearcher* self, int32_t doc_id);

typedef lucy_DocVector*
(*LUCY_PolySearcher_Fetch_Doc_Vec_t)(lucy_PolySearcher* self, int32_t doc_id);

typedef lucy_Schema*
(*LUCY_PolySearcher_Get_Schema_t)(lucy_PolySearcher* self);

typedef void
(*LUCY_PolySearcher_Close_t)(lucy_PolySearcher* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_PolySearcher_get_class(lucy_PolySearcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_PolySearcher_get_class_name(lucy_PolySearcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_PolySearcher_is_a(lucy_PolySearcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_PolySearcher_To_Host(lucy_PolySearcher* self, void* vcache) {
    const LUCY_PolySearcher_To_Host_t method = (LUCY_PolySearcher_To_Host_t)cfish_obj_method(self, LUCY_PolySearcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PolySearcher_Clone(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_Clone_t method = (LUCY_PolySearcher_Clone_t)cfish_obj_method(self, LUCY_PolySearcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_PolySearcher_Equals(lucy_PolySearcher* self, cfish_Obj* other) {
    const LUCY_PolySearcher_Equals_t method = (LUCY_PolySearcher_Equals_t)cfish_obj_method(self, LUCY_PolySearcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolySearcher_Compare_To(lucy_PolySearcher* self, cfish_Obj* other) {
    const LUCY_PolySearcher_Compare_To_t method = (LUCY_PolySearcher_Compare_To_t)cfish_obj_method(self, LUCY_PolySearcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_PolySearcher_Destroy(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_Destroy_t method = (LUCY_PolySearcher_Destroy_t)cfish_obj_method(self, LUCY_PolySearcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PolySearcher_To_String(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_To_String_t method = (LUCY_PolySearcher_To_String_t)cfish_obj_method(self, LUCY_PolySearcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Doc_Max_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolySearcher_Doc_Max(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_Doc_Max_t method = (LUCY_PolySearcher_Doc_Max_t)cfish_obj_method(self, LUCY_PolySearcher_Doc_Max_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Doc_Freq_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PolySearcher_Doc_Freq(lucy_PolySearcher* self, cfish_String* field, cfish_Obj* term) {
    const LUCY_PolySearcher_Doc_Freq_t method = (LUCY_PolySearcher_Doc_Freq_t)cfish_obj_method(self, LUCY_PolySearcher_Doc_Freq_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Glean_Query_OFFSET;
static CFISH_INLINE lucy_Query*
LUCY_PolySearcher_Glean_Query(lucy_PolySearcher* self, cfish_Obj* query) {
    const LUCY_PolySearcher_Glean_Query_t method = (LUCY_PolySearcher_Glean_Query_t)cfish_obj_method(self, LUCY_PolySearcher_Glean_Query_OFFSET);
    return method(self, query);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Hits_OFFSET;
static CFISH_INLINE lucy_Hits*
LUCY_PolySearcher_Hits(lucy_PolySearcher* self, cfish_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    const LUCY_PolySearcher_Hits_t method = (LUCY_PolySearcher_Hits_t)cfish_obj_method(self, LUCY_PolySearcher_Hits_OFFSET);
    return method(self, query, offset, num_wanted, sort_spec);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_PolySearcher_Collect(lucy_PolySearcher* self, lucy_Query* query, lucy_Collector* collector) {
    const LUCY_PolySearcher_Collect_t method = (LUCY_PolySearcher_Collect_t)cfish_obj_method(self, LUCY_PolySearcher_Collect_OFFSET);
    method(self, query, collector);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Top_Docs_OFFSET;
static CFISH_INLINE lucy_TopDocs*
LUCY_PolySearcher_Top_Docs(lucy_PolySearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    const LUCY_PolySearcher_Top_Docs_t method = (LUCY_PolySearcher_Top_Docs_t)cfish_obj_method(self, LUCY_PolySearcher_Top_Docs_OFFSET);
    return method(self, query, num_wanted, sort_spec);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Fetch_Doc_OFFSET;
static CFISH_INLINE lucy_HitDoc*
LUCY_PolySearcher_Fetch_Doc(lucy_PolySearcher* self, int32_t doc_id) {
    const LUCY_PolySearcher_Fetch_Doc_t method = (LUCY_PolySearcher_Fetch_Doc_t)cfish_obj_method(self, LUCY_PolySearcher_Fetch_Doc_OFFSET);
    return method(self, doc_id);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Fetch_Doc_Vec_OFFSET;
static CFISH_INLINE lucy_DocVector*
LUCY_PolySearcher_Fetch_Doc_Vec(lucy_PolySearcher* self, int32_t doc_id) {
    const LUCY_PolySearcher_Fetch_Doc_Vec_t method = (LUCY_PolySearcher_Fetch_Doc_Vec_t)cfish_obj_method(self, LUCY_PolySearcher_Fetch_Doc_Vec_OFFSET);
    return method(self, doc_id);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_PolySearcher_Get_Schema(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_Get_Schema_t method = (LUCY_PolySearcher_Get_Schema_t)cfish_obj_method(self, LUCY_PolySearcher_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_PolySearcher_Close_OFFSET;
static CFISH_INLINE void
LUCY_PolySearcher_Close(lucy_PolySearcher* self) {
    const LUCY_PolySearcher_Close_t method = (LUCY_PolySearcher_Close_t)cfish_obj_method(self, LUCY_PolySearcher_Close_OFFSET);
    method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolySearcher lucy_PolySearcher
  #define POLYSEARCHER LUCY_POLYSEARCHER
  #define PolySearcher_new lucy_PolySearcher_new
  #define PolySearcher_init lucy_PolySearcher_init
  #define PolySearcher_get_class lucy_PolySearcher_get_class
  #define PolySearcher_get_class_name lucy_PolySearcher_get_class_name
  #define PolySearcher_is_a lucy_PolySearcher_is_a
  #define PolySearcher_Destroy_IMP LUCY_PolySearcher_Destroy_IMP
  #define PolySearcher_Doc_Max_IMP LUCY_PolySearcher_Doc_Max_IMP
  #define PolySearcher_Doc_Freq_IMP LUCY_PolySearcher_Doc_Freq_IMP
  #define PolySearcher_Collect_IMP LUCY_PolySearcher_Collect_IMP
  #define PolySearcher_Top_Docs_IMP LUCY_PolySearcher_Top_Docs_IMP
  #define PolySearcher_Fetch_Doc_IMP LUCY_PolySearcher_Fetch_Doc_IMP
  #define PolySearcher_Fetch_Doc_Vec_IMP LUCY_PolySearcher_Fetch_Doc_Vec_IMP
  #define PolySearcher_To_Host LUCY_PolySearcher_To_Host
  #define PolySearcher_To_Host_t LUCY_PolySearcher_To_Host_t
  #define PolySearcher_Clone LUCY_PolySearcher_Clone
  #define PolySearcher_Clone_t LUCY_PolySearcher_Clone_t
  #define PolySearcher_Equals LUCY_PolySearcher_Equals
  #define PolySearcher_Equals_t LUCY_PolySearcher_Equals_t
  #define PolySearcher_Compare_To LUCY_PolySearcher_Compare_To
  #define PolySearcher_Compare_To_t LUCY_PolySearcher_Compare_To_t
  #define PolySearcher_Destroy LUCY_PolySearcher_Destroy
  #define PolySearcher_Destroy_t LUCY_PolySearcher_Destroy_t
  #define PolySearcher_To_String LUCY_PolySearcher_To_String
  #define PolySearcher_To_String_t LUCY_PolySearcher_To_String_t
  #define PolySearcher_Doc_Max LUCY_PolySearcher_Doc_Max
  #define PolySearcher_Doc_Max_t LUCY_PolySearcher_Doc_Max_t
  #define PolySearcher_Doc_Freq LUCY_PolySearcher_Doc_Freq
  #define PolySearcher_Doc_Freq_t LUCY_PolySearcher_Doc_Freq_t
  #define PolySearcher_Glean_Query LUCY_PolySearcher_Glean_Query
  #define PolySearcher_Glean_Query_t LUCY_PolySearcher_Glean_Query_t
  #define PolySearcher_Hits LUCY_PolySearcher_Hits
  #define PolySearcher_Hits_t LUCY_PolySearcher_Hits_t
  #define PolySearcher_Collect LUCY_PolySearcher_Collect
  #define PolySearcher_Collect_t LUCY_PolySearcher_Collect_t
  #define PolySearcher_Top_Docs LUCY_PolySearcher_Top_Docs
  #define PolySearcher_Top_Docs_t LUCY_PolySearcher_Top_Docs_t
  #define PolySearcher_Fetch_Doc LUCY_PolySearcher_Fetch_Doc
  #define PolySearcher_Fetch_Doc_t LUCY_PolySearcher_Fetch_Doc_t
  #define PolySearcher_Fetch_Doc_Vec LUCY_PolySearcher_Fetch_Doc_Vec
  #define PolySearcher_Fetch_Doc_Vec_t LUCY_PolySearcher_Fetch_Doc_Vec_t
  #define PolySearcher_Get_Schema LUCY_PolySearcher_Get_Schema
  #define PolySearcher_Get_Schema_t LUCY_PolySearcher_Get_Schema_t
  #define PolySearcher_Close LUCY_PolySearcher_Close
  #define PolySearcher_Close_t LUCY_PolySearcher_Close_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_POLYSEARCHER */




