/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_SEARCH_SERIESMATCHER
#define H_LUCY_SEARCH_SERIESMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SERIESMATCHER
extern uint32_t lucy_SeriesMatcher_IVARS_OFFSET;
typedef struct lucy_SeriesMatcherIVARS lucy_SeriesMatcherIVARS;
static CFISH_INLINE lucy_SeriesMatcherIVARS*
lucy_SeriesMatcher_IVARS(lucy_SeriesMatcher *self) {
   char *ptr = (char*)self + lucy_SeriesMatcher_IVARS_OFFSET;
   return (lucy_SeriesMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SeriesMatcherIVARS lucy_SeriesMatcherIVARS
  #define SeriesMatcher_IVARS lucy_SeriesMatcher_IVARS
#endif

struct lucy_SeriesMatcherIVARS {
    lucy_I32Array* offsets;
    cfish_Vector* matchers;
    lucy_Matcher* current_matcher;
    int32_t doc_id;
    int32_t tick;
    int32_t num_matchers;
    int32_t current_offset;
    int32_t next_offset;
};

#endif /* C_LUCY_SERIESMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_SeriesMatcher*
lucy_SeriesMatcher_new(cfish_Vector* matchers, lucy_I32Array* offsets);

LUCY_VISIBLE lucy_SeriesMatcher*
lucy_SeriesMatcher_init(lucy_SeriesMatcher* self, cfish_Vector* matchers, lucy_I32Array* offsets);

int32_t
LUCY_SeriesMatcher_Next_IMP(lucy_SeriesMatcher* self);

int32_t
LUCY_SeriesMatcher_Advance_IMP(lucy_SeriesMatcher* self, int32_t target);

int32_t
LUCY_SeriesMatcher_Get_Doc_ID_IMP(lucy_SeriesMatcher* self);

void
LUCY_SeriesMatcher_Destroy_IMP(lucy_SeriesMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_SeriesMatcher_To_Host_t)(lucy_SeriesMatcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_SeriesMatcher_Clone_t)(lucy_SeriesMatcher* self);

typedef bool
(*LUCY_SeriesMatcher_Equals_t)(lucy_SeriesMatcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_SeriesMatcher_Compare_To_t)(lucy_SeriesMatcher* self, cfish_Obj* other);

typedef void
(*LUCY_SeriesMatcher_Destroy_t)(lucy_SeriesMatcher* self);

typedef cfish_String*
(*LUCY_SeriesMatcher_To_String_t)(lucy_SeriesMatcher* self);

typedef int32_t
(*LUCY_SeriesMatcher_Next_t)(lucy_SeriesMatcher* self);

typedef int32_t
(*LUCY_SeriesMatcher_Advance_t)(lucy_SeriesMatcher* self, int32_t target);

typedef int32_t
(*LUCY_SeriesMatcher_Get_Doc_ID_t)(lucy_SeriesMatcher* self);

typedef float
(*LUCY_SeriesMatcher_Score_t)(lucy_SeriesMatcher* self);

typedef void
(*LUCY_SeriesMatcher_Collect_t)(lucy_SeriesMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_SeriesMatcher_get_class(lucy_SeriesMatcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_SeriesMatcher_get_class_name(lucy_SeriesMatcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_SeriesMatcher_is_a(lucy_SeriesMatcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_SeriesMatcher_To_Host(lucy_SeriesMatcher* self, void* vcache) {
    const LUCY_SeriesMatcher_To_Host_t method = (LUCY_SeriesMatcher_To_Host_t)cfish_obj_method(self, LUCY_SeriesMatcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SeriesMatcher_Clone(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_Clone_t method = (LUCY_SeriesMatcher_Clone_t)cfish_obj_method(self, LUCY_SeriesMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_SeriesMatcher_Equals(lucy_SeriesMatcher* self, cfish_Obj* other) {
    const LUCY_SeriesMatcher_Equals_t method = (LUCY_SeriesMatcher_Equals_t)cfish_obj_method(self, LUCY_SeriesMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_SeriesMatcher_Compare_To(lucy_SeriesMatcher* self, cfish_Obj* other) {
    const LUCY_SeriesMatcher_Compare_To_t method = (LUCY_SeriesMatcher_Compare_To_t)cfish_obj_method(self, LUCY_SeriesMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_SeriesMatcher_Destroy(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_Destroy_t method = (LUCY_SeriesMatcher_Destroy_t)cfish_obj_method(self, LUCY_SeriesMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SeriesMatcher_To_String(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_To_String_t method = (LUCY_SeriesMatcher_To_String_t)cfish_obj_method(self, LUCY_SeriesMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_SeriesMatcher_Next(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_Next_t method = (LUCY_SeriesMatcher_Next_t)cfish_obj_method(self, LUCY_SeriesMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_SeriesMatcher_Advance(lucy_SeriesMatcher* self, int32_t target) {
    const LUCY_SeriesMatcher_Advance_t method = (LUCY_SeriesMatcher_Advance_t)cfish_obj_method(self, LUCY_SeriesMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_SeriesMatcher_Get_Doc_ID(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_Get_Doc_ID_t method = (LUCY_SeriesMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_SeriesMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_SeriesMatcher_Score(lucy_SeriesMatcher* self) {
    const LUCY_SeriesMatcher_Score_t method = (LUCY_SeriesMatcher_Score_t)cfish_obj_method(self, LUCY_SeriesMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SeriesMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_SeriesMatcher_Collect(lucy_SeriesMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_SeriesMatcher_Collect_t method = (LUCY_SeriesMatcher_Collect_t)cfish_obj_method(self, LUCY_SeriesMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SeriesMatcher lucy_SeriesMatcher
  #define SERIESMATCHER LUCY_SERIESMATCHER
  #define SeriesMatcher_new lucy_SeriesMatcher_new
  #define SeriesMatcher_init lucy_SeriesMatcher_init
  #define SeriesMatcher_get_class lucy_SeriesMatcher_get_class
  #define SeriesMatcher_get_class_name lucy_SeriesMatcher_get_class_name
  #define SeriesMatcher_is_a lucy_SeriesMatcher_is_a
  #define SeriesMatcher_Next_IMP LUCY_SeriesMatcher_Next_IMP
  #define SeriesMatcher_Advance_IMP LUCY_SeriesMatcher_Advance_IMP
  #define SeriesMatcher_Get_Doc_ID_IMP LUCY_SeriesMatcher_Get_Doc_ID_IMP
  #define SeriesMatcher_Destroy_IMP LUCY_SeriesMatcher_Destroy_IMP
  #define SeriesMatcher_To_Host LUCY_SeriesMatcher_To_Host
  #define SeriesMatcher_To_Host_t LUCY_SeriesMatcher_To_Host_t
  #define SeriesMatcher_Clone LUCY_SeriesMatcher_Clone
  #define SeriesMatcher_Clone_t LUCY_SeriesMatcher_Clone_t
  #define SeriesMatcher_Equals LUCY_SeriesMatcher_Equals
  #define SeriesMatcher_Equals_t LUCY_SeriesMatcher_Equals_t
  #define SeriesMatcher_Compare_To LUCY_SeriesMatcher_Compare_To
  #define SeriesMatcher_Compare_To_t LUCY_SeriesMatcher_Compare_To_t
  #define SeriesMatcher_Destroy LUCY_SeriesMatcher_Destroy
  #define SeriesMatcher_Destroy_t LUCY_SeriesMatcher_Destroy_t
  #define SeriesMatcher_To_String LUCY_SeriesMatcher_To_String
  #define SeriesMatcher_To_String_t LUCY_SeriesMatcher_To_String_t
  #define SeriesMatcher_Next LUCY_SeriesMatcher_Next
  #define SeriesMatcher_Next_t LUCY_SeriesMatcher_Next_t
  #define SeriesMatcher_Advance LUCY_SeriesMatcher_Advance
  #define SeriesMatcher_Advance_t LUCY_SeriesMatcher_Advance_t
  #define SeriesMatcher_Get_Doc_ID LUCY_SeriesMatcher_Get_Doc_ID
  #define SeriesMatcher_Get_Doc_ID_t LUCY_SeriesMatcher_Get_Doc_ID_t
  #define SeriesMatcher_Score LUCY_SeriesMatcher_Score
  #define SeriesMatcher_Score_t LUCY_SeriesMatcher_Score_t
  #define SeriesMatcher_Collect LUCY_SeriesMatcher_Collect
  #define SeriesMatcher_Collect_t LUCY_SeriesMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_SERIESMATCHER */




