/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_SEARCH_TERMMATCHER
#define H_LUCY_SEARCH_TERMMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TERMMATCHER
extern uint32_t lucy_TermMatcher_IVARS_OFFSET;
typedef struct lucy_TermMatcherIVARS lucy_TermMatcherIVARS;
static CFISH_INLINE lucy_TermMatcherIVARS*
lucy_TermMatcher_IVARS(lucy_TermMatcher *self) {
   char *ptr = (char*)self + lucy_TermMatcher_IVARS_OFFSET;
   return (lucy_TermMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define TermMatcherIVARS lucy_TermMatcherIVARS
  #define TermMatcher_IVARS lucy_TermMatcher_IVARS
#endif

struct lucy_TermMatcherIVARS {
    float weight;
    lucy_Compiler* compiler;
    lucy_Similarity* sim;
    lucy_PostingList* plist;
    lucy_Posting* posting;
};

#endif /* C_LUCY_TERMMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_TermMatcher*
lucy_TermMatcher_init(lucy_TermMatcher* self, lucy_Similarity* similarity, lucy_PostingList* posting_list, lucy_Compiler* compiler);

void
LUCY_TermMatcher_Destroy_IMP(lucy_TermMatcher* self);

int32_t
LUCY_TermMatcher_Next_IMP(lucy_TermMatcher* self);

int32_t
LUCY_TermMatcher_Advance_IMP(lucy_TermMatcher* self, int32_t target);

int32_t
LUCY_TermMatcher_Get_Doc_ID_IMP(lucy_TermMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_TermMatcher_To_Host_t)(lucy_TermMatcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_TermMatcher_Clone_t)(lucy_TermMatcher* self);

typedef bool
(*LUCY_TermMatcher_Equals_t)(lucy_TermMatcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_TermMatcher_Compare_To_t)(lucy_TermMatcher* self, cfish_Obj* other);

typedef void
(*LUCY_TermMatcher_Destroy_t)(lucy_TermMatcher* self);

typedef cfish_String*
(*LUCY_TermMatcher_To_String_t)(lucy_TermMatcher* self);

typedef int32_t
(*LUCY_TermMatcher_Next_t)(lucy_TermMatcher* self);

typedef int32_t
(*LUCY_TermMatcher_Advance_t)(lucy_TermMatcher* self, int32_t target);

typedef int32_t
(*LUCY_TermMatcher_Get_Doc_ID_t)(lucy_TermMatcher* self);

typedef float
(*LUCY_TermMatcher_Score_t)(lucy_TermMatcher* self);

typedef void
(*LUCY_TermMatcher_Collect_t)(lucy_TermMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_TermMatcher_get_class(lucy_TermMatcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_TermMatcher_get_class_name(lucy_TermMatcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_TermMatcher_is_a(lucy_TermMatcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_TermMatcher_To_Host(lucy_TermMatcher* self, void* vcache) {
    const LUCY_TermMatcher_To_Host_t method = (LUCY_TermMatcher_To_Host_t)cfish_obj_method(self, LUCY_TermMatcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_TermMatcher_Clone(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_Clone_t method = (LUCY_TermMatcher_Clone_t)cfish_obj_method(self, LUCY_TermMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_TermMatcher_Equals(lucy_TermMatcher* self, cfish_Obj* other) {
    const LUCY_TermMatcher_Equals_t method = (LUCY_TermMatcher_Equals_t)cfish_obj_method(self, LUCY_TermMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_TermMatcher_Compare_To(lucy_TermMatcher* self, cfish_Obj* other) {
    const LUCY_TermMatcher_Compare_To_t method = (LUCY_TermMatcher_Compare_To_t)cfish_obj_method(self, LUCY_TermMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_TermMatcher_Destroy(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_Destroy_t method = (LUCY_TermMatcher_Destroy_t)cfish_obj_method(self, LUCY_TermMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_TermMatcher_To_String(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_To_String_t method = (LUCY_TermMatcher_To_String_t)cfish_obj_method(self, LUCY_TermMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_TermMatcher_Next(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_Next_t method = (LUCY_TermMatcher_Next_t)cfish_obj_method(self, LUCY_TermMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_TermMatcher_Advance(lucy_TermMatcher* self, int32_t target) {
    const LUCY_TermMatcher_Advance_t method = (LUCY_TermMatcher_Advance_t)cfish_obj_method(self, LUCY_TermMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_TermMatcher_Get_Doc_ID(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_Get_Doc_ID_t method = (LUCY_TermMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_TermMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_TermMatcher_Score(lucy_TermMatcher* self) {
    const LUCY_TermMatcher_Score_t method = (LUCY_TermMatcher_Score_t)cfish_obj_method(self, LUCY_TermMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_TermMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_TermMatcher_Collect(lucy_TermMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_TermMatcher_Collect_t method = (LUCY_TermMatcher_Collect_t)cfish_obj_method(self, LUCY_TermMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TermMatcher lucy_TermMatcher
  #define TERMMATCHER LUCY_TERMMATCHER
  #define TermMatcher_init lucy_TermMatcher_init
  #define TermMatcher_get_class lucy_TermMatcher_get_class
  #define TermMatcher_get_class_name lucy_TermMatcher_get_class_name
  #define TermMatcher_is_a lucy_TermMatcher_is_a
  #define TermMatcher_Destroy_IMP LUCY_TermMatcher_Destroy_IMP
  #define TermMatcher_Next_IMP LUCY_TermMatcher_Next_IMP
  #define TermMatcher_Advance_IMP LUCY_TermMatcher_Advance_IMP
  #define TermMatcher_Get_Doc_ID_IMP LUCY_TermMatcher_Get_Doc_ID_IMP
  #define TermMatcher_To_Host LUCY_TermMatcher_To_Host
  #define TermMatcher_To_Host_t LUCY_TermMatcher_To_Host_t
  #define TermMatcher_Clone LUCY_TermMatcher_Clone
  #define TermMatcher_Clone_t LUCY_TermMatcher_Clone_t
  #define TermMatcher_Equals LUCY_TermMatcher_Equals
  #define TermMatcher_Equals_t LUCY_TermMatcher_Equals_t
  #define TermMatcher_Compare_To LUCY_TermMatcher_Compare_To
  #define TermMatcher_Compare_To_t LUCY_TermMatcher_Compare_To_t
  #define TermMatcher_Destroy LUCY_TermMatcher_Destroy
  #define TermMatcher_Destroy_t LUCY_TermMatcher_Destroy_t
  #define TermMatcher_To_String LUCY_TermMatcher_To_String
  #define TermMatcher_To_String_t LUCY_TermMatcher_To_String_t
  #define TermMatcher_Next LUCY_TermMatcher_Next
  #define TermMatcher_Next_t LUCY_TermMatcher_Next_t
  #define TermMatcher_Advance LUCY_TermMatcher_Advance
  #define TermMatcher_Advance_t LUCY_TermMatcher_Advance_t
  #define TermMatcher_Get_Doc_ID LUCY_TermMatcher_Get_Doc_ID
  #define TermMatcher_Get_Doc_ID_t LUCY_TermMatcher_Get_Doc_ID_t
  #define TermMatcher_Score LUCY_TermMatcher_Score
  #define TermMatcher_Score_t LUCY_TermMatcher_Score_t
  #define TermMatcher_Collect LUCY_TermMatcher_Collect
  #define TermMatcher_Collect_t LUCY_TermMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */



#define LUCY_TERMMATCHER_SCORE_CACHE_SIZE 32
#ifdef LUCY_USE_SHORT_NAMES
  #define TERMMATCHER_SCORE_CACHE_SIZE LUCY_TERMMATCHER_SCORE_CACHE_SIZE
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_TERMMATCHER */




