/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_STORE_FSFOLDER
#define H_LUCY_STORE_FSFOLDER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Folder.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FSFOLDER
extern uint32_t lucy_FSFolder_IVARS_OFFSET;
typedef struct lucy_FSFolderIVARS lucy_FSFolderIVARS;
static CFISH_INLINE lucy_FSFolderIVARS*
lucy_FSFolder_IVARS(lucy_FSFolder *self) {
   char *ptr = (char*)self + lucy_FSFolder_IVARS_OFFSET;
   return (lucy_FSFolderIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define FSFolderIVARS lucy_FSFolderIVARS
  #define FSFolder_IVARS lucy_FSFolder_IVARS
#endif

struct lucy_FSFolderIVARS {
    cfish_String* path;
    cfish_Hash* entries;
};

#endif /* C_LUCY_FSFOLDER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_FSFolder*
lucy_FSFolder_new(cfish_String* path);

LUCY_VISIBLE lucy_FSFolder*
lucy_FSFolder_init(lucy_FSFolder* self, cfish_String* path);

void
LUCY_FSFolder_Initialize_IMP(lucy_FSFolder* self);

bool
LUCY_FSFolder_Check_IMP(lucy_FSFolder* self);

void
LUCY_FSFolder_Close_IMP(lucy_FSFolder* self);

lucy_FileHandle*
LUCY_FSFolder_Local_Open_FileHandle_IMP(lucy_FSFolder* self, cfish_String* name, uint32_t flags);

lucy_DirHandle*
LUCY_FSFolder_Local_Open_Dir_IMP(lucy_FSFolder* self);

bool
LUCY_FSFolder_Local_MkDir_IMP(lucy_FSFolder* self, cfish_String* name);

bool
LUCY_FSFolder_Local_Exists_IMP(lucy_FSFolder* self, cfish_String* name);

bool
LUCY_FSFolder_Local_Is_Directory_IMP(lucy_FSFolder* self, cfish_String* name);

lucy_Folder*
LUCY_FSFolder_Local_Find_Folder_IMP(lucy_FSFolder* self, cfish_String* name);

bool
LUCY_FSFolder_Local_Delete_IMP(lucy_FSFolder* self, cfish_String* name);

bool
LUCY_FSFolder_Rename_IMP(lucy_FSFolder* self, cfish_String* from, cfish_String* to);

bool
LUCY_FSFolder_Hard_Link_IMP(lucy_FSFolder* self, cfish_String* from, cfish_String* to);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_FSFolder_To_Host_t)(lucy_FSFolder* self, void* vcache);

typedef cfish_Obj*
(*LUCY_FSFolder_Clone_t)(lucy_FSFolder* self);

typedef bool
(*LUCY_FSFolder_Equals_t)(lucy_FSFolder* self, cfish_Obj* other);

typedef int32_t
(*LUCY_FSFolder_Compare_To_t)(lucy_FSFolder* self, cfish_Obj* other);

typedef void
(*LUCY_FSFolder_Destroy_t)(lucy_FSFolder* self);

typedef cfish_String*
(*LUCY_FSFolder_To_String_t)(lucy_FSFolder* self);

typedef cfish_String*
(*LUCY_FSFolder_Get_Path_t)(lucy_FSFolder* self);

typedef void
(*LUCY_FSFolder_Set_Path_t)(lucy_FSFolder* self, cfish_String* path);

typedef lucy_OutStream*
(*LUCY_FSFolder_Open_Out_t)(lucy_FSFolder* self, cfish_String* path);

typedef lucy_InStream*
(*LUCY_FSFolder_Open_In_t)(lucy_FSFolder* self, cfish_String* path);

typedef lucy_FileHandle*
(*LUCY_FSFolder_Open_FileHandle_t)(lucy_FSFolder* self, cfish_String* path, uint32_t flags);

typedef lucy_DirHandle*
(*LUCY_FSFolder_Open_Dir_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_MkDir_t)(lucy_FSFolder* self, cfish_String* path);

typedef cfish_Vector*
(*LUCY_FSFolder_List_t)(lucy_FSFolder* self, cfish_String* path);

typedef cfish_Vector*
(*LUCY_FSFolder_List_R_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_Exists_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_Is_Directory_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_Delete_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_Delete_Tree_t)(lucy_FSFolder* self, cfish_String* path);

typedef bool
(*LUCY_FSFolder_Rename_t)(lucy_FSFolder* self, cfish_String* from, cfish_String* to);

typedef bool
(*LUCY_FSFolder_Hard_Link_t)(lucy_FSFolder* self, cfish_String* from, cfish_String* to);

typedef cfish_Blob*
(*LUCY_FSFolder_Slurp_File_t)(lucy_FSFolder* self, cfish_String* path);

typedef void
(*LUCY_FSFolder_Consolidate_t)(lucy_FSFolder* self, cfish_String* path);

typedef lucy_Folder*
(*LUCY_FSFolder_Enclosing_Folder_t)(lucy_FSFolder* self, cfish_String* path);

typedef lucy_Folder*
(*LUCY_FSFolder_Find_Folder_t)(lucy_FSFolder* self, cfish_String* path);

typedef void
(*LUCY_FSFolder_Initialize_t)(lucy_FSFolder* self);

typedef bool
(*LUCY_FSFolder_Check_t)(lucy_FSFolder* self);

typedef void
(*LUCY_FSFolder_Close_t)(lucy_FSFolder* self);

typedef lucy_FileHandle*
(*LUCY_FSFolder_Local_Open_FileHandle_t)(lucy_FSFolder* self, cfish_String* name, uint32_t flags);

typedef lucy_InStream*
(*LUCY_FSFolder_Local_Open_In_t)(lucy_FSFolder* self, cfish_String* name);

typedef lucy_DirHandle*
(*LUCY_FSFolder_Local_Open_Dir_t)(lucy_FSFolder* self);

typedef bool
(*LUCY_FSFolder_Local_MkDir_t)(lucy_FSFolder* self, cfish_String* name);

typedef bool
(*LUCY_FSFolder_Local_Exists_t)(lucy_FSFolder* self, cfish_String* name);

typedef bool
(*LUCY_FSFolder_Local_Is_Directory_t)(lucy_FSFolder* self, cfish_String* name);

typedef lucy_Folder*
(*LUCY_FSFolder_Local_Find_Folder_t)(lucy_FSFolder* self, cfish_String* name);

typedef bool
(*LUCY_FSFolder_Local_Delete_t)(lucy_FSFolder* self, cfish_String* name);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_FSFolder_get_class(lucy_FSFolder *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_FSFolder_get_class_name(lucy_FSFolder *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_FSFolder_is_a(lucy_FSFolder *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_FSFolder_To_Host(lucy_FSFolder* self, void* vcache) {
    const LUCY_FSFolder_To_Host_t method = (LUCY_FSFolder_To_Host_t)cfish_obj_method(self, LUCY_FSFolder_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_FSFolder_Clone(lucy_FSFolder* self) {
    const LUCY_FSFolder_Clone_t method = (LUCY_FSFolder_Clone_t)cfish_obj_method(self, LUCY_FSFolder_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Equals(lucy_FSFolder* self, cfish_Obj* other) {
    const LUCY_FSFolder_Equals_t method = (LUCY_FSFolder_Equals_t)cfish_obj_method(self, LUCY_FSFolder_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_FSFolder_Compare_To(lucy_FSFolder* self, cfish_Obj* other) {
    const LUCY_FSFolder_Compare_To_t method = (LUCY_FSFolder_Compare_To_t)cfish_obj_method(self, LUCY_FSFolder_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_FSFolder_Destroy(lucy_FSFolder* self) {
    const LUCY_FSFolder_Destroy_t method = (LUCY_FSFolder_Destroy_t)cfish_obj_method(self, LUCY_FSFolder_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_FSFolder_To_String(lucy_FSFolder* self) {
    const LUCY_FSFolder_To_String_t method = (LUCY_FSFolder_To_String_t)cfish_obj_method(self, LUCY_FSFolder_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Get_Path_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_FSFolder_Get_Path(lucy_FSFolder* self) {
    const LUCY_FSFolder_Get_Path_t method = (LUCY_FSFolder_Get_Path_t)cfish_obj_method(self, LUCY_FSFolder_Get_Path_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Set_Path_OFFSET;
static CFISH_INLINE void
LUCY_FSFolder_Set_Path(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Set_Path_t method = (LUCY_FSFolder_Set_Path_t)cfish_obj_method(self, LUCY_FSFolder_Set_Path_OFFSET);
    method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Open_Out_OFFSET;
static CFISH_INLINE lucy_OutStream*
LUCY_FSFolder_Open_Out(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Open_Out_t method = (LUCY_FSFolder_Open_Out_t)cfish_obj_method(self, LUCY_FSFolder_Open_Out_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Open_In_OFFSET;
static CFISH_INLINE lucy_InStream*
LUCY_FSFolder_Open_In(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Open_In_t method = (LUCY_FSFolder_Open_In_t)cfish_obj_method(self, LUCY_FSFolder_Open_In_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Open_FileHandle_OFFSET;
static CFISH_INLINE lucy_FileHandle*
LUCY_FSFolder_Open_FileHandle(lucy_FSFolder* self, cfish_String* path, uint32_t flags) {
    const LUCY_FSFolder_Open_FileHandle_t method = (LUCY_FSFolder_Open_FileHandle_t)cfish_obj_method(self, LUCY_FSFolder_Open_FileHandle_OFFSET);
    return method(self, path, flags);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Open_Dir_OFFSET;
static CFISH_INLINE lucy_DirHandle*
LUCY_FSFolder_Open_Dir(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Open_Dir_t method = (LUCY_FSFolder_Open_Dir_t)cfish_obj_method(self, LUCY_FSFolder_Open_Dir_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_MkDir_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_MkDir(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_MkDir_t method = (LUCY_FSFolder_MkDir_t)cfish_obj_method(self, LUCY_FSFolder_MkDir_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_List_OFFSET;
static CFISH_INLINE cfish_Vector*
LUCY_FSFolder_List(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_List_t method = (LUCY_FSFolder_List_t)cfish_obj_method(self, LUCY_FSFolder_List_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_List_R_OFFSET;
static CFISH_INLINE cfish_Vector*
LUCY_FSFolder_List_R(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_List_R_t method = (LUCY_FSFolder_List_R_t)cfish_obj_method(self, LUCY_FSFolder_List_R_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Exists_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Exists(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Exists_t method = (LUCY_FSFolder_Exists_t)cfish_obj_method(self, LUCY_FSFolder_Exists_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Is_Directory_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Is_Directory(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Is_Directory_t method = (LUCY_FSFolder_Is_Directory_t)cfish_obj_method(self, LUCY_FSFolder_Is_Directory_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Delete_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Delete(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Delete_t method = (LUCY_FSFolder_Delete_t)cfish_obj_method(self, LUCY_FSFolder_Delete_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Delete_Tree_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Delete_Tree(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Delete_Tree_t method = (LUCY_FSFolder_Delete_Tree_t)cfish_obj_method(self, LUCY_FSFolder_Delete_Tree_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Rename_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Rename(lucy_FSFolder* self, cfish_String* from, cfish_String* to) {
    const LUCY_FSFolder_Rename_t method = (LUCY_FSFolder_Rename_t)cfish_obj_method(self, LUCY_FSFolder_Rename_OFFSET);
    return method(self, from, to);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Hard_Link_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Hard_Link(lucy_FSFolder* self, cfish_String* from, cfish_String* to) {
    const LUCY_FSFolder_Hard_Link_t method = (LUCY_FSFolder_Hard_Link_t)cfish_obj_method(self, LUCY_FSFolder_Hard_Link_OFFSET);
    return method(self, from, to);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Slurp_File_OFFSET;
static CFISH_INLINE cfish_Blob*
LUCY_FSFolder_Slurp_File(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Slurp_File_t method = (LUCY_FSFolder_Slurp_File_t)cfish_obj_method(self, LUCY_FSFolder_Slurp_File_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Consolidate_OFFSET;
static CFISH_INLINE void
LUCY_FSFolder_Consolidate(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Consolidate_t method = (LUCY_FSFolder_Consolidate_t)cfish_obj_method(self, LUCY_FSFolder_Consolidate_OFFSET);
    method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Enclosing_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_FSFolder_Enclosing_Folder(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Enclosing_Folder_t method = (LUCY_FSFolder_Enclosing_Folder_t)cfish_obj_method(self, LUCY_FSFolder_Enclosing_Folder_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Find_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_FSFolder_Find_Folder(lucy_FSFolder* self, cfish_String* path) {
    const LUCY_FSFolder_Find_Folder_t method = (LUCY_FSFolder_Find_Folder_t)cfish_obj_method(self, LUCY_FSFolder_Find_Folder_OFFSET);
    return method(self, path);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Initialize_OFFSET;
static CFISH_INLINE void
LUCY_FSFolder_Initialize(lucy_FSFolder* self) {
    const LUCY_FSFolder_Initialize_t method = (LUCY_FSFolder_Initialize_t)cfish_obj_method(self, LUCY_FSFolder_Initialize_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Check_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Check(lucy_FSFolder* self) {
    const LUCY_FSFolder_Check_t method = (LUCY_FSFolder_Check_t)cfish_obj_method(self, LUCY_FSFolder_Check_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Close_OFFSET;
static CFISH_INLINE void
LUCY_FSFolder_Close(lucy_FSFolder* self) {
    const LUCY_FSFolder_Close_t method = (LUCY_FSFolder_Close_t)cfish_obj_method(self, LUCY_FSFolder_Close_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Open_FileHandle_OFFSET;
static CFISH_INLINE lucy_FileHandle*
LUCY_FSFolder_Local_Open_FileHandle(lucy_FSFolder* self, cfish_String* name, uint32_t flags) {
    const LUCY_FSFolder_Local_Open_FileHandle_t method = (LUCY_FSFolder_Local_Open_FileHandle_t)cfish_obj_method(self, LUCY_FSFolder_Local_Open_FileHandle_OFFSET);
    return method(self, name, flags);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Open_In_OFFSET;
static CFISH_INLINE lucy_InStream*
LUCY_FSFolder_Local_Open_In(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_Open_In_t method = (LUCY_FSFolder_Local_Open_In_t)cfish_obj_method(self, LUCY_FSFolder_Local_Open_In_OFFSET);
    return method(self, name);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Open_Dir_OFFSET;
static CFISH_INLINE lucy_DirHandle*
LUCY_FSFolder_Local_Open_Dir(lucy_FSFolder* self) {
    const LUCY_FSFolder_Local_Open_Dir_t method = (LUCY_FSFolder_Local_Open_Dir_t)cfish_obj_method(self, LUCY_FSFolder_Local_Open_Dir_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_MkDir_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Local_MkDir(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_MkDir_t method = (LUCY_FSFolder_Local_MkDir_t)cfish_obj_method(self, LUCY_FSFolder_Local_MkDir_OFFSET);
    return method(self, name);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Exists_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Local_Exists(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_Exists_t method = (LUCY_FSFolder_Local_Exists_t)cfish_obj_method(self, LUCY_FSFolder_Local_Exists_OFFSET);
    return method(self, name);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Is_Directory_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Local_Is_Directory(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_Is_Directory_t method = (LUCY_FSFolder_Local_Is_Directory_t)cfish_obj_method(self, LUCY_FSFolder_Local_Is_Directory_OFFSET);
    return method(self, name);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Find_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_FSFolder_Local_Find_Folder(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_Find_Folder_t method = (LUCY_FSFolder_Local_Find_Folder_t)cfish_obj_method(self, LUCY_FSFolder_Local_Find_Folder_OFFSET);
    return method(self, name);
}

extern LUCY_VISIBLE uint32_t LUCY_FSFolder_Local_Delete_OFFSET;
static CFISH_INLINE bool
LUCY_FSFolder_Local_Delete(lucy_FSFolder* self, cfish_String* name) {
    const LUCY_FSFolder_Local_Delete_t method = (LUCY_FSFolder_Local_Delete_t)cfish_obj_method(self, LUCY_FSFolder_Local_Delete_OFFSET);
    return method(self, name);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FSFolder lucy_FSFolder
  #define FSFOLDER LUCY_FSFOLDER
  #define FSFolder_new lucy_FSFolder_new
  #define FSFolder_init lucy_FSFolder_init
  #define FSFolder_get_class lucy_FSFolder_get_class
  #define FSFolder_get_class_name lucy_FSFolder_get_class_name
  #define FSFolder_is_a lucy_FSFolder_is_a
  #define FSFolder_Initialize_IMP LUCY_FSFolder_Initialize_IMP
  #define FSFolder_Check_IMP LUCY_FSFolder_Check_IMP
  #define FSFolder_Close_IMP LUCY_FSFolder_Close_IMP
  #define FSFolder_Local_Open_FileHandle_IMP LUCY_FSFolder_Local_Open_FileHandle_IMP
  #define FSFolder_Local_Open_Dir_IMP LUCY_FSFolder_Local_Open_Dir_IMP
  #define FSFolder_Local_MkDir_IMP LUCY_FSFolder_Local_MkDir_IMP
  #define FSFolder_Local_Exists_IMP LUCY_FSFolder_Local_Exists_IMP
  #define FSFolder_Local_Is_Directory_IMP LUCY_FSFolder_Local_Is_Directory_IMP
  #define FSFolder_Local_Find_Folder_IMP LUCY_FSFolder_Local_Find_Folder_IMP
  #define FSFolder_Local_Delete_IMP LUCY_FSFolder_Local_Delete_IMP
  #define FSFolder_Rename_IMP LUCY_FSFolder_Rename_IMP
  #define FSFolder_Hard_Link_IMP LUCY_FSFolder_Hard_Link_IMP
  #define FSFolder_To_Host LUCY_FSFolder_To_Host
  #define FSFolder_To_Host_t LUCY_FSFolder_To_Host_t
  #define FSFolder_Clone LUCY_FSFolder_Clone
  #define FSFolder_Clone_t LUCY_FSFolder_Clone_t
  #define FSFolder_Equals LUCY_FSFolder_Equals
  #define FSFolder_Equals_t LUCY_FSFolder_Equals_t
  #define FSFolder_Compare_To LUCY_FSFolder_Compare_To
  #define FSFolder_Compare_To_t LUCY_FSFolder_Compare_To_t
  #define FSFolder_Destroy LUCY_FSFolder_Destroy
  #define FSFolder_Destroy_t LUCY_FSFolder_Destroy_t
  #define FSFolder_To_String LUCY_FSFolder_To_String
  #define FSFolder_To_String_t LUCY_FSFolder_To_String_t
  #define FSFolder_Get_Path LUCY_FSFolder_Get_Path
  #define FSFolder_Get_Path_t LUCY_FSFolder_Get_Path_t
  #define FSFolder_Set_Path LUCY_FSFolder_Set_Path
  #define FSFolder_Set_Path_t LUCY_FSFolder_Set_Path_t
  #define FSFolder_Open_Out LUCY_FSFolder_Open_Out
  #define FSFolder_Open_Out_t LUCY_FSFolder_Open_Out_t
  #define FSFolder_Open_In LUCY_FSFolder_Open_In
  #define FSFolder_Open_In_t LUCY_FSFolder_Open_In_t
  #define FSFolder_Open_FileHandle LUCY_FSFolder_Open_FileHandle
  #define FSFolder_Open_FileHandle_t LUCY_FSFolder_Open_FileHandle_t
  #define FSFolder_Open_Dir LUCY_FSFolder_Open_Dir
  #define FSFolder_Open_Dir_t LUCY_FSFolder_Open_Dir_t
  #define FSFolder_MkDir LUCY_FSFolder_MkDir
  #define FSFolder_MkDir_t LUCY_FSFolder_MkDir_t
  #define FSFolder_List LUCY_FSFolder_List
  #define FSFolder_List_t LUCY_FSFolder_List_t
  #define FSFolder_List_R LUCY_FSFolder_List_R
  #define FSFolder_List_R_t LUCY_FSFolder_List_R_t
  #define FSFolder_Exists LUCY_FSFolder_Exists
  #define FSFolder_Exists_t LUCY_FSFolder_Exists_t
  #define FSFolder_Is_Directory LUCY_FSFolder_Is_Directory
  #define FSFolder_Is_Directory_t LUCY_FSFolder_Is_Directory_t
  #define FSFolder_Delete LUCY_FSFolder_Delete
  #define FSFolder_Delete_t LUCY_FSFolder_Delete_t
  #define FSFolder_Delete_Tree LUCY_FSFolder_Delete_Tree
  #define FSFolder_Delete_Tree_t LUCY_FSFolder_Delete_Tree_t
  #define FSFolder_Rename LUCY_FSFolder_Rename
  #define FSFolder_Rename_t LUCY_FSFolder_Rename_t
  #define FSFolder_Hard_Link LUCY_FSFolder_Hard_Link
  #define FSFolder_Hard_Link_t LUCY_FSFolder_Hard_Link_t
  #define FSFolder_Slurp_File LUCY_FSFolder_Slurp_File
  #define FSFolder_Slurp_File_t LUCY_FSFolder_Slurp_File_t
  #define FSFolder_Consolidate LUCY_FSFolder_Consolidate
  #define FSFolder_Consolidate_t LUCY_FSFolder_Consolidate_t
  #define FSFolder_Enclosing_Folder LUCY_FSFolder_Enclosing_Folder
  #define FSFolder_Enclosing_Folder_t LUCY_FSFolder_Enclosing_Folder_t
  #define FSFolder_Find_Folder LUCY_FSFolder_Find_Folder
  #define FSFolder_Find_Folder_t LUCY_FSFolder_Find_Folder_t
  #define FSFolder_Initialize LUCY_FSFolder_Initialize
  #define FSFolder_Initialize_t LUCY_FSFolder_Initialize_t
  #define FSFolder_Check LUCY_FSFolder_Check
  #define FSFolder_Check_t LUCY_FSFolder_Check_t
  #define FSFolder_Close LUCY_FSFolder_Close
  #define FSFolder_Close_t LUCY_FSFolder_Close_t
  #define FSFolder_Local_Open_FileHandle LUCY_FSFolder_Local_Open_FileHandle
  #define FSFolder_Local_Open_FileHandle_t LUCY_FSFolder_Local_Open_FileHandle_t
  #define FSFolder_Local_Open_In LUCY_FSFolder_Local_Open_In
  #define FSFolder_Local_Open_In_t LUCY_FSFolder_Local_Open_In_t
  #define FSFolder_Local_Open_Dir LUCY_FSFolder_Local_Open_Dir
  #define FSFolder_Local_Open_Dir_t LUCY_FSFolder_Local_Open_Dir_t
  #define FSFolder_Local_MkDir LUCY_FSFolder_Local_MkDir
  #define FSFolder_Local_MkDir_t LUCY_FSFolder_Local_MkDir_t
  #define FSFolder_Local_Exists LUCY_FSFolder_Local_Exists
  #define FSFolder_Local_Exists_t LUCY_FSFolder_Local_Exists_t
  #define FSFolder_Local_Is_Directory LUCY_FSFolder_Local_Is_Directory
  #define FSFolder_Local_Is_Directory_t LUCY_FSFolder_Local_Is_Directory_t
  #define FSFolder_Local_Find_Folder LUCY_FSFolder_Local_Find_Folder
  #define FSFolder_Local_Find_Folder_t LUCY_FSFolder_Local_Find_Folder_t
  #define FSFolder_Local_Delete LUCY_FSFolder_Local_Delete
  #define FSFolder_Local_Delete_t LUCY_FSFolder_Local_Delete_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FSFOLDER */




