/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_STORE_RAMDIRHANDLE
#define H_LUCY_STORE_RAMDIRHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/DirHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAMDIRHANDLE
extern uint32_t lucy_RAMDH_IVARS_OFFSET;
typedef struct lucy_RAMDirHandleIVARS lucy_RAMDirHandleIVARS;
static CFISH_INLINE lucy_RAMDirHandleIVARS*
lucy_RAMDH_IVARS(lucy_RAMDirHandle *self) {
   char *ptr = (char*)self + lucy_RAMDH_IVARS_OFFSET;
   return (lucy_RAMDirHandleIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define RAMDirHandleIVARS lucy_RAMDirHandleIVARS
  #define RAMDH_IVARS lucy_RAMDH_IVARS
#endif

struct lucy_RAMDirHandleIVARS {
    cfish_String* dir;
    cfish_String* entry;
    lucy_RAMFolder* folder;
    cfish_Vector* elems;
    int32_t tick;
};

#endif /* C_LUCY_RAMDIRHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_RAMDirHandle*
lucy_RAMDH_new(lucy_RAMFolder* folder);

LUCY_VISIBLE lucy_RAMDirHandle*
lucy_RAMDH_init(lucy_RAMDirHandle* self, lucy_RAMFolder* folder);

bool
LUCY_RAMDH_Next_IMP(lucy_RAMDirHandle* self);

bool
LUCY_RAMDH_Entry_Is_Dir_IMP(lucy_RAMDirHandle* self);

bool
LUCY_RAMDH_Entry_Is_Symlink_IMP(lucy_RAMDirHandle* self);

bool
LUCY_RAMDH_Close_IMP(lucy_RAMDirHandle* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_RAMDH_To_Host_t)(lucy_RAMDirHandle* self, void* vcache);

typedef cfish_Obj*
(*LUCY_RAMDH_Clone_t)(lucy_RAMDirHandle* self);

typedef bool
(*LUCY_RAMDH_Equals_t)(lucy_RAMDirHandle* self, cfish_Obj* other);

typedef int32_t
(*LUCY_RAMDH_Compare_To_t)(lucy_RAMDirHandle* self, cfish_Obj* other);

typedef void
(*LUCY_RAMDH_Destroy_t)(lucy_RAMDirHandle* self);

typedef cfish_String*
(*LUCY_RAMDH_To_String_t)(lucy_RAMDirHandle* self);

typedef bool
(*LUCY_RAMDH_Next_t)(lucy_RAMDirHandle* self);

typedef bool
(*LUCY_RAMDH_Close_t)(lucy_RAMDirHandle* self);

typedef cfish_String*
(*LUCY_RAMDH_Get_Dir_t)(lucy_RAMDirHandle* self);

typedef cfish_String*
(*LUCY_RAMDH_Get_Entry_t)(lucy_RAMDirHandle* self);

typedef bool
(*LUCY_RAMDH_Entry_Is_Dir_t)(lucy_RAMDirHandle* self);

typedef bool
(*LUCY_RAMDH_Entry_Is_Symlink_t)(lucy_RAMDirHandle* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_RAMDH_get_class(lucy_RAMDirHandle *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_RAMDH_get_class_name(lucy_RAMDirHandle *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_RAMDH_is_a(lucy_RAMDirHandle *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_RAMDH_To_Host(lucy_RAMDirHandle* self, void* vcache) {
    const LUCY_RAMDH_To_Host_t method = (LUCY_RAMDH_To_Host_t)cfish_obj_method(self, LUCY_RAMDH_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RAMDH_Clone(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Clone_t method = (LUCY_RAMDH_Clone_t)cfish_obj_method(self, LUCY_RAMDH_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_RAMDH_Equals(lucy_RAMDirHandle* self, cfish_Obj* other) {
    const LUCY_RAMDH_Equals_t method = (LUCY_RAMDH_Equals_t)cfish_obj_method(self, LUCY_RAMDH_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_RAMDH_Compare_To(lucy_RAMDirHandle* self, cfish_Obj* other) {
    const LUCY_RAMDH_Compare_To_t method = (LUCY_RAMDH_Compare_To_t)cfish_obj_method(self, LUCY_RAMDH_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_RAMDH_Destroy(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Destroy_t method = (LUCY_RAMDH_Destroy_t)cfish_obj_method(self, LUCY_RAMDH_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RAMDH_To_String(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_To_String_t method = (LUCY_RAMDH_To_String_t)cfish_obj_method(self, LUCY_RAMDH_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Next_OFFSET;
static CFISH_INLINE bool
LUCY_RAMDH_Next(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Next_t method = (LUCY_RAMDH_Next_t)cfish_obj_method(self, LUCY_RAMDH_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Close_OFFSET;
static CFISH_INLINE bool
LUCY_RAMDH_Close(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Close_t method = (LUCY_RAMDH_Close_t)cfish_obj_method(self, LUCY_RAMDH_Close_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Get_Dir_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RAMDH_Get_Dir(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Get_Dir_t method = (LUCY_RAMDH_Get_Dir_t)cfish_obj_method(self, LUCY_RAMDH_Get_Dir_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Get_Entry_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RAMDH_Get_Entry(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Get_Entry_t method = (LUCY_RAMDH_Get_Entry_t)cfish_obj_method(self, LUCY_RAMDH_Get_Entry_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Entry_Is_Dir_OFFSET;
static CFISH_INLINE bool
LUCY_RAMDH_Entry_Is_Dir(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Entry_Is_Dir_t method = (LUCY_RAMDH_Entry_Is_Dir_t)cfish_obj_method(self, LUCY_RAMDH_Entry_Is_Dir_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_RAMDH_Entry_Is_Symlink_OFFSET;
static CFISH_INLINE bool
LUCY_RAMDH_Entry_Is_Symlink(lucy_RAMDirHandle* self) {
    const LUCY_RAMDH_Entry_Is_Symlink_t method = (LUCY_RAMDH_Entry_Is_Symlink_t)cfish_obj_method(self, LUCY_RAMDH_Entry_Is_Symlink_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RAMDirHandle lucy_RAMDirHandle
  #define RAMDIRHANDLE LUCY_RAMDIRHANDLE
  #define RAMDH_new lucy_RAMDH_new
  #define RAMDH_init lucy_RAMDH_init
  #define RAMDH_get_class lucy_RAMDH_get_class
  #define RAMDH_get_class_name lucy_RAMDH_get_class_name
  #define RAMDH_is_a lucy_RAMDH_is_a
  #define RAMDH_Next_IMP LUCY_RAMDH_Next_IMP
  #define RAMDH_Entry_Is_Dir_IMP LUCY_RAMDH_Entry_Is_Dir_IMP
  #define RAMDH_Entry_Is_Symlink_IMP LUCY_RAMDH_Entry_Is_Symlink_IMP
  #define RAMDH_Close_IMP LUCY_RAMDH_Close_IMP
  #define RAMDH_To_Host LUCY_RAMDH_To_Host
  #define RAMDH_To_Host_t LUCY_RAMDH_To_Host_t
  #define RAMDH_Clone LUCY_RAMDH_Clone
  #define RAMDH_Clone_t LUCY_RAMDH_Clone_t
  #define RAMDH_Equals LUCY_RAMDH_Equals
  #define RAMDH_Equals_t LUCY_RAMDH_Equals_t
  #define RAMDH_Compare_To LUCY_RAMDH_Compare_To
  #define RAMDH_Compare_To_t LUCY_RAMDH_Compare_To_t
  #define RAMDH_Destroy LUCY_RAMDH_Destroy
  #define RAMDH_Destroy_t LUCY_RAMDH_Destroy_t
  #define RAMDH_To_String LUCY_RAMDH_To_String
  #define RAMDH_To_String_t LUCY_RAMDH_To_String_t
  #define RAMDH_Next LUCY_RAMDH_Next
  #define RAMDH_Next_t LUCY_RAMDH_Next_t
  #define RAMDH_Close LUCY_RAMDH_Close
  #define RAMDH_Close_t LUCY_RAMDH_Close_t
  #define RAMDH_Get_Dir LUCY_RAMDH_Get_Dir
  #define RAMDH_Get_Dir_t LUCY_RAMDH_Get_Dir_t
  #define RAMDH_Get_Entry LUCY_RAMDH_Get_Entry
  #define RAMDH_Get_Entry_t LUCY_RAMDH_Get_Entry_t
  #define RAMDH_Entry_Is_Dir LUCY_RAMDH_Entry_Is_Dir
  #define RAMDH_Entry_Is_Dir_t LUCY_RAMDH_Entry_Is_Dir_t
  #define RAMDH_Entry_Is_Symlink LUCY_RAMDH_Entry_Is_Symlink
  #define RAMDH_Entry_Is_Symlink_t LUCY_RAMDH_Entry_Is_Symlink_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_RAMDIRHANDLE */




