/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCY_UTIL_SORTEXTERNAL
#define H_LUCY_UTIL_SORTEXTERNAL 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTEXTERNAL
extern uint32_t lucy_SortEx_IVARS_OFFSET;
typedef struct lucy_SortExternalIVARS lucy_SortExternalIVARS;
static CFISH_INLINE lucy_SortExternalIVARS*
lucy_SortEx_IVARS(lucy_SortExternal *self) {
   char *ptr = (char*)self + lucy_SortEx_IVARS_OFFSET;
   return (lucy_SortExternalIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SortExternalIVARS lucy_SortExternalIVARS
  #define SortEx_IVARS lucy_SortEx_IVARS
#endif

struct lucy_SortExternalIVARS {
    cfish_Obj** buffer;
    uint32_t buf_cap;
    uint32_t buf_max;
    uint32_t buf_tick;
    cfish_Obj** scratch;
    uint32_t scratch_cap;
    cfish_Vector* runs;
    cfish_Obj*** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    bool flipped;
};

#endif /* C_LUCY_SORTEXTERNAL */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_SortExternal*
lucy_SortEx_init(lucy_SortExternal* self);

int
LUCY_SortEx_Compare_IMP(lucy_SortExternal* self, cfish_Obj** ptr_a, cfish_Obj** ptr_b);

void
LUCY_SortEx_Flush_IMP(lucy_SortExternal* self);

void
LUCY_SortEx_Feed_IMP(lucy_SortExternal* self, cfish_Obj* item);

void
LUCY_SortEx_Flip_IMP(lucy_SortExternal* self);

cfish_Obj*
LUCY_SortEx_Fetch_IMP(lucy_SortExternal* self);

cfish_Obj*
LUCY_SortEx_Peek_IMP(lucy_SortExternal* self);

void
LUCY_SortEx_Add_Run_IMP(lucy_SortExternal* self, lucy_SortExternal* run);

void
LUCY_SortEx_Shrink_IMP(lucy_SortExternal* self);

uint32_t
LUCY_SortEx_Refill_IMP(lucy_SortExternal* self);

void
LUCY_SortEx_Sort_Buffer_IMP(lucy_SortExternal* self);

void
LUCY_SortEx_Clear_Buffer_IMP(lucy_SortExternal* self);

uint32_t
LUCY_SortEx_Buffer_Count_IMP(lucy_SortExternal* self);

void
LUCY_SortEx_Grow_Buffer_IMP(lucy_SortExternal* self, uint32_t cap);

void
LUCY_SortEx_Set_Mem_Thresh_IMP(lucy_SortExternal* self, uint32_t mem_thresh);

void
LUCY_SortEx_Destroy_IMP(lucy_SortExternal* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_SortEx_To_Host_t)(lucy_SortExternal* self, void* vcache);

typedef cfish_Obj*
(*LUCY_SortEx_Clone_t)(lucy_SortExternal* self);

typedef bool
(*LUCY_SortEx_Equals_t)(lucy_SortExternal* self, cfish_Obj* other);

typedef int32_t
(*LUCY_SortEx_Compare_To_t)(lucy_SortExternal* self, cfish_Obj* other);

typedef void
(*LUCY_SortEx_Destroy_t)(lucy_SortExternal* self);

typedef cfish_String*
(*LUCY_SortEx_To_String_t)(lucy_SortExternal* self);

typedef int
(*LUCY_SortEx_Compare_t)(lucy_SortExternal* self, cfish_Obj** ptr_a, cfish_Obj** ptr_b);

typedef void
(*LUCY_SortEx_Flush_t)(lucy_SortExternal* self);

typedef void
(*LUCY_SortEx_Feed_t)(lucy_SortExternal* self, cfish_Obj* item);

typedef void
(*LUCY_SortEx_Flip_t)(lucy_SortExternal* self);

typedef cfish_Obj*
(*LUCY_SortEx_Fetch_t)(lucy_SortExternal* self);

typedef cfish_Obj*
(*LUCY_SortEx_Peek_t)(lucy_SortExternal* self);

typedef void
(*LUCY_SortEx_Add_Run_t)(lucy_SortExternal* self, lucy_SortExternal* run);

typedef void
(*LUCY_SortEx_Shrink_t)(lucy_SortExternal* self);

typedef uint32_t
(*LUCY_SortEx_Refill_t)(lucy_SortExternal* self);

typedef void
(*LUCY_SortEx_Sort_Buffer_t)(lucy_SortExternal* self);

typedef void
(*LUCY_SortEx_Clear_Buffer_t)(lucy_SortExternal* self);

typedef uint32_t
(*LUCY_SortEx_Buffer_Count_t)(lucy_SortExternal* self);

typedef void
(*LUCY_SortEx_Grow_Buffer_t)(lucy_SortExternal* self, uint32_t cap);

typedef void
(*LUCY_SortEx_Set_Mem_Thresh_t)(lucy_SortExternal* self, uint32_t mem_thresh);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_SortEx_get_class(lucy_SortExternal *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_SortEx_get_class_name(lucy_SortExternal *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_SortEx_is_a(lucy_SortExternal *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_SortEx_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_SortEx_To_Host(lucy_SortExternal* self, void* vcache) {
    const LUCY_SortEx_To_Host_t method = (LUCY_SortEx_To_Host_t)cfish_obj_method(self, LUCY_SortEx_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortEx_Clone(lucy_SortExternal* self) {
    const LUCY_SortEx_Clone_t method = (LUCY_SortEx_Clone_t)cfish_obj_method(self, LUCY_SortEx_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_SortEx_Equals(lucy_SortExternal* self, cfish_Obj* other) {
    const LUCY_SortEx_Equals_t method = (LUCY_SortEx_Equals_t)cfish_obj_method(self, LUCY_SortEx_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortEx_Compare_To(lucy_SortExternal* self, cfish_Obj* other) {
    const LUCY_SortEx_Compare_To_t method = (LUCY_SortEx_Compare_To_t)cfish_obj_method(self, LUCY_SortEx_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Destroy(lucy_SortExternal* self) {
    const LUCY_SortEx_Destroy_t method = (LUCY_SortEx_Destroy_t)cfish_obj_method(self, LUCY_SortEx_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SortEx_To_String(lucy_SortExternal* self) {
    const LUCY_SortEx_To_String_t method = (LUCY_SortEx_To_String_t)cfish_obj_method(self, LUCY_SortEx_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Compare_OFFSET;
static CFISH_INLINE int
LUCY_SortEx_Compare(lucy_SortExternal* self, cfish_Obj** ptr_a, cfish_Obj** ptr_b) {
    const LUCY_SortEx_Compare_t method = (LUCY_SortEx_Compare_t)cfish_obj_method(self, LUCY_SortEx_Compare_OFFSET);
    return method(self, ptr_a, ptr_b);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Flush_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Flush(lucy_SortExternal* self) {
    const LUCY_SortEx_Flush_t method = (LUCY_SortEx_Flush_t)cfish_obj_method(self, LUCY_SortEx_Flush_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Feed_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Feed(lucy_SortExternal* self, cfish_Obj* item) {
    const LUCY_SortEx_Feed_t method = (LUCY_SortEx_Feed_t)cfish_obj_method(self, LUCY_SortEx_Feed_OFFSET);
    method(self, item);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Flip_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Flip(lucy_SortExternal* self) {
    const LUCY_SortEx_Flip_t method = (LUCY_SortEx_Flip_t)cfish_obj_method(self, LUCY_SortEx_Flip_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Fetch_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortEx_Fetch(lucy_SortExternal* self) {
    const LUCY_SortEx_Fetch_t method = (LUCY_SortEx_Fetch_t)cfish_obj_method(self, LUCY_SortEx_Fetch_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Peek_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortEx_Peek(lucy_SortExternal* self) {
    const LUCY_SortEx_Peek_t method = (LUCY_SortEx_Peek_t)cfish_obj_method(self, LUCY_SortEx_Peek_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Add_Run_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Add_Run(lucy_SortExternal* self, lucy_SortExternal* run) {
    const LUCY_SortEx_Add_Run_t method = (LUCY_SortEx_Add_Run_t)cfish_obj_method(self, LUCY_SortEx_Add_Run_OFFSET);
    method(self, run);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Shrink_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Shrink(lucy_SortExternal* self) {
    const LUCY_SortEx_Shrink_t method = (LUCY_SortEx_Shrink_t)cfish_obj_method(self, LUCY_SortEx_Shrink_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Refill_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortEx_Refill(lucy_SortExternal* self) {
    const LUCY_SortEx_Refill_t method = (LUCY_SortEx_Refill_t)cfish_obj_method(self, LUCY_SortEx_Refill_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Sort_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Sort_Buffer(lucy_SortExternal* self) {
    const LUCY_SortEx_Sort_Buffer_t method = (LUCY_SortEx_Sort_Buffer_t)cfish_obj_method(self, LUCY_SortEx_Sort_Buffer_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Clear_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Clear_Buffer(lucy_SortExternal* self) {
    const LUCY_SortEx_Clear_Buffer_t method = (LUCY_SortEx_Clear_Buffer_t)cfish_obj_method(self, LUCY_SortEx_Clear_Buffer_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Buffer_Count_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortEx_Buffer_Count(lucy_SortExternal* self) {
    const LUCY_SortEx_Buffer_Count_t method = (LUCY_SortEx_Buffer_Count_t)cfish_obj_method(self, LUCY_SortEx_Buffer_Count_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Grow_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Grow_Buffer(lucy_SortExternal* self, uint32_t cap) {
    const LUCY_SortEx_Grow_Buffer_t method = (LUCY_SortEx_Grow_Buffer_t)cfish_obj_method(self, LUCY_SortEx_Grow_Buffer_OFFSET);
    method(self, cap);
}

extern LUCY_VISIBLE uint32_t LUCY_SortEx_Set_Mem_Thresh_OFFSET;
static CFISH_INLINE void
LUCY_SortEx_Set_Mem_Thresh(lucy_SortExternal* self, uint32_t mem_thresh) {
    const LUCY_SortEx_Set_Mem_Thresh_t method = (LUCY_SortEx_Set_Mem_Thresh_t)cfish_obj_method(self, LUCY_SortEx_Set_Mem_Thresh_OFFSET);
    method(self, mem_thresh);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_SortEx_Compare_OVERRIDE NULL
#define Lucy_SortEx_Flush_OVERRIDE NULL
#define Lucy_SortEx_Feed_OVERRIDE NULL
#define Lucy_SortEx_Flip_OVERRIDE NULL
#define Lucy_SortEx_Fetch_OVERRIDE NULL
#define Lucy_SortEx_Peek_OVERRIDE NULL
#define Lucy_SortEx_Add_Run_OVERRIDE NULL
#define Lucy_SortEx_Shrink_OVERRIDE NULL
#define Lucy_SortEx_Refill_OVERRIDE NULL
#define Lucy_SortEx_Sort_Buffer_OVERRIDE NULL
#define Lucy_SortEx_Clear_Buffer_OVERRIDE NULL
#define Lucy_SortEx_Buffer_Count_OVERRIDE NULL
#define Lucy_SortEx_Grow_Buffer_OVERRIDE NULL
#define Lucy_SortEx_Set_Mem_Thresh_OVERRIDE NULL
#else
int
Lucy_SortEx_Compare_OVERRIDE(lucy_SortExternal* self, cfish_Obj** ptr_a, cfish_Obj** ptr_b);
void
Lucy_SortEx_Flush_OVERRIDE(lucy_SortExternal* self);
void
Lucy_SortEx_Feed_OVERRIDE(lucy_SortExternal* self, cfish_Obj* item);
void
Lucy_SortEx_Flip_OVERRIDE(lucy_SortExternal* self);
cfish_Obj*
Lucy_SortEx_Fetch_OVERRIDE(lucy_SortExternal* self);
cfish_Obj*
Lucy_SortEx_Peek_OVERRIDE(lucy_SortExternal* self);
void
Lucy_SortEx_Add_Run_OVERRIDE(lucy_SortExternal* self, lucy_SortExternal* run);
void
Lucy_SortEx_Shrink_OVERRIDE(lucy_SortExternal* self);
uint32_t
Lucy_SortEx_Refill_OVERRIDE(lucy_SortExternal* self);
void
Lucy_SortEx_Sort_Buffer_OVERRIDE(lucy_SortExternal* self);
void
Lucy_SortEx_Clear_Buffer_OVERRIDE(lucy_SortExternal* self);
uint32_t
Lucy_SortEx_Buffer_Count_OVERRIDE(lucy_SortExternal* self);
void
Lucy_SortEx_Grow_Buffer_OVERRIDE(lucy_SortExternal* self, uint32_t cap);
void
Lucy_SortEx_Set_Mem_Thresh_OVERRIDE(lucy_SortExternal* self, uint32_t mem_thresh);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortExternal lucy_SortExternal
  #define SORTEXTERNAL LUCY_SORTEXTERNAL
  #define SortEx_init lucy_SortEx_init
  #define SortEx_get_class lucy_SortEx_get_class
  #define SortEx_get_class_name lucy_SortEx_get_class_name
  #define SortEx_is_a lucy_SortEx_is_a
  #define SortEx_Compare_IMP LUCY_SortEx_Compare_IMP
  #define SortEx_Flush_IMP LUCY_SortEx_Flush_IMP
  #define SortEx_Feed_IMP LUCY_SortEx_Feed_IMP
  #define SortEx_Flip_IMP LUCY_SortEx_Flip_IMP
  #define SortEx_Fetch_IMP LUCY_SortEx_Fetch_IMP
  #define SortEx_Peek_IMP LUCY_SortEx_Peek_IMP
  #define SortEx_Add_Run_IMP LUCY_SortEx_Add_Run_IMP
  #define SortEx_Shrink_IMP LUCY_SortEx_Shrink_IMP
  #define SortEx_Refill_IMP LUCY_SortEx_Refill_IMP
  #define SortEx_Sort_Buffer_IMP LUCY_SortEx_Sort_Buffer_IMP
  #define SortEx_Clear_Buffer_IMP LUCY_SortEx_Clear_Buffer_IMP
  #define SortEx_Buffer_Count_IMP LUCY_SortEx_Buffer_Count_IMP
  #define SortEx_Grow_Buffer_IMP LUCY_SortEx_Grow_Buffer_IMP
  #define SortEx_Set_Mem_Thresh_IMP LUCY_SortEx_Set_Mem_Thresh_IMP
  #define SortEx_Destroy_IMP LUCY_SortEx_Destroy_IMP
  #define SortEx_To_Host LUCY_SortEx_To_Host
  #define SortEx_To_Host_t LUCY_SortEx_To_Host_t
  #define SortEx_Clone LUCY_SortEx_Clone
  #define SortEx_Clone_t LUCY_SortEx_Clone_t
  #define SortEx_Equals LUCY_SortEx_Equals
  #define SortEx_Equals_t LUCY_SortEx_Equals_t
  #define SortEx_Compare_To LUCY_SortEx_Compare_To
  #define SortEx_Compare_To_t LUCY_SortEx_Compare_To_t
  #define SortEx_Destroy LUCY_SortEx_Destroy
  #define SortEx_Destroy_t LUCY_SortEx_Destroy_t
  #define SortEx_To_String LUCY_SortEx_To_String
  #define SortEx_To_String_t LUCY_SortEx_To_String_t
  #define SortEx_Compare LUCY_SortEx_Compare
  #define SortEx_Compare_t LUCY_SortEx_Compare_t
  #define SortEx_Flush LUCY_SortEx_Flush
  #define SortEx_Flush_t LUCY_SortEx_Flush_t
  #define SortEx_Feed LUCY_SortEx_Feed
  #define SortEx_Feed_t LUCY_SortEx_Feed_t
  #define SortEx_Flip LUCY_SortEx_Flip
  #define SortEx_Flip_t LUCY_SortEx_Flip_t
  #define SortEx_Fetch LUCY_SortEx_Fetch
  #define SortEx_Fetch_t LUCY_SortEx_Fetch_t
  #define SortEx_Peek LUCY_SortEx_Peek
  #define SortEx_Peek_t LUCY_SortEx_Peek_t
  #define SortEx_Add_Run LUCY_SortEx_Add_Run
  #define SortEx_Add_Run_t LUCY_SortEx_Add_Run_t
  #define SortEx_Shrink LUCY_SortEx_Shrink
  #define SortEx_Shrink_t LUCY_SortEx_Shrink_t
  #define SortEx_Refill LUCY_SortEx_Refill
  #define SortEx_Refill_t LUCY_SortEx_Refill_t
  #define SortEx_Sort_Buffer LUCY_SortEx_Sort_Buffer
  #define SortEx_Sort_Buffer_t LUCY_SortEx_Sort_Buffer_t
  #define SortEx_Clear_Buffer LUCY_SortEx_Clear_Buffer
  #define SortEx_Clear_Buffer_t LUCY_SortEx_Clear_Buffer_t
  #define SortEx_Buffer_Count LUCY_SortEx_Buffer_Count
  #define SortEx_Buffer_Count_t LUCY_SortEx_Buffer_Count_t
  #define SortEx_Grow_Buffer LUCY_SortEx_Grow_Buffer
  #define SortEx_Grow_Buffer_t LUCY_SortEx_Grow_Buffer_t
  #define SortEx_Set_Mem_Thresh LUCY_SortEx_Set_Mem_Thresh
  #define SortEx_Set_Mem_Thresh_t LUCY_SortEx_Set_Mem_Thresh_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_UTIL_SORTEXTERNAL */




