/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCYX_SEARCH_PROXIMITYMATCHER
#define H_LUCYX_SEARCH_PROXIMITYMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYMATCHER
extern uint32_t lucy_ProximityMatcher_IVARS_OFFSET;
typedef struct lucy_ProximityMatcherIVARS lucy_ProximityMatcherIVARS;
static CFISH_INLINE lucy_ProximityMatcherIVARS*
lucy_ProximityMatcher_IVARS(lucy_ProximityMatcher *self) {
   char *ptr = (char*)self + lucy_ProximityMatcher_IVARS_OFFSET;
   return (lucy_ProximityMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityMatcherIVARS lucy_ProximityMatcherIVARS
  #define ProximityMatcher_IVARS lucy_ProximityMatcher_IVARS
#endif

struct lucy_ProximityMatcherIVARS {
    int32_t doc_id;
    uint32_t num_elements;
    lucy_Similarity* sim;
    lucy_PostingList** plists;
    cfish_ByteBuf* anchor_set;
    float proximity_freq;
    float proximity_boost;
    lucy_Compiler* compiler;
    float weight;
    bool first_time;
    bool more;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_ProximityMatcher*
lucy_ProximityMatcher_new(lucy_Similarity* similarity, cfish_Vector* posting_lists, lucy_Compiler* compiler, uint32_t within);

LUCY_VISIBLE lucy_ProximityMatcher*
lucy_ProximityMatcher_init(lucy_ProximityMatcher* self, lucy_Similarity* similarity, cfish_Vector* posting_lists, lucy_Compiler* compiler, uint32_t within);

void
LUCY_ProximityMatcher_Destroy_IMP(lucy_ProximityMatcher* self);

int32_t
LUCY_ProximityMatcher_Next_IMP(lucy_ProximityMatcher* self);

int32_t
LUCY_ProximityMatcher_Advance_IMP(lucy_ProximityMatcher* self, int32_t target);

int32_t
LUCY_ProximityMatcher_Get_Doc_ID_IMP(lucy_ProximityMatcher* self);

float
LUCY_ProximityMatcher_Score_IMP(lucy_ProximityMatcher* self);

float
LUCY_ProximityMatcher_Calc_Proximity_Freq_IMP(lucy_ProximityMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_ProximityMatcher_To_Host_t)(lucy_ProximityMatcher* self, void* vcache);

typedef cfish_Obj*
(*LUCY_ProximityMatcher_Clone_t)(lucy_ProximityMatcher* self);

typedef bool
(*LUCY_ProximityMatcher_Equals_t)(lucy_ProximityMatcher* self, cfish_Obj* other);

typedef int32_t
(*LUCY_ProximityMatcher_Compare_To_t)(lucy_ProximityMatcher* self, cfish_Obj* other);

typedef void
(*LUCY_ProximityMatcher_Destroy_t)(lucy_ProximityMatcher* self);

typedef cfish_String*
(*LUCY_ProximityMatcher_To_String_t)(lucy_ProximityMatcher* self);

typedef int32_t
(*LUCY_ProximityMatcher_Next_t)(lucy_ProximityMatcher* self);

typedef int32_t
(*LUCY_ProximityMatcher_Advance_t)(lucy_ProximityMatcher* self, int32_t target);

typedef int32_t
(*LUCY_ProximityMatcher_Get_Doc_ID_t)(lucy_ProximityMatcher* self);

typedef float
(*LUCY_ProximityMatcher_Score_t)(lucy_ProximityMatcher* self);

typedef void
(*LUCY_ProximityMatcher_Collect_t)(lucy_ProximityMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions);

typedef float
(*LUCY_ProximityMatcher_Calc_Proximity_Freq_t)(lucy_ProximityMatcher* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_ProximityMatcher_get_class(lucy_ProximityMatcher *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_ProximityMatcher_get_class_name(lucy_ProximityMatcher *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_ProximityMatcher_is_a(lucy_ProximityMatcher *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_ProximityMatcher_To_Host(lucy_ProximityMatcher* self, void* vcache) {
    const LUCY_ProximityMatcher_To_Host_t method = (LUCY_ProximityMatcher_To_Host_t)cfish_obj_method(self, LUCY_ProximityMatcher_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityMatcher_Clone(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Clone_t method = (LUCY_ProximityMatcher_Clone_t)cfish_obj_method(self, LUCY_ProximityMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_ProximityMatcher_Equals(lucy_ProximityMatcher* self, cfish_Obj* other) {
    const LUCY_ProximityMatcher_Equals_t method = (LUCY_ProximityMatcher_Equals_t)cfish_obj_method(self, LUCY_ProximityMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityMatcher_Compare_To(lucy_ProximityMatcher* self, cfish_Obj* other) {
    const LUCY_ProximityMatcher_Compare_To_t method = (LUCY_ProximityMatcher_Compare_To_t)cfish_obj_method(self, LUCY_ProximityMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_ProximityMatcher_Destroy(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Destroy_t method = (LUCY_ProximityMatcher_Destroy_t)cfish_obj_method(self, LUCY_ProximityMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ProximityMatcher_To_String(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_To_String_t method = (LUCY_ProximityMatcher_To_String_t)cfish_obj_method(self, LUCY_ProximityMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityMatcher_Next(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Next_t method = (LUCY_ProximityMatcher_Next_t)cfish_obj_method(self, LUCY_ProximityMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityMatcher_Advance(lucy_ProximityMatcher* self, int32_t target) {
    const LUCY_ProximityMatcher_Advance_t method = (LUCY_ProximityMatcher_Advance_t)cfish_obj_method(self, LUCY_ProximityMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityMatcher_Get_Doc_ID(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Get_Doc_ID_t method = (LUCY_ProximityMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_ProximityMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_ProximityMatcher_Score(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Score_t method = (LUCY_ProximityMatcher_Score_t)cfish_obj_method(self, LUCY_ProximityMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_ProximityMatcher_Collect(lucy_ProximityMatcher* self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_ProximityMatcher_Collect_t method = (LUCY_ProximityMatcher_Collect_t)cfish_obj_method(self, LUCY_ProximityMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityMatcher_Calc_Proximity_Freq_OFFSET;
static CFISH_INLINE float
LUCY_ProximityMatcher_Calc_Proximity_Freq(lucy_ProximityMatcher* self) {
    const LUCY_ProximityMatcher_Calc_Proximity_Freq_t method = (LUCY_ProximityMatcher_Calc_Proximity_Freq_t)cfish_obj_method(self, LUCY_ProximityMatcher_Calc_Proximity_Freq_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_ProximityMatcher_Calc_Proximity_Freq_OVERRIDE NULL
#else
float
Lucy_ProximityMatcher_Calc_Proximity_Freq_OVERRIDE(lucy_ProximityMatcher* self);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityMatcher lucy_ProximityMatcher
  #define PROXIMITYMATCHER LUCY_PROXIMITYMATCHER
  #define ProximityMatcher_new lucy_ProximityMatcher_new
  #define ProximityMatcher_init lucy_ProximityMatcher_init
  #define ProximityMatcher_get_class lucy_ProximityMatcher_get_class
  #define ProximityMatcher_get_class_name lucy_ProximityMatcher_get_class_name
  #define ProximityMatcher_is_a lucy_ProximityMatcher_is_a
  #define ProximityMatcher_Destroy_IMP LUCY_ProximityMatcher_Destroy_IMP
  #define ProximityMatcher_Next_IMP LUCY_ProximityMatcher_Next_IMP
  #define ProximityMatcher_Advance_IMP LUCY_ProximityMatcher_Advance_IMP
  #define ProximityMatcher_Get_Doc_ID_IMP LUCY_ProximityMatcher_Get_Doc_ID_IMP
  #define ProximityMatcher_Score_IMP LUCY_ProximityMatcher_Score_IMP
  #define ProximityMatcher_Calc_Proximity_Freq_IMP LUCY_ProximityMatcher_Calc_Proximity_Freq_IMP
  #define ProximityMatcher_To_Host LUCY_ProximityMatcher_To_Host
  #define ProximityMatcher_To_Host_t LUCY_ProximityMatcher_To_Host_t
  #define ProximityMatcher_Clone LUCY_ProximityMatcher_Clone
  #define ProximityMatcher_Clone_t LUCY_ProximityMatcher_Clone_t
  #define ProximityMatcher_Equals LUCY_ProximityMatcher_Equals
  #define ProximityMatcher_Equals_t LUCY_ProximityMatcher_Equals_t
  #define ProximityMatcher_Compare_To LUCY_ProximityMatcher_Compare_To
  #define ProximityMatcher_Compare_To_t LUCY_ProximityMatcher_Compare_To_t
  #define ProximityMatcher_Destroy LUCY_ProximityMatcher_Destroy
  #define ProximityMatcher_Destroy_t LUCY_ProximityMatcher_Destroy_t
  #define ProximityMatcher_To_String LUCY_ProximityMatcher_To_String
  #define ProximityMatcher_To_String_t LUCY_ProximityMatcher_To_String_t
  #define ProximityMatcher_Next LUCY_ProximityMatcher_Next
  #define ProximityMatcher_Next_t LUCY_ProximityMatcher_Next_t
  #define ProximityMatcher_Advance LUCY_ProximityMatcher_Advance
  #define ProximityMatcher_Advance_t LUCY_ProximityMatcher_Advance_t
  #define ProximityMatcher_Get_Doc_ID LUCY_ProximityMatcher_Get_Doc_ID
  #define ProximityMatcher_Get_Doc_ID_t LUCY_ProximityMatcher_Get_Doc_ID_t
  #define ProximityMatcher_Score LUCY_ProximityMatcher_Score
  #define ProximityMatcher_Score_t LUCY_ProximityMatcher_Score_t
  #define ProximityMatcher_Collect LUCY_ProximityMatcher_Collect
  #define ProximityMatcher_Collect_t LUCY_ProximityMatcher_Collect_t
  #define ProximityMatcher_Calc_Proximity_Freq LUCY_ProximityMatcher_Calc_Proximity_Freq
  #define ProximityMatcher_Calc_Proximity_Freq_t LUCY_ProximityMatcher_Calc_Proximity_Freq_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCYX_SEARCH_PROXIMITYMATCHER */




