/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef H_LUCYX_SEARCH_PROXIMITYQUERY
#define H_LUCYX_SEARCH_PROXIMITYQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYQUERY
extern uint32_t lucy_ProximityQuery_IVARS_OFFSET;
typedef struct lucy_ProximityQueryIVARS lucy_ProximityQueryIVARS;
static CFISH_INLINE lucy_ProximityQueryIVARS*
lucy_ProximityQuery_IVARS(lucy_ProximityQuery *self) {
   char *ptr = (char*)self + lucy_ProximityQuery_IVARS_OFFSET;
   return (lucy_ProximityQueryIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityQueryIVARS lucy_ProximityQueryIVARS
  #define ProximityQuery_IVARS lucy_ProximityQuery_IVARS
#endif

struct lucy_ProximityQueryIVARS {
    float boost;
    cfish_String* field;
    cfish_Vector* terms;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_ProximityQuery*
lucy_ProximityQuery_new(cfish_String* field, cfish_Vector* terms, uint32_t within);

LUCY_VISIBLE lucy_ProximityQuery*
lucy_ProximityQuery_init(lucy_ProximityQuery* self, cfish_String* field, cfish_Vector* terms, uint32_t within);

cfish_String*
LUCY_ProximityQuery_Get_Field_IMP(lucy_ProximityQuery* self);

cfish_Vector*
LUCY_ProximityQuery_Get_Terms_IMP(lucy_ProximityQuery* self);

uint32_t
LUCY_ProximityQuery_Get_Within_IMP(lucy_ProximityQuery* self);

lucy_Compiler*
LUCY_ProximityQuery_Make_Compiler_IMP(lucy_ProximityQuery* self, lucy_Searcher* searcher, float boost, bool subordinate);

bool
LUCY_ProximityQuery_Equals_IMP(lucy_ProximityQuery* self, cfish_Obj* other);

cfish_String*
LUCY_ProximityQuery_To_String_IMP(lucy_ProximityQuery* self);

void
LUCY_ProximityQuery_Serialize_IMP(lucy_ProximityQuery* self, lucy_OutStream* outstream);

lucy_ProximityQuery*
LUCY_ProximityQuery_Deserialize_IMP(lucy_ProximityQuery* self, lucy_InStream* instream);

cfish_Obj*
LUCY_ProximityQuery_Dump_IMP(lucy_ProximityQuery* self);

cfish_Obj*
LUCY_ProximityQuery_Load_IMP(lucy_ProximityQuery* self, cfish_Obj* dump);

void
LUCY_ProximityQuery_Destroy_IMP(lucy_ProximityQuery* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_ProximityQuery_To_Host_t)(lucy_ProximityQuery* self, void* vcache);

typedef cfish_Obj*
(*LUCY_ProximityQuery_Clone_t)(lucy_ProximityQuery* self);

typedef bool
(*LUCY_ProximityQuery_Equals_t)(lucy_ProximityQuery* self, cfish_Obj* other);

typedef int32_t
(*LUCY_ProximityQuery_Compare_To_t)(lucy_ProximityQuery* self, cfish_Obj* other);

typedef void
(*LUCY_ProximityQuery_Destroy_t)(lucy_ProximityQuery* self);

typedef cfish_String*
(*LUCY_ProximityQuery_To_String_t)(lucy_ProximityQuery* self);

typedef lucy_Compiler*
(*LUCY_ProximityQuery_Make_Compiler_t)(lucy_ProximityQuery* self, lucy_Searcher* searcher, float boost, bool subordinate);

typedef void
(*LUCY_ProximityQuery_Set_Boost_t)(lucy_ProximityQuery* self, float boost);

typedef float
(*LUCY_ProximityQuery_Get_Boost_t)(lucy_ProximityQuery* self);

typedef void
(*LUCY_ProximityQuery_Serialize_t)(lucy_ProximityQuery* self, lucy_OutStream* outstream);

typedef lucy_ProximityQuery*
(*LUCY_ProximityQuery_Deserialize_t)(lucy_ProximityQuery* self, lucy_InStream* instream);

typedef cfish_Obj*
(*LUCY_ProximityQuery_Dump_t)(lucy_ProximityQuery* self);

typedef cfish_Obj*
(*LUCY_ProximityQuery_Load_t)(lucy_ProximityQuery* self, cfish_Obj* dump);

typedef cfish_String*
(*LUCY_ProximityQuery_Get_Field_t)(lucy_ProximityQuery* self);

typedef cfish_Vector*
(*LUCY_ProximityQuery_Get_Terms_t)(lucy_ProximityQuery* self);

typedef uint32_t
(*LUCY_ProximityQuery_Get_Within_t)(lucy_ProximityQuery* self);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_ProximityQuery_get_class(lucy_ProximityQuery *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_ProximityQuery_get_class_name(lucy_ProximityQuery *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_ProximityQuery_is_a(lucy_ProximityQuery *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_ProximityQuery_To_Host(lucy_ProximityQuery* self, void* vcache) {
    const LUCY_ProximityQuery_To_Host_t method = (LUCY_ProximityQuery_To_Host_t)cfish_obj_method(self, LUCY_ProximityQuery_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityQuery_Clone(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Clone_t method = (LUCY_ProximityQuery_Clone_t)cfish_obj_method(self, LUCY_ProximityQuery_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_ProximityQuery_Equals(lucy_ProximityQuery* self, cfish_Obj* other) {
    const LUCY_ProximityQuery_Equals_t method = (LUCY_ProximityQuery_Equals_t)cfish_obj_method(self, LUCY_ProximityQuery_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityQuery_Compare_To(lucy_ProximityQuery* self, cfish_Obj* other) {
    const LUCY_ProximityQuery_Compare_To_t method = (LUCY_ProximityQuery_Compare_To_t)cfish_obj_method(self, LUCY_ProximityQuery_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_ProximityQuery_Destroy(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Destroy_t method = (LUCY_ProximityQuery_Destroy_t)cfish_obj_method(self, LUCY_ProximityQuery_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ProximityQuery_To_String(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_To_String_t method = (LUCY_ProximityQuery_To_String_t)cfish_obj_method(self, LUCY_ProximityQuery_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Make_Compiler_OFFSET;
static CFISH_INLINE lucy_Compiler*
LUCY_ProximityQuery_Make_Compiler(lucy_ProximityQuery* self, lucy_Searcher* searcher, float boost, bool subordinate) {
    const LUCY_ProximityQuery_Make_Compiler_t method = (LUCY_ProximityQuery_Make_Compiler_t)cfish_obj_method(self, LUCY_ProximityQuery_Make_Compiler_OFFSET);
    return method(self, searcher, boost, subordinate);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Set_Boost_OFFSET;
static CFISH_INLINE void
LUCY_ProximityQuery_Set_Boost(lucy_ProximityQuery* self, float boost) {
    const LUCY_ProximityQuery_Set_Boost_t method = (LUCY_ProximityQuery_Set_Boost_t)cfish_obj_method(self, LUCY_ProximityQuery_Set_Boost_OFFSET);
    method(self, boost);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Get_Boost_OFFSET;
static CFISH_INLINE float
LUCY_ProximityQuery_Get_Boost(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Get_Boost_t method = (LUCY_ProximityQuery_Get_Boost_t)cfish_obj_method(self, LUCY_ProximityQuery_Get_Boost_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Serialize_OFFSET;
static CFISH_INLINE void
LUCY_ProximityQuery_Serialize(lucy_ProximityQuery* self, lucy_OutStream* outstream) {
    const LUCY_ProximityQuery_Serialize_t method = (LUCY_ProximityQuery_Serialize_t)cfish_obj_method(self, LUCY_ProximityQuery_Serialize_OFFSET);
    method(self, outstream);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Deserialize_OFFSET;
static CFISH_INLINE lucy_ProximityQuery*
LUCY_ProximityQuery_Deserialize(lucy_ProximityQuery* self, lucy_InStream* instream) {
    const LUCY_ProximityQuery_Deserialize_t method = (LUCY_ProximityQuery_Deserialize_t)cfish_obj_method(self, LUCY_ProximityQuery_Deserialize_OFFSET);
    return method(self, instream);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Dump_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityQuery_Dump(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Dump_t method = (LUCY_ProximityQuery_Dump_t)cfish_obj_method(self, LUCY_ProximityQuery_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Load_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityQuery_Load(lucy_ProximityQuery* self, cfish_Obj* dump) {
    const LUCY_ProximityQuery_Load_t method = (LUCY_ProximityQuery_Load_t)cfish_obj_method(self, LUCY_ProximityQuery_Load_OFFSET);
    return method(self, dump);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Get_Field_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ProximityQuery_Get_Field(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Get_Field_t method = (LUCY_ProximityQuery_Get_Field_t)cfish_obj_method(self, LUCY_ProximityQuery_Get_Field_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Get_Terms_OFFSET;
static CFISH_INLINE cfish_Vector*
LUCY_ProximityQuery_Get_Terms(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Get_Terms_t method = (LUCY_ProximityQuery_Get_Terms_t)cfish_obj_method(self, LUCY_ProximityQuery_Get_Terms_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityQuery_Get_Within_OFFSET;
static CFISH_INLINE uint32_t
LUCY_ProximityQuery_Get_Within(lucy_ProximityQuery* self) {
    const LUCY_ProximityQuery_Get_Within_t method = (LUCY_ProximityQuery_Get_Within_t)cfish_obj_method(self, LUCY_ProximityQuery_Get_Within_OFFSET);
    return method(self);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#define Lucy_ProximityQuery_Get_Field_OVERRIDE NULL
#define Lucy_ProximityQuery_Get_Terms_OVERRIDE NULL
#define Lucy_ProximityQuery_Get_Within_OVERRIDE NULL
#else
cfish_String*
Lucy_ProximityQuery_Get_Field_OVERRIDE(lucy_ProximityQuery* self);
cfish_Vector*
Lucy_ProximityQuery_Get_Terms_OVERRIDE(lucy_ProximityQuery* self);
uint32_t
Lucy_ProximityQuery_Get_Within_OVERRIDE(lucy_ProximityQuery* self);
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityQuery lucy_ProximityQuery
  #define PROXIMITYQUERY LUCY_PROXIMITYQUERY
  #define ProximityQuery_new lucy_ProximityQuery_new
  #define ProximityQuery_init lucy_ProximityQuery_init
  #define ProximityQuery_get_class lucy_ProximityQuery_get_class
  #define ProximityQuery_get_class_name lucy_ProximityQuery_get_class_name
  #define ProximityQuery_is_a lucy_ProximityQuery_is_a
  #define ProximityQuery_Get_Field_IMP LUCY_ProximityQuery_Get_Field_IMP
  #define ProximityQuery_Get_Terms_IMP LUCY_ProximityQuery_Get_Terms_IMP
  #define ProximityQuery_Get_Within_IMP LUCY_ProximityQuery_Get_Within_IMP
  #define ProximityQuery_Make_Compiler_IMP LUCY_ProximityQuery_Make_Compiler_IMP
  #define ProximityQuery_Equals_IMP LUCY_ProximityQuery_Equals_IMP
  #define ProximityQuery_To_String_IMP LUCY_ProximityQuery_To_String_IMP
  #define ProximityQuery_Serialize_IMP LUCY_ProximityQuery_Serialize_IMP
  #define ProximityQuery_Deserialize_IMP LUCY_ProximityQuery_Deserialize_IMP
  #define ProximityQuery_Dump_IMP LUCY_ProximityQuery_Dump_IMP
  #define ProximityQuery_Load_IMP LUCY_ProximityQuery_Load_IMP
  #define ProximityQuery_Destroy_IMP LUCY_ProximityQuery_Destroy_IMP
  #define ProximityQuery_To_Host LUCY_ProximityQuery_To_Host
  #define ProximityQuery_To_Host_t LUCY_ProximityQuery_To_Host_t
  #define ProximityQuery_Clone LUCY_ProximityQuery_Clone
  #define ProximityQuery_Clone_t LUCY_ProximityQuery_Clone_t
  #define ProximityQuery_Equals LUCY_ProximityQuery_Equals
  #define ProximityQuery_Equals_t LUCY_ProximityQuery_Equals_t
  #define ProximityQuery_Compare_To LUCY_ProximityQuery_Compare_To
  #define ProximityQuery_Compare_To_t LUCY_ProximityQuery_Compare_To_t
  #define ProximityQuery_Destroy LUCY_ProximityQuery_Destroy
  #define ProximityQuery_Destroy_t LUCY_ProximityQuery_Destroy_t
  #define ProximityQuery_To_String LUCY_ProximityQuery_To_String
  #define ProximityQuery_To_String_t LUCY_ProximityQuery_To_String_t
  #define ProximityQuery_Make_Compiler LUCY_ProximityQuery_Make_Compiler
  #define ProximityQuery_Make_Compiler_t LUCY_ProximityQuery_Make_Compiler_t
  #define ProximityQuery_Set_Boost LUCY_ProximityQuery_Set_Boost
  #define ProximityQuery_Set_Boost_t LUCY_ProximityQuery_Set_Boost_t
  #define ProximityQuery_Get_Boost LUCY_ProximityQuery_Get_Boost
  #define ProximityQuery_Get_Boost_t LUCY_ProximityQuery_Get_Boost_t
  #define ProximityQuery_Serialize LUCY_ProximityQuery_Serialize
  #define ProximityQuery_Serialize_t LUCY_ProximityQuery_Serialize_t
  #define ProximityQuery_Deserialize LUCY_ProximityQuery_Deserialize
  #define ProximityQuery_Deserialize_t LUCY_ProximityQuery_Deserialize_t
  #define ProximityQuery_Dump LUCY_ProximityQuery_Dump
  #define ProximityQuery_Dump_t LUCY_ProximityQuery_Dump_t
  #define ProximityQuery_Load LUCY_ProximityQuery_Load
  #define ProximityQuery_Load_t LUCY_ProximityQuery_Load_t
  #define ProximityQuery_Get_Field LUCY_ProximityQuery_Get_Field
  #define ProximityQuery_Get_Field_t LUCY_ProximityQuery_Get_Field_t
  #define ProximityQuery_Get_Terms LUCY_ProximityQuery_Get_Terms
  #define ProximityQuery_Get_Terms_t LUCY_ProximityQuery_Get_Terms_t
  #define ProximityQuery_Get_Within LUCY_ProximityQuery_Get_Within
  #define ProximityQuery_Get_Within_t LUCY_ProximityQuery_Get_Within_t
#endif /* LUCY_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYCOMPILER
extern uint32_t lucy_ProximityCompiler_IVARS_OFFSET;
typedef struct lucy_ProximityCompilerIVARS lucy_ProximityCompilerIVARS;
static CFISH_INLINE lucy_ProximityCompilerIVARS*
lucy_ProximityCompiler_IVARS(lucy_ProximityCompiler *self) {
   char *ptr = (char*)self + lucy_ProximityCompiler_IVARS_OFFSET;
   return (lucy_ProximityCompilerIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityCompilerIVARS lucy_ProximityCompilerIVARS
  #define ProximityCompiler_IVARS lucy_ProximityCompiler_IVARS
#endif

struct lucy_ProximityCompilerIVARS {
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
    float idf;
    float raw_weight;
    float query_norm_factor;
    float normalized_weight;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYCOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_ProximityCompiler*
lucy_ProximityCompiler_new(lucy_ProximityQuery* parent, lucy_Searcher* searcher, float boost, uint32_t within);

LUCY_VISIBLE lucy_ProximityCompiler*
lucy_ProximityCompiler_init(lucy_ProximityCompiler* self, lucy_ProximityQuery* parent, lucy_Searcher* searcher, float boost, uint32_t within);

lucy_Matcher*
LUCY_ProximityCompiler_Make_Matcher_IMP(lucy_ProximityCompiler* self, lucy_SegReader* reader, bool need_score);

float
LUCY_ProximityCompiler_Get_Weight_IMP(lucy_ProximityCompiler* self);

float
LUCY_ProximityCompiler_Sum_Of_Squared_Weights_IMP(lucy_ProximityCompiler* self);

void
LUCY_ProximityCompiler_Apply_Norm_Factor_IMP(lucy_ProximityCompiler* self, float factor);

cfish_Vector*
LUCY_ProximityCompiler_Highlight_Spans_IMP(lucy_ProximityCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, cfish_String* field);

bool
LUCY_ProximityCompiler_Equals_IMP(lucy_ProximityCompiler* self, cfish_Obj* other);

void
LUCY_ProximityCompiler_Serialize_IMP(lucy_ProximityCompiler* self, lucy_OutStream* outstream);

lucy_ProximityCompiler*
LUCY_ProximityCompiler_Deserialize_IMP(lucy_ProximityCompiler* self, lucy_InStream* instream);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void*
(*LUCY_ProximityCompiler_To_Host_t)(lucy_ProximityCompiler* self, void* vcache);

typedef cfish_Obj*
(*LUCY_ProximityCompiler_Clone_t)(lucy_ProximityCompiler* self);

typedef bool
(*LUCY_ProximityCompiler_Equals_t)(lucy_ProximityCompiler* self, cfish_Obj* other);

typedef int32_t
(*LUCY_ProximityCompiler_Compare_To_t)(lucy_ProximityCompiler* self, cfish_Obj* other);

typedef void
(*LUCY_ProximityCompiler_Destroy_t)(lucy_ProximityCompiler* self);

typedef cfish_String*
(*LUCY_ProximityCompiler_To_String_t)(lucy_ProximityCompiler* self);

typedef lucy_Compiler*
(*LUCY_ProximityCompiler_Make_Compiler_t)(lucy_ProximityCompiler* self, lucy_Searcher* searcher, float boost, bool subordinate);

typedef void
(*LUCY_ProximityCompiler_Set_Boost_t)(lucy_ProximityCompiler* self, float boost);

typedef float
(*LUCY_ProximityCompiler_Get_Boost_t)(lucy_ProximityCompiler* self);

typedef void
(*LUCY_ProximityCompiler_Serialize_t)(lucy_ProximityCompiler* self, lucy_OutStream* outstream);

typedef lucy_ProximityCompiler*
(*LUCY_ProximityCompiler_Deserialize_t)(lucy_ProximityCompiler* self, lucy_InStream* instream);

typedef cfish_Obj*
(*LUCY_ProximityCompiler_Dump_t)(lucy_ProximityCompiler* self);

typedef cfish_Obj*
(*LUCY_ProximityCompiler_Load_t)(lucy_ProximityCompiler* self, cfish_Obj* dump);

typedef lucy_Matcher*
(*LUCY_ProximityCompiler_Make_Matcher_t)(lucy_ProximityCompiler* self, lucy_SegReader* reader, bool need_score);

typedef float
(*LUCY_ProximityCompiler_Get_Weight_t)(lucy_ProximityCompiler* self);

typedef lucy_Similarity*
(*LUCY_ProximityCompiler_Get_Similarity_t)(lucy_ProximityCompiler* self);

typedef lucy_Query*
(*LUCY_ProximityCompiler_Get_Parent_t)(lucy_ProximityCompiler* self);

typedef float
(*LUCY_ProximityCompiler_Sum_Of_Squared_Weights_t)(lucy_ProximityCompiler* self);

typedef void
(*LUCY_ProximityCompiler_Apply_Norm_Factor_t)(lucy_ProximityCompiler* self, float factor);

typedef void
(*LUCY_ProximityCompiler_Normalize_t)(lucy_ProximityCompiler* self);

typedef cfish_Vector*
(*LUCY_ProximityCompiler_Highlight_Spans_t)(lucy_ProximityCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, cfish_String* field);



/* Define type-safe wrappers for inert functions of Obj.
 */

static CFISH_INLINE cfish_Class*
lucy_ProximityCompiler_get_class(lucy_ProximityCompiler *self) {
    return cfish_Obj_get_class((cfish_Obj*)self);
}

static CFISH_INLINE cfish_String*
lucy_ProximityCompiler_get_class_name(lucy_ProximityCompiler *self) {
    return cfish_Obj_get_class_name((cfish_Obj*)self);
}

static CFISH_INLINE bool
lucy_ProximityCompiler_is_a(lucy_ProximityCompiler *self, cfish_Class *ancestor) {
    return cfish_Obj_is_a((cfish_Obj*)self, ancestor);
}


/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_ProximityCompiler_To_Host(lucy_ProximityCompiler* self, void* vcache) {
    const LUCY_ProximityCompiler_To_Host_t method = (LUCY_ProximityCompiler_To_Host_t)cfish_obj_method(self, LUCY_ProximityCompiler_To_Host_OFFSET);
    return method(self, vcache);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityCompiler_Clone(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Clone_t method = (LUCY_ProximityCompiler_Clone_t)cfish_obj_method(self, LUCY_ProximityCompiler_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_ProximityCompiler_Equals(lucy_ProximityCompiler* self, cfish_Obj* other) {
    const LUCY_ProximityCompiler_Equals_t method = (LUCY_ProximityCompiler_Equals_t)cfish_obj_method(self, LUCY_ProximityCompiler_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_ProximityCompiler_Compare_To(lucy_ProximityCompiler* self, cfish_Obj* other) {
    const LUCY_ProximityCompiler_Compare_To_t method = (LUCY_ProximityCompiler_Compare_To_t)cfish_obj_method(self, LUCY_ProximityCompiler_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_ProximityCompiler_Destroy(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Destroy_t method = (LUCY_ProximityCompiler_Destroy_t)cfish_obj_method(self, LUCY_ProximityCompiler_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ProximityCompiler_To_String(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_To_String_t method = (LUCY_ProximityCompiler_To_String_t)cfish_obj_method(self, LUCY_ProximityCompiler_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Make_Compiler_OFFSET;
static CFISH_INLINE lucy_Compiler*
LUCY_ProximityCompiler_Make_Compiler(lucy_ProximityCompiler* self, lucy_Searcher* searcher, float boost, bool subordinate) {
    const LUCY_ProximityCompiler_Make_Compiler_t method = (LUCY_ProximityCompiler_Make_Compiler_t)cfish_obj_method(self, LUCY_ProximityCompiler_Make_Compiler_OFFSET);
    return method(self, searcher, boost, subordinate);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Set_Boost_OFFSET;
static CFISH_INLINE void
LUCY_ProximityCompiler_Set_Boost(lucy_ProximityCompiler* self, float boost) {
    const LUCY_ProximityCompiler_Set_Boost_t method = (LUCY_ProximityCompiler_Set_Boost_t)cfish_obj_method(self, LUCY_ProximityCompiler_Set_Boost_OFFSET);
    method(self, boost);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Get_Boost_OFFSET;
static CFISH_INLINE float
LUCY_ProximityCompiler_Get_Boost(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Get_Boost_t method = (LUCY_ProximityCompiler_Get_Boost_t)cfish_obj_method(self, LUCY_ProximityCompiler_Get_Boost_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Serialize_OFFSET;
static CFISH_INLINE void
LUCY_ProximityCompiler_Serialize(lucy_ProximityCompiler* self, lucy_OutStream* outstream) {
    const LUCY_ProximityCompiler_Serialize_t method = (LUCY_ProximityCompiler_Serialize_t)cfish_obj_method(self, LUCY_ProximityCompiler_Serialize_OFFSET);
    method(self, outstream);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Deserialize_OFFSET;
static CFISH_INLINE lucy_ProximityCompiler*
LUCY_ProximityCompiler_Deserialize(lucy_ProximityCompiler* self, lucy_InStream* instream) {
    const LUCY_ProximityCompiler_Deserialize_t method = (LUCY_ProximityCompiler_Deserialize_t)cfish_obj_method(self, LUCY_ProximityCompiler_Deserialize_OFFSET);
    return method(self, instream);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Dump_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityCompiler_Dump(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Dump_t method = (LUCY_ProximityCompiler_Dump_t)cfish_obj_method(self, LUCY_ProximityCompiler_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Load_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ProximityCompiler_Load(lucy_ProximityCompiler* self, cfish_Obj* dump) {
    const LUCY_ProximityCompiler_Load_t method = (LUCY_ProximityCompiler_Load_t)cfish_obj_method(self, LUCY_ProximityCompiler_Load_OFFSET);
    return method(self, dump);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Make_Matcher_OFFSET;
static CFISH_INLINE lucy_Matcher*
LUCY_ProximityCompiler_Make_Matcher(lucy_ProximityCompiler* self, lucy_SegReader* reader, bool need_score) {
    const LUCY_ProximityCompiler_Make_Matcher_t method = (LUCY_ProximityCompiler_Make_Matcher_t)cfish_obj_method(self, LUCY_ProximityCompiler_Make_Matcher_OFFSET);
    return method(self, reader, need_score);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Get_Weight_OFFSET;
static CFISH_INLINE float
LUCY_ProximityCompiler_Get_Weight(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Get_Weight_t method = (LUCY_ProximityCompiler_Get_Weight_t)cfish_obj_method(self, LUCY_ProximityCompiler_Get_Weight_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Get_Similarity_OFFSET;
static CFISH_INLINE lucy_Similarity*
LUCY_ProximityCompiler_Get_Similarity(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Get_Similarity_t method = (LUCY_ProximityCompiler_Get_Similarity_t)cfish_obj_method(self, LUCY_ProximityCompiler_Get_Similarity_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Get_Parent_OFFSET;
static CFISH_INLINE lucy_Query*
LUCY_ProximityCompiler_Get_Parent(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Get_Parent_t method = (LUCY_ProximityCompiler_Get_Parent_t)cfish_obj_method(self, LUCY_ProximityCompiler_Get_Parent_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Sum_Of_Squared_Weights_OFFSET;
static CFISH_INLINE float
LUCY_ProximityCompiler_Sum_Of_Squared_Weights(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Sum_Of_Squared_Weights_t method = (LUCY_ProximityCompiler_Sum_Of_Squared_Weights_t)cfish_obj_method(self, LUCY_ProximityCompiler_Sum_Of_Squared_Weights_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Apply_Norm_Factor_OFFSET;
static CFISH_INLINE void
LUCY_ProximityCompiler_Apply_Norm_Factor(lucy_ProximityCompiler* self, float factor) {
    const LUCY_ProximityCompiler_Apply_Norm_Factor_t method = (LUCY_ProximityCompiler_Apply_Norm_Factor_t)cfish_obj_method(self, LUCY_ProximityCompiler_Apply_Norm_Factor_OFFSET);
    method(self, factor);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Normalize_OFFSET;
static CFISH_INLINE void
LUCY_ProximityCompiler_Normalize(lucy_ProximityCompiler* self) {
    const LUCY_ProximityCompiler_Normalize_t method = (LUCY_ProximityCompiler_Normalize_t)cfish_obj_method(self, LUCY_ProximityCompiler_Normalize_OFFSET);
    method(self);
}

extern LUCY_VISIBLE uint32_t LUCY_ProximityCompiler_Highlight_Spans_OFFSET;
static CFISH_INLINE cfish_Vector*
LUCY_ProximityCompiler_Highlight_Spans(lucy_ProximityCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, cfish_String* field) {
    const LUCY_ProximityCompiler_Highlight_Spans_t method = (LUCY_ProximityCompiler_Highlight_Spans_t)cfish_obj_method(self, LUCY_ProximityCompiler_Highlight_Spans_OFFSET);
    return method(self, searcher, doc_vec, field);
}



/* Declare callbacks for wrapping host overrides.
 */

#ifdef CFISH_NO_DYNAMIC_OVERRIDES
#else
#endif


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityCompiler lucy_ProximityCompiler
  #define PROXIMITYCOMPILER LUCY_PROXIMITYCOMPILER
  #define ProximityCompiler_new lucy_ProximityCompiler_new
  #define ProximityCompiler_init lucy_ProximityCompiler_init
  #define ProximityCompiler_get_class lucy_ProximityCompiler_get_class
  #define ProximityCompiler_get_class_name lucy_ProximityCompiler_get_class_name
  #define ProximityCompiler_is_a lucy_ProximityCompiler_is_a
  #define ProximityCompiler_Make_Matcher_IMP LUCY_ProximityCompiler_Make_Matcher_IMP
  #define ProximityCompiler_Get_Weight_IMP LUCY_ProximityCompiler_Get_Weight_IMP
  #define ProximityCompiler_Sum_Of_Squared_Weights_IMP LUCY_ProximityCompiler_Sum_Of_Squared_Weights_IMP
  #define ProximityCompiler_Apply_Norm_Factor_IMP LUCY_ProximityCompiler_Apply_Norm_Factor_IMP
  #define ProximityCompiler_Highlight_Spans_IMP LUCY_ProximityCompiler_Highlight_Spans_IMP
  #define ProximityCompiler_Equals_IMP LUCY_ProximityCompiler_Equals_IMP
  #define ProximityCompiler_Serialize_IMP LUCY_ProximityCompiler_Serialize_IMP
  #define ProximityCompiler_Deserialize_IMP LUCY_ProximityCompiler_Deserialize_IMP
  #define ProximityCompiler_To_Host LUCY_ProximityCompiler_To_Host
  #define ProximityCompiler_To_Host_t LUCY_ProximityCompiler_To_Host_t
  #define ProximityCompiler_Clone LUCY_ProximityCompiler_Clone
  #define ProximityCompiler_Clone_t LUCY_ProximityCompiler_Clone_t
  #define ProximityCompiler_Equals LUCY_ProximityCompiler_Equals
  #define ProximityCompiler_Equals_t LUCY_ProximityCompiler_Equals_t
  #define ProximityCompiler_Compare_To LUCY_ProximityCompiler_Compare_To
  #define ProximityCompiler_Compare_To_t LUCY_ProximityCompiler_Compare_To_t
  #define ProximityCompiler_Destroy LUCY_ProximityCompiler_Destroy
  #define ProximityCompiler_Destroy_t LUCY_ProximityCompiler_Destroy_t
  #define ProximityCompiler_To_String LUCY_ProximityCompiler_To_String
  #define ProximityCompiler_To_String_t LUCY_ProximityCompiler_To_String_t
  #define ProximityCompiler_Make_Compiler LUCY_ProximityCompiler_Make_Compiler
  #define ProximityCompiler_Make_Compiler_t LUCY_ProximityCompiler_Make_Compiler_t
  #define ProximityCompiler_Set_Boost LUCY_ProximityCompiler_Set_Boost
  #define ProximityCompiler_Set_Boost_t LUCY_ProximityCompiler_Set_Boost_t
  #define ProximityCompiler_Get_Boost LUCY_ProximityCompiler_Get_Boost
  #define ProximityCompiler_Get_Boost_t LUCY_ProximityCompiler_Get_Boost_t
  #define ProximityCompiler_Serialize LUCY_ProximityCompiler_Serialize
  #define ProximityCompiler_Serialize_t LUCY_ProximityCompiler_Serialize_t
  #define ProximityCompiler_Deserialize LUCY_ProximityCompiler_Deserialize
  #define ProximityCompiler_Deserialize_t LUCY_ProximityCompiler_Deserialize_t
  #define ProximityCompiler_Dump LUCY_ProximityCompiler_Dump
  #define ProximityCompiler_Dump_t LUCY_ProximityCompiler_Dump_t
  #define ProximityCompiler_Load LUCY_ProximityCompiler_Load
  #define ProximityCompiler_Load_t LUCY_ProximityCompiler_Load_t
  #define ProximityCompiler_Make_Matcher LUCY_ProximityCompiler_Make_Matcher
  #define ProximityCompiler_Make_Matcher_t LUCY_ProximityCompiler_Make_Matcher_t
  #define ProximityCompiler_Get_Weight LUCY_ProximityCompiler_Get_Weight
  #define ProximityCompiler_Get_Weight_t LUCY_ProximityCompiler_Get_Weight_t
  #define ProximityCompiler_Get_Similarity LUCY_ProximityCompiler_Get_Similarity
  #define ProximityCompiler_Get_Similarity_t LUCY_ProximityCompiler_Get_Similarity_t
  #define ProximityCompiler_Get_Parent LUCY_ProximityCompiler_Get_Parent
  #define ProximityCompiler_Get_Parent_t LUCY_ProximityCompiler_Get_Parent_t
  #define ProximityCompiler_Sum_Of_Squared_Weights LUCY_ProximityCompiler_Sum_Of_Squared_Weights
  #define ProximityCompiler_Sum_Of_Squared_Weights_t LUCY_ProximityCompiler_Sum_Of_Squared_Weights_t
  #define ProximityCompiler_Apply_Norm_Factor LUCY_ProximityCompiler_Apply_Norm_Factor
  #define ProximityCompiler_Apply_Norm_Factor_t LUCY_ProximityCompiler_Apply_Norm_Factor_t
  #define ProximityCompiler_Normalize LUCY_ProximityCompiler_Normalize
  #define ProximityCompiler_Normalize_t LUCY_ProximityCompiler_Normalize_t
  #define ProximityCompiler_Highlight_Spans LUCY_ProximityCompiler_Highlight_Spans
  #define ProximityCompiler_Highlight_Spans_t LUCY_ProximityCompiler_Highlight_Spans_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCYX_SEARCH_PROXIMITYQUERY */




